/*
 * THIS FILE WAS AUTOMATICALLY GENERATED, DO NOT EDIT.
 *
 * Copyright (C) 2017 Apple Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "config.h"
#include "WebPreferences.h"

#include "WebPreferencesKeys.h"

namespace WebKit {

void WebPreferences::setAccessibilityObjectModelEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::accessibilityObjectModelEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::accessibilityObjectModelEnabledKey(), value);
}

bool WebPreferences::accessibilityObjectModelEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::accessibilityObjectModelEnabledKey());
}

void WebPreferences::setBlankAnchorTargetImpliesNoOpenerEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::blankAnchorTargetImpliesNoOpenerEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::blankAnchorTargetImpliesNoOpenerEnabledKey(), value);
}

bool WebPreferences::blankAnchorTargetImpliesNoOpenerEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::blankAnchorTargetImpliesNoOpenerEnabledKey());
}

void WebPreferences::setCSSCustomPropertiesAndValuesEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::cssCustomPropertiesAndValuesEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::cssCustomPropertiesAndValuesEnabledKey(), value);
}

bool WebPreferences::cssCustomPropertiesAndValuesEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::cssCustomPropertiesAndValuesEnabledKey());
}

void WebPreferences::setCSSOMViewScrollingAPIEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::cssOMViewScrollingAPIEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::cssOMViewScrollingAPIEnabledKey(), value);
}

bool WebPreferences::cssOMViewScrollingAPIEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::cssOMViewScrollingAPIEnabledKey());
}

void WebPreferences::setCSSPaintingAPIEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::cssPaintingAPIEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::cssPaintingAPIEnabledKey(), value);
}

bool WebPreferences::cssPaintingAPIEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::cssPaintingAPIEnabledKey());
}

void WebPreferences::setDarkModeCSSEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::darkModeCSSEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::darkModeCSSEnabledKey(), value);
}

bool WebPreferences::darkModeCSSEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::darkModeCSSEnabledKey());
}

void WebPreferences::setImageBitmapOffscreenCanvasEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::imageBitmapOffscreenCanvasEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::imageBitmapOffscreenCanvasEnabledKey(), value);
}

bool WebPreferences::imageBitmapOffscreenCanvasEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::imageBitmapOffscreenCanvasEnabledKey());
}

void WebPreferences::setIntersectionObserverEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::intersectionObserverEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::intersectionObserverEnabledKey(), value);
}

bool WebPreferences::intersectionObserverEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::intersectionObserverEnabledKey());
}

void WebPreferences::setMediaCapabilitiesEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::mediaCapabilitiesEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::mediaCapabilitiesEnabledKey(), value);
}

bool WebPreferences::mediaCapabilitiesEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::mediaCapabilitiesEnabledKey());
}

void WebPreferences::setMediaRecorderEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::mediaRecorderEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::mediaRecorderEnabledKey(), value);
}

bool WebPreferences::mediaRecorderEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::mediaRecorderEnabledKey());
}

void WebPreferences::setPointerEventsEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::pointerEventsEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::pointerEventsEnabledKey(), value);
}

bool WebPreferences::pointerEventsEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::pointerEventsEnabledKey());
}

void WebPreferences::setProcessSwapOnCrossSiteNavigationEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::processSwapOnCrossSiteNavigationEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::processSwapOnCrossSiteNavigationEnabledKey(), value);
}

bool WebPreferences::processSwapOnCrossSiteNavigationEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::processSwapOnCrossSiteNavigationEnabledKey());
}

void WebPreferences::setScreenCaptureEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::screenCaptureEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::screenCaptureEnabledKey(), value);
}

bool WebPreferences::screenCaptureEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::screenCaptureEnabledKey());
}

void WebPreferences::setServerTimingEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::serverTimingEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::serverTimingEnabledKey(), value);
}

bool WebPreferences::serverTimingEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::serverTimingEnabledKey());
}

void WebPreferences::setSpringTimingFunctionEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::springTimingFunctionEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::springTimingFunctionEnabledKey(), value);
}

bool WebPreferences::springTimingFunctionEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::springTimingFunctionEnabledKey());
}

void WebPreferences::setVisualViewportAPIEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::visualViewportAPIEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::visualViewportAPIEnabledKey(), value);
}

bool WebPreferences::visualViewportAPIEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::visualViewportAPIEnabledKey());
}

void WebPreferences::setWebAnimationsCSSIntegrationEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webAnimationsCSSIntegrationEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webAnimationsCSSIntegrationEnabledKey(), value);
}

bool WebPreferences::webAnimationsCSSIntegrationEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webAnimationsCSSIntegrationEnabledKey());
}

void WebPreferences::setWebAnimationsEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webAnimationsEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webAnimationsEnabledKey(), value);
}

bool WebPreferences::webAnimationsEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webAnimationsEnabledKey());
}

void WebPreferences::setWebGL2Enabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webGL2EnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webGL2EnabledKey(), value);
}

bool WebPreferences::webGL2Enabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webGL2EnabledKey());
}

void WebPreferences::setWebGPUEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webGPUEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webGPUEnabledKey(), value);
}

bool WebPreferences::webGPUEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webGPUEnabledKey());
}

void WebPreferences::setWebMetalEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webMetalEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webMetalEnabledKey(), value);
}

bool WebPreferences::webMetalEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webMetalEnabledKey());
}

void WebPreferences::setWebRTCH264SimulcastEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webRTCH264SimulcastEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webRTCH264SimulcastEnabledKey(), value);
}

bool WebPreferences::webRTCH264SimulcastEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webRTCH264SimulcastEnabledKey());
}

void WebPreferences::setWebRTCMDNSICECandidatesEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webRTCMDNSICECandidatesEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webRTCMDNSICECandidatesEnabledKey(), value);
}

bool WebPreferences::webRTCMDNSICECandidatesEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webRTCMDNSICECandidatesEnabledKey());
}

void WebPreferences::setWebRTCUnifiedPlanEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webRTCUnifiedPlanEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webRTCUnifiedPlanEnabledKey(), value);
}

bool WebPreferences::webRTCUnifiedPlanEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webRTCUnifiedPlanEnabledKey());
}

void WebPreferences::setWebRTCVP8CodecEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webRTCVP8CodecEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webRTCVP8CodecEnabledKey(), value);
}

bool WebPreferences::webRTCVP8CodecEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webRTCVP8CodecEnabledKey());
}

void WebPreferences::setWebSQLDisabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webSQLDisabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webSQLDisabledKey(), value);
}

bool WebPreferences::webSQLDisabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webSQLDisabledKey());
}

void WebPreferences::setWebVREnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webVREnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webVREnabledKey(), value);
}

bool WebPreferences::webVREnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webVREnabledKey());
}

const Vector<RefPtr<API::Object>>& WebPreferences::experimentalFeatures()
{
    static NeverDestroyed<Vector<RefPtr<API::Object>>> features(std::initializer_list<RefPtr<API::Object>> {
        API::ExperimentalFeature::create("Accessibility Object Model", "AccessibilityObjectModelEnabled", "Accessibility Object Model support", false, false),
        API::ExperimentalFeature::create("Blank anchor target implies rel=noopener", "BlankAnchorTargetImpliesNoOpenerEnabled", "target=_blank on anchor elements implies rel=noopener", true, false),
        API::ExperimentalFeature::create("CSS Custom Properties and Values API", "CSSCustomPropertiesAndValuesEnabled", "Enable CSS Custom Properties and Values API", false, false),
        API::ExperimentalFeature::create("CSSOM View Scrolling API", "CSSOMViewScrollingAPIEnabled", "Implement standard behavior for scrollLeft, scrollTop, scrollWidth, scrollHeight, scrollTo, scrollBy and scrollingElement.", false, false),
#if ENABLE(CSS_PAINTING_API)
        API::ExperimentalFeature::create("CSS Painting API", "CSSPaintingAPIEnabled", "Enable the CSS Painting API", false, false),
#endif
#if ENABLE(DARK_MODE_CSS)
        API::ExperimentalFeature::create("Dark Mode CSS Support", "DarkModeCSSEnabled", "Enable Dark Mode CSS Support", true, false),
#endif
        API::ExperimentalFeature::create("ImageBitmap and OffscreenCanvas", "ImageBitmapOffscreenCanvasEnabled", "Support for the ImageBitmap and OffscreenCanvas APIs", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED, false),
#if ENABLE(INTERSECTION_OBSERVER)
        API::ExperimentalFeature::create("Intersection Observer", "IntersectionObserverEnabled", "Enable Intersection Observer support", true, false),
#endif
        API::ExperimentalFeature::create("Media Capabilities API", "MediaCapabilitiesEnabled", "Media Capabilities API", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED, false),
#if ENABLE(MEDIA_STREAM)
        API::ExperimentalFeature::create("MediaRecorder", "MediaRecorderEnabled", "MediaRecorder", false, false),
#endif
        API::ExperimentalFeature::create("Pointer Events", "PointerEventsEnabled", "Enable Pointer Events", false, false),
        API::ExperimentalFeature::create("Swap Processes on Cross-Site Navigation", "ProcessSwapOnCrossSiteNavigationEnabled", "Swap WebContent processes on cross-site navigations", DEFAULT_PROCESS_SWAP_ON_CROSS_SITE_NAVIGATION_ENABLED, false),
#if ENABLE(MEDIA_STREAM) && PLATFORM(MAC)
        API::ExperimentalFeature::create("ScreenCapture", "ScreenCaptureEnabled", "Enable ScreenCapture", false, false),
#endif
        API::ExperimentalFeature::create("Server Timing", "ServerTimingEnabled", "Enable Server Timing API", false, false),
        API::ExperimentalFeature::create("CSS Spring Animations", "SpringTimingFunctionEnabled", "CSS Spring Animation prototype", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED, false),
        API::ExperimentalFeature::create("Visual Viewport API", "VisualViewportAPIEnabled", "Enable Visual Viewport API", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED, false),
        API::ExperimentalFeature::create("CSS Animations via Web Animations", "WebAnimationsCSSIntegrationEnabled", "Expose CSS Animations and CSS Transitions through getAnimations()", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED, false),
        API::ExperimentalFeature::create("Web Animations", "WebAnimationsEnabled", "Web Animations prototype", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED, false),
#if ENABLE(WEBGL2)
        API::ExperimentalFeature::create("WebGL 2.0", "WebGL2Enabled", "WebGL 2 prototype", false, false),
#endif
#if ENABLE(WEBGPU)
        API::ExperimentalFeature::create("WebGPU", "WebGPUEnabled", "WebGPU Sketch prototype", false, false),
#endif
#if ENABLE(WEBMETAL)
        API::ExperimentalFeature::create("WebMetal", "WebMetalEnabled", "WebMetal prototype", false, false),
#endif
#if ENABLE(WEB_RTC)
        API::ExperimentalFeature::create("WebRTC H264 Simulcast", "WebRTCH264SimulcastEnabled", "Enable WebRTC H264 Simulcast", true, false),
#endif
#if ENABLE(WEB_RTC)
        API::ExperimentalFeature::create("WebRTC mDNS ICE candidates", "WebRTCMDNSICECandidatesEnabled", "Enable WebRTC mDNS ICE candidates", false, false),
#endif
#if ENABLE(WEB_RTC)
        API::ExperimentalFeature::create("WebRTC Unified Plan", "WebRTCUnifiedPlanEnabled", "Use WebRTC Unified Plan", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED, false),
#endif
#if ENABLE(WEB_RTC)
        API::ExperimentalFeature::create("WebRTC VP8 codec", "WebRTCVP8CodecEnabled", "Enable WebRTC VP8 codec", true, false),
#endif
        API::ExperimentalFeature::create("Disable Web SQL", "WebSQLDisabled", "Disable Web SQL", false, false),
#if PLATFORM(GTK) || PLATFORM(WPE)
        API::ExperimentalFeature::create("WebVR", "WebVREnabled", "WebVR Module support", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED, false),
#endif
    });

    return features;
}

bool WebPreferences::isFeatureEnabled(const API::ExperimentalFeature& feature) const
{
    struct FeatureGetterMapping {
        const char* name;
        bool (WebPreferences::*function) () const;
    };

    static FeatureGetterMapping getters[] = {
        { "AccessibilityObjectModelEnabled", &WebPreferences::accessibilityObjectModelEnabled },
        { "BlankAnchorTargetImpliesNoOpenerEnabled", &WebPreferences::blankAnchorTargetImpliesNoOpenerEnabled },
        { "CSSCustomPropertiesAndValuesEnabled", &WebPreferences::cssCustomPropertiesAndValuesEnabled },
        { "CSSOMViewScrollingAPIEnabled", &WebPreferences::cssOMViewScrollingAPIEnabled },
#if ENABLE(CSS_PAINTING_API)
        { "CSSPaintingAPIEnabled", &WebPreferences::cssPaintingAPIEnabled },
#endif
#if ENABLE(DARK_MODE_CSS)
        { "DarkModeCSSEnabled", &WebPreferences::darkModeCSSEnabled },
#endif
        { "ImageBitmapOffscreenCanvasEnabled", &WebPreferences::imageBitmapOffscreenCanvasEnabled },
#if ENABLE(INTERSECTION_OBSERVER)
        { "IntersectionObserverEnabled", &WebPreferences::intersectionObserverEnabled },
#endif
        { "MediaCapabilitiesEnabled", &WebPreferences::mediaCapabilitiesEnabled },
#if ENABLE(MEDIA_STREAM)
        { "MediaRecorderEnabled", &WebPreferences::mediaRecorderEnabled },
#endif
        { "PointerEventsEnabled", &WebPreferences::pointerEventsEnabled },
        { "ProcessSwapOnCrossSiteNavigationEnabled", &WebPreferences::processSwapOnCrossSiteNavigationEnabled },
#if ENABLE(MEDIA_STREAM) && PLATFORM(MAC)
        { "ScreenCaptureEnabled", &WebPreferences::screenCaptureEnabled },
#endif
        { "ServerTimingEnabled", &WebPreferences::serverTimingEnabled },
        { "SpringTimingFunctionEnabled", &WebPreferences::springTimingFunctionEnabled },
        { "VisualViewportAPIEnabled", &WebPreferences::visualViewportAPIEnabled },
        { "WebAnimationsCSSIntegrationEnabled", &WebPreferences::webAnimationsCSSIntegrationEnabled },
        { "WebAnimationsEnabled", &WebPreferences::webAnimationsEnabled },
#if ENABLE(WEBGL2)
        { "WebGL2Enabled", &WebPreferences::webGL2Enabled },
#endif
#if ENABLE(WEBGPU)
        { "WebGPUEnabled", &WebPreferences::webGPUEnabled },
#endif
#if ENABLE(WEBMETAL)
        { "WebMetalEnabled", &WebPreferences::webMetalEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCH264SimulcastEnabled", &WebPreferences::webRTCH264SimulcastEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCMDNSICECandidatesEnabled", &WebPreferences::webRTCMDNSICECandidatesEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCUnifiedPlanEnabled", &WebPreferences::webRTCUnifiedPlanEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCVP8CodecEnabled", &WebPreferences::webRTCVP8CodecEnabled },
#endif
        { "WebSQLDisabled", &WebPreferences::webSQLDisabled },
#if PLATFORM(GTK) || PLATFORM(WPE)
        { "WebVREnabled", &WebPreferences::webVREnabled },
#endif
    };

    const String& key = feature.key();

    for (auto& getter : getters) {
        if (key == getter.name)
            return (this->*getter.function)();
    }

    return false;
}

void WebPreferences::setFeatureEnabled(const API::ExperimentalFeature& feature, bool value)
{
    setExperimentalFeatureEnabledForKey(feature.key(), value);
}

void WebPreferences::setExperimentalFeatureEnabledForKey(const String& key, bool value)
{
    struct FeatureSetterMapping {
        const char* name;
        void (WebPreferences::*function) (const bool&);
    };

    static FeatureSetterMapping setters[] = {
        { "AccessibilityObjectModelEnabled", &WebPreferences::setAccessibilityObjectModelEnabled },
        { "BlankAnchorTargetImpliesNoOpenerEnabled", &WebPreferences::setBlankAnchorTargetImpliesNoOpenerEnabled },
        { "CSSCustomPropertiesAndValuesEnabled", &WebPreferences::setCSSCustomPropertiesAndValuesEnabled },
        { "CSSOMViewScrollingAPIEnabled", &WebPreferences::setCSSOMViewScrollingAPIEnabled },
#if ENABLE(CSS_PAINTING_API)
        { "CSSPaintingAPIEnabled", &WebPreferences::setCSSPaintingAPIEnabled },
#endif
#if ENABLE(DARK_MODE_CSS)
        { "DarkModeCSSEnabled", &WebPreferences::setDarkModeCSSEnabled },
#endif
        { "ImageBitmapOffscreenCanvasEnabled", &WebPreferences::setImageBitmapOffscreenCanvasEnabled },
#if ENABLE(INTERSECTION_OBSERVER)
        { "IntersectionObserverEnabled", &WebPreferences::setIntersectionObserverEnabled },
#endif
        { "MediaCapabilitiesEnabled", &WebPreferences::setMediaCapabilitiesEnabled },
#if ENABLE(MEDIA_STREAM)
        { "MediaRecorderEnabled", &WebPreferences::setMediaRecorderEnabled },
#endif
        { "PointerEventsEnabled", &WebPreferences::setPointerEventsEnabled },
        { "ProcessSwapOnCrossSiteNavigationEnabled", &WebPreferences::setProcessSwapOnCrossSiteNavigationEnabled },
#if ENABLE(MEDIA_STREAM) && PLATFORM(MAC)
        { "ScreenCaptureEnabled", &WebPreferences::setScreenCaptureEnabled },
#endif
        { "ServerTimingEnabled", &WebPreferences::setServerTimingEnabled },
        { "SpringTimingFunctionEnabled", &WebPreferences::setSpringTimingFunctionEnabled },
        { "VisualViewportAPIEnabled", &WebPreferences::setVisualViewportAPIEnabled },
        { "WebAnimationsCSSIntegrationEnabled", &WebPreferences::setWebAnimationsCSSIntegrationEnabled },
        { "WebAnimationsEnabled", &WebPreferences::setWebAnimationsEnabled },
#if ENABLE(WEBGL2)
        { "WebGL2Enabled", &WebPreferences::setWebGL2Enabled },
#endif
#if ENABLE(WEBGPU)
        { "WebGPUEnabled", &WebPreferences::setWebGPUEnabled },
#endif
#if ENABLE(WEBMETAL)
        { "WebMetalEnabled", &WebPreferences::setWebMetalEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCH264SimulcastEnabled", &WebPreferences::setWebRTCH264SimulcastEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCMDNSICECandidatesEnabled", &WebPreferences::setWebRTCMDNSICECandidatesEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCUnifiedPlanEnabled", &WebPreferences::setWebRTCUnifiedPlanEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCVP8CodecEnabled", &WebPreferences::setWebRTCVP8CodecEnabled },
#endif
        { "WebSQLDisabled", &WebPreferences::setWebSQLDisabled },
#if PLATFORM(GTK) || PLATFORM(WPE)
        { "WebVREnabled", &WebPreferences::setWebVREnabled },
#endif
    };

    for (auto& setter : setters) {
        if (key == setter.name) {
            (this->*setter.function)(value);
            return;
        }
    }
}

void WebPreferences::enableAllExperimentalFeatures()
{
    setAccessibilityObjectModelEnabled(true);
    setBlankAnchorTargetImpliesNoOpenerEnabled(true);
    setCSSCustomPropertiesAndValuesEnabled(true);
    setCSSOMViewScrollingAPIEnabled(true);
#if ENABLE(CSS_PAINTING_API)
    setCSSPaintingAPIEnabled(true);
#endif
#if ENABLE(DARK_MODE_CSS)
    setDarkModeCSSEnabled(true);
#endif
    setImageBitmapOffscreenCanvasEnabled(true);
#if ENABLE(INTERSECTION_OBSERVER)
    setIntersectionObserverEnabled(true);
#endif
    setMediaCapabilitiesEnabled(true);
#if ENABLE(MEDIA_STREAM)
    setMediaRecorderEnabled(true);
#endif
    setPointerEventsEnabled(true);
    setProcessSwapOnCrossSiteNavigationEnabled(true);
#if ENABLE(MEDIA_STREAM) && PLATFORM(MAC)
    setScreenCaptureEnabled(true);
#endif
    setServerTimingEnabled(true);
    setSpringTimingFunctionEnabled(true);
    setVisualViewportAPIEnabled(true);
    setWebAnimationsCSSIntegrationEnabled(true);
    setWebAnimationsEnabled(true);
#if ENABLE(WEBGL2)
    setWebGL2Enabled(true);
#endif
#if ENABLE(WEBGPU)
    setWebGPUEnabled(true);
#endif
#if ENABLE(WEBMETAL)
    setWebMetalEnabled(true);
#endif
#if ENABLE(WEB_RTC)
    setWebRTCH264SimulcastEnabled(true);
#endif
#if ENABLE(WEB_RTC)
    setWebRTCMDNSICECandidatesEnabled(true);
#endif
#if ENABLE(WEB_RTC)
    setWebRTCUnifiedPlanEnabled(true);
#endif
#if ENABLE(WEB_RTC)
    setWebRTCVP8CodecEnabled(true);
#endif
    setWebSQLDisabled(true);
#if PLATFORM(GTK) || PLATFORM(WPE)
    setWebVREnabled(true);
#endif
}

}
