/*
* THIS FILE WAS AUTOMATICALLY GENERATED, DO NOT EDIT.
*
* Copyright (C) 2018 Apple Inc. All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
* 1. Redistributions of source code must retain the above copyright
*    notice, this list of conditions and the following disclaimer.
* 2. Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in the
*    documentation and/or other materials provided with the distribution.
*
* THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS''
* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
* THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
* PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS
* BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
* SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
* THE POSSIBILITY OF SUCH DAMAGE.
*/

#include "config.h"
#include "WebPreferences.h"

#include "WebPreferencesKeys.h"

namespace WebKit {

void WebPreferences::setAriaReflectionEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::ariaReflectionEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::ariaReflectionEnabledKey(), value);
}

bool WebPreferences::ariaReflectionEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::ariaReflectionEnabledKey());
}

void WebPreferences::setAsyncFrameScrollingEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::asyncFrameScrollingEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::asyncFrameScrollingEnabledKey(), value);
}

bool WebPreferences::asyncFrameScrollingEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::asyncFrameScrollingEnabledKey());
}

void WebPreferences::setDataListElementEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::dataListElementEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::dataListElementEnabledKey(), value);
}

bool WebPreferences::dataListElementEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::dataListElementEnabledKey());
}

void WebPreferences::setExperimentalPlugInSandboxProfilesEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::experimentalPlugInSandboxProfilesEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::experimentalPlugInSandboxProfilesEnabledKey(), value);
}

bool WebPreferences::experimentalPlugInSandboxProfilesEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::experimentalPlugInSandboxProfilesEnabledKey());
}

void WebPreferences::setFetchAPIKeepAliveEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::fetchAPIKeepAliveEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::fetchAPIKeepAliveEnabledKey(), value);
}

bool WebPreferences::fetchAPIKeepAliveEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::fetchAPIKeepAliveEnabledKey());
}

void WebPreferences::setFrameFlatteningEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::frameFlatteningEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::frameFlatteningEnabledKey(), value);
}

bool WebPreferences::frameFlatteningEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::frameFlatteningEnabledKey());
}

void WebPreferences::setFullScreenEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::fullScreenEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::fullScreenEnabledKey(), value);
}

bool WebPreferences::fullScreenEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::fullScreenEnabledKey());
}

void WebPreferences::setInputTypeColorEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::inputTypeColorEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::inputTypeColorEnabledKey(), value);
}

bool WebPreferences::inputTypeColorEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::inputTypeColorEnabledKey());
}

void WebPreferences::setResourceLoadStatisticsDebugMode(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::resourceLoadStatisticsDebugModeKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::resourceLoadStatisticsDebugModeKey(), value);
}

bool WebPreferences::resourceLoadStatisticsDebugMode() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::resourceLoadStatisticsDebugModeKey());
}

void WebPreferences::setSelectionAcrossShadowBoundariesEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::selectionAcrossShadowBoundariesEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::selectionAcrossShadowBoundariesEnabledKey(), value);
}

bool WebPreferences::selectionAcrossShadowBoundariesEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::selectionAcrossShadowBoundariesEnabledKey());
}

void WebPreferences::setServiceWorkersEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::serviceWorkersEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::serviceWorkersEnabledKey(), value);
}

bool WebPreferences::serviceWorkersEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::serviceWorkersEnabledKey());
}

void WebPreferences::setWebAPIStatisticsEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webAPIStatisticsEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::webAPIStatisticsEnabledKey(), value);
}

bool WebPreferences::webAPIStatisticsEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webAPIStatisticsEnabledKey());
}

void WebPreferences::setWebGLCompressedTextureASTCSupportEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webGLCompressedTextureASTCSupportEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::webGLCompressedTextureASTCSupportEnabledKey(), value);
}

bool WebPreferences::webGLCompressedTextureASTCSupportEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webGLCompressedTextureASTCSupportEnabledKey());
}

const Vector<RefPtr<API::Object>>& WebPreferences::internalDebugFeatures()
{
    static NeverDestroyed<Vector<RefPtr<API::Object>>> features(std::initializer_list<RefPtr<API::Object>> {
        API::InternalDebugFeature::create("ARIA Reflection", "AriaReflectionEnabled", "ARIA Reflection support", false, false),
        API::InternalDebugFeature::create("Async Frame Scrolling", "AsyncFrameScrollingEnabled", "Perform frame scrolling in a dedicated thread or process", false, false),
#if ENABLE(DATALIST_ELEMENT)
        API::InternalDebugFeature::create("DataList Element", "DataListElementEnabled", "Enable datalist elements", DEFAULT_DATALIST_ELEMENT_ENABLED, false),
#endif
        API::InternalDebugFeature::create("Sandbox Plug-Ins", "ExperimentalPlugInSandboxProfilesEnabled", "Enable Plug-In sandboxing", false, false),
        API::InternalDebugFeature::create("Fetch API Request KeepAlive", "FetchAPIKeepAliveEnabled", "Enable Fetch API Request KeepAlive", false, false),
        API::InternalDebugFeature::create("Frame flattening", "FrameFlatteningEnabled", "Enable frame flattening, which adjusts the height of an iframe to fit its contents", DEFAULT_FRAME_FLATTENING, false),
#if ENABLE(FULLSCREEN_API)
        API::InternalDebugFeature::create("Fullscreen API", "FullScreenEnabled", "Fullscreen API", false, EXPERIMENTAL_FULLSCREEN_API_HIDDEN),
#endif
#if ENABLE(INPUT_TYPE_COLOR)
        API::InternalDebugFeature::create("Color Inputs", "InputTypeColorEnabled", "Enable input elements of type color", DEFAULT_INPUT_TYPE_COLOR_ENABLED, false),
#endif
        API::InternalDebugFeature::create("ITP Debug Mode", "ResourceLoadStatisticsDebugMode", "Intelligent Tracking Prevention Debug Mode", false, false),
        API::InternalDebugFeature::create("Selection across shadow DOM", "SelectionAcrossShadowBoundariesEnabled", "Allow user-initiated selection across shadow DOM boundaries", true, false),
#if ENABLE(SERVICE_WORKER)
        API::InternalDebugFeature::create("Service Workers", "ServiceWorkersEnabled", "Enable Service Workers", DEFAULT_SERVICE_WORKERS_ENABLED, false),
#endif
        API::InternalDebugFeature::create("Web API Statistics", "WebAPIStatisticsEnabled", "Enable Web API Statistics", false, false),
        API::InternalDebugFeature::create("ASTC Texture Support", "WebGLCompressedTextureASTCSupportEnabled", "Support for ASTC compressed texture formats in WebGL", false, false),
    });

    return features;
}

bool WebPreferences::isFeatureEnabled(const API::InternalDebugFeature& feature) const
{
    struct FeatureGetterMapping {
        const char* name;
        bool (WebPreferences::*function) () const;
    };

    static FeatureGetterMapping getters[] = {
        { "AriaReflectionEnabled", &WebPreferences::ariaReflectionEnabled },
        { "AsyncFrameScrollingEnabled", &WebPreferences::asyncFrameScrollingEnabled },
#if ENABLE(DATALIST_ELEMENT)
        { "DataListElementEnabled", &WebPreferences::dataListElementEnabled },
#endif
        { "ExperimentalPlugInSandboxProfilesEnabled", &WebPreferences::experimentalPlugInSandboxProfilesEnabled },
        { "FetchAPIKeepAliveEnabled", &WebPreferences::fetchAPIKeepAliveEnabled },
        { "FrameFlatteningEnabled", &WebPreferences::frameFlatteningEnabled },
#if ENABLE(FULLSCREEN_API)
        { "FullScreenEnabled", &WebPreferences::fullScreenEnabled },
#endif
#if ENABLE(INPUT_TYPE_COLOR)
        { "InputTypeColorEnabled", &WebPreferences::inputTypeColorEnabled },
#endif
        { "ResourceLoadStatisticsDebugMode", &WebPreferences::resourceLoadStatisticsDebugMode },
        { "SelectionAcrossShadowBoundariesEnabled", &WebPreferences::selectionAcrossShadowBoundariesEnabled },
#if ENABLE(SERVICE_WORKER)
        { "ServiceWorkersEnabled", &WebPreferences::serviceWorkersEnabled },
#endif
        { "WebAPIStatisticsEnabled", &WebPreferences::webAPIStatisticsEnabled },
        { "WebGLCompressedTextureASTCSupportEnabled", &WebPreferences::webGLCompressedTextureASTCSupportEnabled },
    };

    const String& key = feature.key();

    for (auto& getter : getters) {
        if (key == getter.name)
            return (this->*getter.function)();
    }

    return false;
}

void WebPreferences::setFeatureEnabled(const API::InternalDebugFeature& feature, bool value)
{
    setInternalDebugFeatureEnabledForKey(feature.key(), value);
}

void WebPreferences::setInternalDebugFeatureEnabledForKey(const String& key, bool value)
{
    struct FeatureSetterMapping {
        const char* name;
        void (WebPreferences::*function) (const bool&);
    };

    static FeatureSetterMapping setters[] = {
        { "AriaReflectionEnabled", &WebPreferences::setAriaReflectionEnabled },
        { "AsyncFrameScrollingEnabled", &WebPreferences::setAsyncFrameScrollingEnabled },
#if ENABLE(DATALIST_ELEMENT)
        { "DataListElementEnabled", &WebPreferences::setDataListElementEnabled },
#endif
        { "ExperimentalPlugInSandboxProfilesEnabled", &WebPreferences::setExperimentalPlugInSandboxProfilesEnabled },
        { "FetchAPIKeepAliveEnabled", &WebPreferences::setFetchAPIKeepAliveEnabled },
        { "FrameFlatteningEnabled", &WebPreferences::setFrameFlatteningEnabled },
#if ENABLE(FULLSCREEN_API)
        { "FullScreenEnabled", &WebPreferences::setFullScreenEnabled },
#endif
#if ENABLE(INPUT_TYPE_COLOR)
        { "InputTypeColorEnabled", &WebPreferences::setInputTypeColorEnabled },
#endif
        { "ResourceLoadStatisticsDebugMode", &WebPreferences::setResourceLoadStatisticsDebugMode },
        { "SelectionAcrossShadowBoundariesEnabled", &WebPreferences::setSelectionAcrossShadowBoundariesEnabled },
#if ENABLE(SERVICE_WORKER)
        { "ServiceWorkersEnabled", &WebPreferences::setServiceWorkersEnabled },
#endif
        { "WebAPIStatisticsEnabled", &WebPreferences::setWebAPIStatisticsEnabled },
        { "WebGLCompressedTextureASTCSupportEnabled", &WebPreferences::setWebGLCompressedTextureASTCSupportEnabled },
    };

    for (auto& setter : setters) {
        if (key == setter.name) {
            (this->*setter.function)(value);
            return;
        }
    }
}

void WebPreferences::resetAllInternalDebugFeatures()
{
    setAriaReflectionEnabled(false);
    setAsyncFrameScrollingEnabled(false);
#if ENABLE(DATALIST_ELEMENT)
    setDataListElementEnabled(DEFAULT_DATALIST_ELEMENT_ENABLED);
#endif
    setExperimentalPlugInSandboxProfilesEnabled(false);
    setFetchAPIKeepAliveEnabled(false);
    setFrameFlatteningEnabled(DEFAULT_FRAME_FLATTENING);
#if ENABLE(FULLSCREEN_API)
    setFullScreenEnabled(false);
#endif
#if ENABLE(INPUT_TYPE_COLOR)
    setInputTypeColorEnabled(DEFAULT_INPUT_TYPE_COLOR_ENABLED);
#endif
    setResourceLoadStatisticsDebugMode(false);
    setSelectionAcrossShadowBoundariesEnabled(true);
#if ENABLE(SERVICE_WORKER)
    setServiceWorkersEnabled(DEFAULT_SERVICE_WORKERS_ENABLED);
#endif
    setWebAPIStatisticsEnabled(false);
    setWebGLCompressedTextureASTCSupportEnabled(false);
}

}
