//  SHA1Hash: da39a3ee5e6b4b0d3255bfef95601890afd80709
/*
 * Copyright (C) 2018 Apple Inc. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1.  Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 * 2.  Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY APPLE AND ITS CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL APPLE OR ITS CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 * Autogenerated from /builddir/build/BUILD/webkitgtk-2.23.1/Source/JavaScriptCore/bytecode/BytecodeList.rb, do not modify.
*/

            #pragma once

            #include "ArithProfile.h"
            #include "BytecodeDumper.h"
            #include "BytecodeGenerator.h"
            #include "Fits.h"
            #include "GetByIdMetadata.h"
            #include "Instruction.h"
            #include "Opcode.h"
            #include "ToThisStatus.h"

            namespace JSC {

                    struct OpCreateThis : public Instruction {
            static constexpr OpcodeID opcodeID = op_create_this;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, unsigned inlineCapacity)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, callee, inlineCapacity, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, callee, inlineCapacity, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, unsigned inlineCapacity)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, callee, inlineCapacity, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, unsigned inlineCapacity, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, callee, inlineCapacity, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, unsigned inlineCapacity, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(callee) && Fits<unsigned, size>::check(inlineCapacity) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(callee));
__generator->write(Fits<unsigned, size>::convert(inlineCapacity));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*create_this"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(callee, false);

                __dumper->dumpOperand(inlineCapacity, false);

        }


                    OpCreateThis(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
callee(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
inlineCapacity(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpCreateThis(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
callee(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
inlineCapacity(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpCreateThis decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setCallee(VirtualRegister value, Functor func)
        {
            if (isWide())
                setCallee<OpcodeSize::Wide>(value, func);
            else
                setCallee<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setCallee(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setInlineCapacity(unsigned value, Functor func)
        {
            if (isWide())
                setInlineCapacity<OpcodeSize::Wide>(value, func);
            else
                setInlineCapacity<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setInlineCapacity(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpCreateThis&)
            
            { }

            WriteBarrier<JSCell> cachedCallee;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister callee;
unsigned inlineCapacity;
        unsigned metadataID;

        };

        struct OpGetArgument : public Instruction {
            static constexpr OpcodeID opcodeID = op_get_argument;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, int index)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, index, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, index, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, int index)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, index, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, int index, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, index, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, int index, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<int, size>::check(index) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<int, size>::convert(index));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*get_argument"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(index, false);

        }


                    OpGetArgument(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
index(Fits<int, OpcodeSize::Narrow>::convert(stream[2])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpGetArgument(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
index(Fits<int, OpcodeSize::Wide>::convert(stream[2])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpGetArgument decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setIndex(int value, Functor func)
        {
            if (isWide())
                setIndex<OpcodeSize::Wide>(value, func);
            else
                setIndex<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setIndex(int value, Functor func)
        {
            if (!Fits<int, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<int, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpGetArgument&)
            
            { }

            ValueProfile profile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
int index;
        unsigned metadataID;

        };

        struct OpToThis : public Instruction {
            static constexpr OpcodeID opcodeID = op_to_this;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister srcDst)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, srcDst, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, srcDst, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister srcDst)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, srcDst, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister srcDst, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, srcDst, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister srcDst, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(srcDst) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(srcDst));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*to_this"[!__isWide]);
                            __dumper->dumpOperand(srcDst, true);

        }


                    OpToThis(const uint8_t* stream)
            : srcDst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpToThis(const uint32_t* stream)
            : srcDst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpToThis decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setSrcDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setSrcDst<OpcodeSize::Wide>(value, func);
            else
                setSrcDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setSrcDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpToThis&)
            
            { }

            WriteBarrierBase<Structure> cachedStructure;
ToThisStatus toThisStatus;
ValueProfile profile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister srcDst;
        unsigned metadataID;

        };

        struct OpNewObject : public Instruction {
            static constexpr OpcodeID opcodeID = op_new_object;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, unsigned inlineCapacity)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, inlineCapacity, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, inlineCapacity, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, unsigned inlineCapacity)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, inlineCapacity, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, unsigned inlineCapacity, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, inlineCapacity, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, unsigned inlineCapacity, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<unsigned, size>::check(inlineCapacity) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<unsigned, size>::convert(inlineCapacity));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*new_object"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(inlineCapacity, false);

        }


                    OpNewObject(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
inlineCapacity(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[2])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpNewObject(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
inlineCapacity(Fits<unsigned, OpcodeSize::Wide>::convert(stream[2])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpNewObject decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setInlineCapacity(unsigned value, Functor func)
        {
            if (isWide())
                setInlineCapacity<OpcodeSize::Wide>(value, func);
            else
                setInlineCapacity<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setInlineCapacity(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpNewObject&)
            
            { }

            ObjectAllocationProfile objectAllocationProfile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
unsigned inlineCapacity;
        unsigned metadataID;

        };

        struct OpNewArray : public Instruction {
            static constexpr OpcodeID opcodeID = op_new_array;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister argv, unsigned argc, IndexingType recommendedIndexingType)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, argv, argc, recommendedIndexingType, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, argv, argc, recommendedIndexingType, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister argv, unsigned argc, IndexingType recommendedIndexingType)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, argv, argc, recommendedIndexingType, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister argv, unsigned argc, IndexingType recommendedIndexingType, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, argv, argc, recommendedIndexingType, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister argv, unsigned argc, IndexingType recommendedIndexingType, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(argv) && Fits<unsigned, size>::check(argc) && Fits<IndexingType, size>::check(recommendedIndexingType) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(argv));
__generator->write(Fits<unsigned, size>::convert(argc));
__generator->write(Fits<IndexingType, size>::convert(recommendedIndexingType));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*new_array"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(argv, false);

                __dumper->dumpOperand(argc, false);

                __dumper->dumpOperand(recommendedIndexingType, false);

        }


                    OpNewArray(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
argv(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
argc(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3])),
recommendedIndexingType(Fits<IndexingType, OpcodeSize::Narrow>::convert(stream[4])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[5]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpNewArray(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
argv(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
argc(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3])),
recommendedIndexingType(Fits<IndexingType, OpcodeSize::Wide>::convert(stream[4])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[5]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpNewArray decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setArgv(VirtualRegister value, Functor func)
        {
            if (isWide())
                setArgv<OpcodeSize::Wide>(value, func);
            else
                setArgv<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setArgv(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setArgc(unsigned value, Functor func)
        {
            if (isWide())
                setArgc<OpcodeSize::Wide>(value, func);
            else
                setArgc<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setArgc(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }

        template<typename Functor>
        void setRecommendedIndexingType(IndexingType value, Functor func)
        {
            if (isWide())
                setRecommendedIndexingType<OpcodeSize::Wide>(value, func);
            else
                setRecommendedIndexingType<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRecommendedIndexingType(IndexingType value, Functor func)
        {
            if (!Fits<IndexingType, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<IndexingType, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpNewArray&)
            
            { }

            ArrayAllocationProfile arrayAllocationProfile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister argv;
unsigned argc;
IndexingType recommendedIndexingType;
        unsigned metadataID;

        };

        struct OpNewArrayWithSize : public Instruction {
            static constexpr OpcodeID opcodeID = op_new_array_with_size;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister length)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, length, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, length, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister length)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, length, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister length, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, length, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister length, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(length) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(length));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*new_array_with_size"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(length, false);

        }


                    OpNewArrayWithSize(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
length(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpNewArrayWithSize(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
length(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpNewArrayWithSize decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setLength(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLength<OpcodeSize::Wide>(value, func);
            else
                setLength<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLength(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpNewArrayWithSize&)
            
            { }

            ArrayAllocationProfile arrayAllocationProfile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister length;
        unsigned metadataID;

        };

        struct OpNewArrayBuffer : public Instruction {
            static constexpr OpcodeID opcodeID = op_new_array_buffer;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister immutableButterfly, IndexingType recommendedIndexingType)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, immutableButterfly, recommendedIndexingType, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, immutableButterfly, recommendedIndexingType, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister immutableButterfly, IndexingType recommendedIndexingType)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, immutableButterfly, recommendedIndexingType, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister immutableButterfly, IndexingType recommendedIndexingType, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, immutableButterfly, recommendedIndexingType, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister immutableButterfly, IndexingType recommendedIndexingType, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(immutableButterfly) && Fits<IndexingType, size>::check(recommendedIndexingType) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(immutableButterfly));
__generator->write(Fits<IndexingType, size>::convert(recommendedIndexingType));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*new_array_buffer"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(immutableButterfly, false);

                __dumper->dumpOperand(recommendedIndexingType, false);

        }


                    OpNewArrayBuffer(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
immutableButterfly(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
recommendedIndexingType(Fits<IndexingType, OpcodeSize::Narrow>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpNewArrayBuffer(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
immutableButterfly(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
recommendedIndexingType(Fits<IndexingType, OpcodeSize::Wide>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpNewArrayBuffer decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setImmutableButterfly(VirtualRegister value, Functor func)
        {
            if (isWide())
                setImmutableButterfly<OpcodeSize::Wide>(value, func);
            else
                setImmutableButterfly<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setImmutableButterfly(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRecommendedIndexingType(IndexingType value, Functor func)
        {
            if (isWide())
                setRecommendedIndexingType<OpcodeSize::Wide>(value, func);
            else
                setRecommendedIndexingType<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRecommendedIndexingType(IndexingType value, Functor func)
        {
            if (!Fits<IndexingType, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<IndexingType, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpNewArrayBuffer&)
            
            { }

            ArrayAllocationProfile arrayAllocationProfile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister immutableButterfly;
IndexingType recommendedIndexingType;
        unsigned metadataID;

        };

        struct OpAdd : public Instruction {
            static constexpr OpcodeID opcodeID = op_add;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs, OperandTypes operandTypes)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, lhs, rhs, operandTypes, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, lhs, rhs, operandTypes, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs, OperandTypes operandTypes)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, lhs, rhs, operandTypes, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs, OperandTypes operandTypes, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, lhs, rhs, operandTypes, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs, OperandTypes operandTypes, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && Fits<OperandTypes, size>::check(operandTypes) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
__generator->write(Fits<OperandTypes, size>::convert(operandTypes));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*add"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(lhs, false);

                __dumper->dumpOperand(rhs, false);

                __dumper->dumpOperand(operandTypes, false);

        }


                    OpAdd(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3])),
operandTypes(Fits<OperandTypes, OpcodeSize::Narrow>::convert(stream[4])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[5]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpAdd(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3])),
operandTypes(Fits<OperandTypes, OpcodeSize::Wide>::convert(stream[4])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[5]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpAdd decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setOperandTypes(OperandTypes value, Functor func)
        {
            if (isWide())
                setOperandTypes<OpcodeSize::Wide>(value, func);
            else
                setOperandTypes<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setOperandTypes(OperandTypes value, Functor func)
        {
            if (!Fits<OperandTypes, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<OperandTypes, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpAdd& __op)
            : arithProfile(__op.operandTypes)
            { }

            ArithProfile arithProfile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister lhs;
VirtualRegister rhs;
OperandTypes operandTypes;
        unsigned metadataID;

        };

        struct OpMul : public Instruction {
            static constexpr OpcodeID opcodeID = op_mul;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs, OperandTypes operandTypes)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, lhs, rhs, operandTypes, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, lhs, rhs, operandTypes, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs, OperandTypes operandTypes)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, lhs, rhs, operandTypes, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs, OperandTypes operandTypes, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, lhs, rhs, operandTypes, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs, OperandTypes operandTypes, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && Fits<OperandTypes, size>::check(operandTypes) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
__generator->write(Fits<OperandTypes, size>::convert(operandTypes));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*mul"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(lhs, false);

                __dumper->dumpOperand(rhs, false);

                __dumper->dumpOperand(operandTypes, false);

        }


                    OpMul(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3])),
operandTypes(Fits<OperandTypes, OpcodeSize::Narrow>::convert(stream[4])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[5]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpMul(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3])),
operandTypes(Fits<OperandTypes, OpcodeSize::Wide>::convert(stream[4])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[5]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpMul decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setOperandTypes(OperandTypes value, Functor func)
        {
            if (isWide())
                setOperandTypes<OpcodeSize::Wide>(value, func);
            else
                setOperandTypes<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setOperandTypes(OperandTypes value, Functor func)
        {
            if (!Fits<OperandTypes, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<OperandTypes, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpMul& __op)
            : arithProfile(__op.operandTypes)
            { }

            ArithProfile arithProfile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister lhs;
VirtualRegister rhs;
OperandTypes operandTypes;
        unsigned metadataID;

        };

        struct OpDiv : public Instruction {
            static constexpr OpcodeID opcodeID = op_div;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs, OperandTypes operandTypes)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, lhs, rhs, operandTypes, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, lhs, rhs, operandTypes, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs, OperandTypes operandTypes)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, lhs, rhs, operandTypes, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs, OperandTypes operandTypes, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, lhs, rhs, operandTypes, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs, OperandTypes operandTypes, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && Fits<OperandTypes, size>::check(operandTypes) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
__generator->write(Fits<OperandTypes, size>::convert(operandTypes));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*div"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(lhs, false);

                __dumper->dumpOperand(rhs, false);

                __dumper->dumpOperand(operandTypes, false);

        }


                    OpDiv(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3])),
operandTypes(Fits<OperandTypes, OpcodeSize::Narrow>::convert(stream[4])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[5]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpDiv(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3])),
operandTypes(Fits<OperandTypes, OpcodeSize::Wide>::convert(stream[4])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[5]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpDiv decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setOperandTypes(OperandTypes value, Functor func)
        {
            if (isWide())
                setOperandTypes<OpcodeSize::Wide>(value, func);
            else
                setOperandTypes<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setOperandTypes(OperandTypes value, Functor func)
        {
            if (!Fits<OperandTypes, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<OperandTypes, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpDiv& __op)
            : arithProfile(__op.operandTypes)
            { }

            ArithProfile arithProfile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister lhs;
VirtualRegister rhs;
OperandTypes operandTypes;
        unsigned metadataID;

        };

        struct OpSub : public Instruction {
            static constexpr OpcodeID opcodeID = op_sub;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs, OperandTypes operandTypes)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, lhs, rhs, operandTypes, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, lhs, rhs, operandTypes, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs, OperandTypes operandTypes)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, lhs, rhs, operandTypes, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs, OperandTypes operandTypes, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, lhs, rhs, operandTypes, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs, OperandTypes operandTypes, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && Fits<OperandTypes, size>::check(operandTypes) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
__generator->write(Fits<OperandTypes, size>::convert(operandTypes));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*sub"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(lhs, false);

                __dumper->dumpOperand(rhs, false);

                __dumper->dumpOperand(operandTypes, false);

        }


                    OpSub(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3])),
operandTypes(Fits<OperandTypes, OpcodeSize::Narrow>::convert(stream[4])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[5]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpSub(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3])),
operandTypes(Fits<OperandTypes, OpcodeSize::Wide>::convert(stream[4])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[5]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpSub decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setOperandTypes(OperandTypes value, Functor func)
        {
            if (isWide())
                setOperandTypes<OpcodeSize::Wide>(value, func);
            else
                setOperandTypes<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setOperandTypes(OperandTypes value, Functor func)
        {
            if (!Fits<OperandTypes, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<OperandTypes, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpSub& __op)
            : arithProfile(__op.operandTypes)
            { }

            ArithProfile arithProfile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister lhs;
VirtualRegister rhs;
OperandTypes operandTypes;
        unsigned metadataID;

        };

        struct OpBitxor : public Instruction {
            static constexpr OpcodeID opcodeID = op_bitxor;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs, OperandTypes operandTypes)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, lhs, rhs, operandTypes, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, lhs, rhs, operandTypes, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs, OperandTypes operandTypes)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, lhs, rhs, operandTypes, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs, OperandTypes operandTypes, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, lhs, rhs, operandTypes, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs, OperandTypes operandTypes, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && Fits<OperandTypes, size>::check(operandTypes) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
__generator->write(Fits<OperandTypes, size>::convert(operandTypes));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*bitxor"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(lhs, false);

                __dumper->dumpOperand(rhs, false);

                __dumper->dumpOperand(operandTypes, false);

        }


                    OpBitxor(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3])),
operandTypes(Fits<OperandTypes, OpcodeSize::Narrow>::convert(stream[4])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[5]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpBitxor(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3])),
operandTypes(Fits<OperandTypes, OpcodeSize::Wide>::convert(stream[4])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[5]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpBitxor decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setOperandTypes(OperandTypes value, Functor func)
        {
            if (isWide())
                setOperandTypes<OpcodeSize::Wide>(value, func);
            else
                setOperandTypes<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setOperandTypes(OperandTypes value, Functor func)
        {
            if (!Fits<OperandTypes, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<OperandTypes, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpBitxor& __op)
            : arithProfile(__op.operandTypes)
            { }

            ArithProfile arithProfile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister lhs;
VirtualRegister rhs;
OperandTypes operandTypes;
        unsigned metadataID;

        };

        struct OpBitand : public Instruction {
            static constexpr OpcodeID opcodeID = op_bitand;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, lhs, rhs, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, lhs, rhs, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, lhs, rhs, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, lhs, rhs, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*bitand"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(lhs, false);

                __dumper->dumpOperand(rhs, false);

        }


                    OpBitand(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpBitand(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpBitand decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpBitand&)
            
            { }

            ValueProfile profile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister lhs;
VirtualRegister rhs;
        unsigned metadataID;

        };

        struct OpBitor : public Instruction {
            static constexpr OpcodeID opcodeID = op_bitor;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, lhs, rhs, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, lhs, rhs, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, lhs, rhs, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, lhs, rhs, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*bitor"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(lhs, false);

                __dumper->dumpOperand(rhs, false);

        }


                    OpBitor(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpBitor(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpBitor decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpBitor&)
            
            { }

            ValueProfile profile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister lhs;
VirtualRegister rhs;
        unsigned metadataID;

        };

        struct OpToObject : public Instruction {
            static constexpr OpcodeID opcodeID = op_to_object;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand, unsigned message)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, operand, message, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, operand, message, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand, unsigned message)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, operand, message, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand, unsigned message, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, operand, message, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand, unsigned message, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(operand) && Fits<unsigned, size>::check(message) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(operand));
__generator->write(Fits<unsigned, size>::convert(message));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*to_object"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(operand, false);

                __dumper->dumpOperand(message, false);

        }


                    OpToObject(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
message(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpToObject(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
message(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpToObject decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (isWide())
                setOperand<OpcodeSize::Wide>(value, func);
            else
                setOperand<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setMessage(unsigned value, Functor func)
        {
            if (isWide())
                setMessage<OpcodeSize::Wide>(value, func);
            else
                setMessage<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setMessage(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpToObject&)
            
            { }

            ValueProfile profile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister operand;
unsigned message;
        unsigned metadataID;

        };

        struct OpToNumber : public Instruction {
            static constexpr OpcodeID opcodeID = op_to_number;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, operand, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, operand, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, operand, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, operand, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(operand) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(operand));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*to_number"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(operand, false);

        }


                    OpToNumber(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpToNumber(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpToNumber decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (isWide())
                setOperand<OpcodeSize::Wide>(value, func);
            else
                setOperand<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpToNumber&)
            
            { }

            ValueProfile profile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister operand;
        unsigned metadataID;

        };

        struct OpNegate : public Instruction {
            static constexpr OpcodeID opcodeID = op_negate;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand, OperandTypes operandTypes)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, operand, operandTypes, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, operand, operandTypes, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand, OperandTypes operandTypes)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, operand, operandTypes, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand, OperandTypes operandTypes, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, operand, operandTypes, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand, OperandTypes operandTypes, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(operand) && Fits<OperandTypes, size>::check(operandTypes) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(operand));
__generator->write(Fits<OperandTypes, size>::convert(operandTypes));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*negate"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(operand, false);

                __dumper->dumpOperand(operandTypes, false);

        }


                    OpNegate(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
operandTypes(Fits<OperandTypes, OpcodeSize::Narrow>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpNegate(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
operandTypes(Fits<OperandTypes, OpcodeSize::Wide>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpNegate decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (isWide())
                setOperand<OpcodeSize::Wide>(value, func);
            else
                setOperand<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setOperandTypes(OperandTypes value, Functor func)
        {
            if (isWide())
                setOperandTypes<OpcodeSize::Wide>(value, func);
            else
                setOperandTypes<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setOperandTypes(OperandTypes value, Functor func)
        {
            if (!Fits<OperandTypes, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<OperandTypes, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpNegate& __op)
            : arithProfile(__op.operandTypes)
            { }

            ArithProfile arithProfile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister operand;
OperandTypes operandTypes;
        unsigned metadataID;

        };

        struct OpInByVal : public Instruction {
            static constexpr OpcodeID opcodeID = op_in_by_val;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister property)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, base, property, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, base, property, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister property)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, base, property, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister property, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, base, property, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister property, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(base) && Fits<VirtualRegister, size>::check(property) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(base));
__generator->write(Fits<VirtualRegister, size>::convert(property));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*in_by_val"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(base, false);

                __dumper->dumpOperand(property, false);

        }


                    OpInByVal(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
property(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpInByVal(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
property(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpInByVal decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (isWide())
                setBase<OpcodeSize::Wide>(value, func);
            else
                setBase<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setProperty(VirtualRegister value, Functor func)
        {
            if (isWide())
                setProperty<OpcodeSize::Wide>(value, func);
            else
                setProperty<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setProperty(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpInByVal&)
            
            { }

            ArrayProfile arrayProfile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister base;
VirtualRegister property;
        unsigned metadataID;

        };

        struct OpGetById : public Instruction {
            static constexpr OpcodeID opcodeID = op_get_by_id;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, unsigned property)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, base, property, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, base, property, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, unsigned property)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, base, property, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, unsigned property, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, base, property, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, unsigned property, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(base) && Fits<unsigned, size>::check(property) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(base));
__generator->write(Fits<unsigned, size>::convert(property));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*get_by_id"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(base, false);

                __dumper->dumpOperand(property, false);

        }


                    OpGetById(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
property(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpGetById(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
property(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpGetById decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (isWide())
                setBase<OpcodeSize::Wide>(value, func);
            else
                setBase<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setProperty(unsigned value, Functor func)
        {
            if (isWide())
                setProperty<OpcodeSize::Wide>(value, func);
            else
                setProperty<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setProperty(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpGetById&)
            
            { }

            GetByIdMode mode;
GetByIdModeMetadata modeMetadata;
unsigned hitCountForLLIntCaching;
ValueProfile profile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister base;
unsigned property;
        unsigned metadataID;

        };

        struct OpGetByIdWithThis : public Instruction {
            static constexpr OpcodeID opcodeID = op_get_by_id_with_this;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister thisValue, unsigned property)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, base, thisValue, property, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, base, thisValue, property, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister thisValue, unsigned property)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, base, thisValue, property, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister thisValue, unsigned property, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, base, thisValue, property, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister thisValue, unsigned property, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(base) && Fits<VirtualRegister, size>::check(thisValue) && Fits<unsigned, size>::check(property) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(base));
__generator->write(Fits<VirtualRegister, size>::convert(thisValue));
__generator->write(Fits<unsigned, size>::convert(property));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*get_by_id_with_this"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(base, false);

                __dumper->dumpOperand(thisValue, false);

                __dumper->dumpOperand(property, false);

        }


                    OpGetByIdWithThis(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
thisValue(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3])),
property(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[4])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[5]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpGetByIdWithThis(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
thisValue(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3])),
property(Fits<unsigned, OpcodeSize::Wide>::convert(stream[4])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[5]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpGetByIdWithThis decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (isWide())
                setBase<OpcodeSize::Wide>(value, func);
            else
                setBase<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setThisValue(VirtualRegister value, Functor func)
        {
            if (isWide())
                setThisValue<OpcodeSize::Wide>(value, func);
            else
                setThisValue<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setThisValue(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setProperty(unsigned value, Functor func)
        {
            if (isWide())
                setProperty<OpcodeSize::Wide>(value, func);
            else
                setProperty<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setProperty(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpGetByIdWithThis&)
            
            { }

            ValueProfile profile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister base;
VirtualRegister thisValue;
unsigned property;
        unsigned metadataID;

        };

        struct OpGetByValWithThis : public Instruction {
            static constexpr OpcodeID opcodeID = op_get_by_val_with_this;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister thisValue, VirtualRegister property)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, base, thisValue, property, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, base, thisValue, property, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister thisValue, VirtualRegister property)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, base, thisValue, property, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister thisValue, VirtualRegister property, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, base, thisValue, property, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister thisValue, VirtualRegister property, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(base) && Fits<VirtualRegister, size>::check(thisValue) && Fits<VirtualRegister, size>::check(property) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(base));
__generator->write(Fits<VirtualRegister, size>::convert(thisValue));
__generator->write(Fits<VirtualRegister, size>::convert(property));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*get_by_val_with_this"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(base, false);

                __dumper->dumpOperand(thisValue, false);

                __dumper->dumpOperand(property, false);

        }


                    OpGetByValWithThis(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
thisValue(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3])),
property(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[4])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[5]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpGetByValWithThis(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
thisValue(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3])),
property(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[4])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[5]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpGetByValWithThis decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (isWide())
                setBase<OpcodeSize::Wide>(value, func);
            else
                setBase<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setThisValue(VirtualRegister value, Functor func)
        {
            if (isWide())
                setThisValue<OpcodeSize::Wide>(value, func);
            else
                setThisValue<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setThisValue(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setProperty(VirtualRegister value, Functor func)
        {
            if (isWide())
                setProperty<OpcodeSize::Wide>(value, func);
            else
                setProperty<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setProperty(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpGetByValWithThis&)
            
            { }

            ValueProfile profile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister base;
VirtualRegister thisValue;
VirtualRegister property;
        unsigned metadataID;

        };

        struct OpGetByIdDirect : public Instruction {
            static constexpr OpcodeID opcodeID = op_get_by_id_direct;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, unsigned property)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, base, property, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, base, property, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, unsigned property)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, base, property, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, unsigned property, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, base, property, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, unsigned property, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(base) && Fits<unsigned, size>::check(property) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(base));
__generator->write(Fits<unsigned, size>::convert(property));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*get_by_id_direct"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(base, false);

                __dumper->dumpOperand(property, false);

        }


                    OpGetByIdDirect(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
property(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpGetByIdDirect(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
property(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpGetByIdDirect decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (isWide())
                setBase<OpcodeSize::Wide>(value, func);
            else
                setBase<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setProperty(unsigned value, Functor func)
        {
            if (isWide())
                setProperty<OpcodeSize::Wide>(value, func);
            else
                setProperty<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setProperty(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpGetByIdDirect&)
            
            { }

            ValueProfile profile;
StructureID structure;
unsigned offset;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister base;
unsigned property;
        unsigned metadataID;

        };

        struct OpTryGetById : public Instruction {
            static constexpr OpcodeID opcodeID = op_try_get_by_id;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, unsigned property)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, base, property, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, base, property, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, unsigned property)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, base, property, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, unsigned property, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, base, property, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, unsigned property, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(base) && Fits<unsigned, size>::check(property) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(base));
__generator->write(Fits<unsigned, size>::convert(property));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*try_get_by_id"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(base, false);

                __dumper->dumpOperand(property, false);

        }


                    OpTryGetById(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
property(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpTryGetById(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
property(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpTryGetById decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (isWide())
                setBase<OpcodeSize::Wide>(value, func);
            else
                setBase<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setProperty(unsigned value, Functor func)
        {
            if (isWide())
                setProperty<OpcodeSize::Wide>(value, func);
            else
                setProperty<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setProperty(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpTryGetById&)
            
            { }

            ValueProfile profile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister base;
unsigned property;
        unsigned metadataID;

        };

        struct OpPutById : public Instruction {
            static constexpr OpcodeID opcodeID = op_put_by_id;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister base, unsigned property, VirtualRegister value, PutByIdFlags flags)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, base, property, value, flags, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, base, property, value, flags, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister base, unsigned property, VirtualRegister value, PutByIdFlags flags)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, base, property, value, flags, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister base, unsigned property, VirtualRegister value, PutByIdFlags flags, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, base, property, value, flags, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister base, unsigned property, VirtualRegister value, PutByIdFlags flags, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(base) && Fits<unsigned, size>::check(property) && Fits<VirtualRegister, size>::check(value) && Fits<PutByIdFlags, size>::check(flags) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(base));
__generator->write(Fits<unsigned, size>::convert(property));
__generator->write(Fits<VirtualRegister, size>::convert(value));
__generator->write(Fits<PutByIdFlags, size>::convert(flags));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*put_by_id"[!__isWide]);
                            __dumper->dumpOperand(base, true);

                __dumper->dumpOperand(property, false);

                __dumper->dumpOperand(value, false);

                __dumper->dumpOperand(flags, false);

        }


                    OpPutById(const uint8_t* stream)
            : base(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
property(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[2])),
value(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3])),
flags(Fits<PutByIdFlags, OpcodeSize::Narrow>::convert(stream[4])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[5]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpPutById(const uint32_t* stream)
            : base(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
property(Fits<unsigned, OpcodeSize::Wide>::convert(stream[2])),
value(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3])),
flags(Fits<PutByIdFlags, OpcodeSize::Wide>::convert(stream[4])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[5]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpPutById decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (isWide())
                setBase<OpcodeSize::Wide>(value, func);
            else
                setBase<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setProperty(unsigned value, Functor func)
        {
            if (isWide())
                setProperty<OpcodeSize::Wide>(value, func);
            else
                setProperty<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setProperty(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }

        template<typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (isWide())
                setValue<OpcodeSize::Wide>(value, func);
            else
                setValue<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setFlags(PutByIdFlags value, Functor func)
        {
            if (isWide())
                setFlags<OpcodeSize::Wide>(value, func);
            else
                setFlags<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setFlags(PutByIdFlags value, Functor func)
        {
            if (!Fits<PutByIdFlags, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<PutByIdFlags, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpPutById& __op)
            : flags(__op.flags)
            { }

            StructureID oldStructure;
unsigned offset;
StructureID newStructure;
WriteBarrierBase<StructureChain> structureChain;
PutByIdFlags flags;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister base;
unsigned property;
VirtualRegister value;
PutByIdFlags flags;
        unsigned metadataID;

        };

        struct OpGetByVal : public Instruction {
            static constexpr OpcodeID opcodeID = op_get_by_val;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister property)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, base, property, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, base, property, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister property)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, base, property, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister property, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, base, property, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister property, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(base) && Fits<VirtualRegister, size>::check(property) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(base));
__generator->write(Fits<VirtualRegister, size>::convert(property));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*get_by_val"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(base, false);

                __dumper->dumpOperand(property, false);

        }


                    OpGetByVal(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
property(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpGetByVal(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
property(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpGetByVal decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (isWide())
                setBase<OpcodeSize::Wide>(value, func);
            else
                setBase<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setProperty(VirtualRegister value, Functor func)
        {
            if (isWide())
                setProperty<OpcodeSize::Wide>(value, func);
            else
                setProperty<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setProperty(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpGetByVal&)
            
            { }

            ValueProfile profile;
ArrayProfile arrayProfile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister base;
VirtualRegister property;
        unsigned metadataID;

        };

        struct OpPutByVal : public Instruction {
            static constexpr OpcodeID opcodeID = op_put_by_val;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister base, VirtualRegister property, VirtualRegister value)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, base, property, value, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, base, property, value, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister base, VirtualRegister property, VirtualRegister value)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, base, property, value, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister base, VirtualRegister property, VirtualRegister value, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, base, property, value, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister base, VirtualRegister property, VirtualRegister value, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(base) && Fits<VirtualRegister, size>::check(property) && Fits<VirtualRegister, size>::check(value) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(base));
__generator->write(Fits<VirtualRegister, size>::convert(property));
__generator->write(Fits<VirtualRegister, size>::convert(value));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*put_by_val"[!__isWide]);
                            __dumper->dumpOperand(base, true);

                __dumper->dumpOperand(property, false);

                __dumper->dumpOperand(value, false);

        }


                    OpPutByVal(const uint8_t* stream)
            : base(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
property(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
value(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpPutByVal(const uint32_t* stream)
            : base(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
property(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
value(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpPutByVal decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (isWide())
                setBase<OpcodeSize::Wide>(value, func);
            else
                setBase<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setProperty(VirtualRegister value, Functor func)
        {
            if (isWide())
                setProperty<OpcodeSize::Wide>(value, func);
            else
                setProperty<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setProperty(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (isWide())
                setValue<OpcodeSize::Wide>(value, func);
            else
                setValue<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpPutByVal&)
            
            { }

            ArrayProfile arrayProfile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister base;
VirtualRegister property;
VirtualRegister value;
        unsigned metadataID;

        };

        struct OpPutByValDirect : public Instruction {
            static constexpr OpcodeID opcodeID = op_put_by_val_direct;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister base, VirtualRegister property, VirtualRegister value)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, base, property, value, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, base, property, value, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister base, VirtualRegister property, VirtualRegister value)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, base, property, value, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister base, VirtualRegister property, VirtualRegister value, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, base, property, value, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister base, VirtualRegister property, VirtualRegister value, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(base) && Fits<VirtualRegister, size>::check(property) && Fits<VirtualRegister, size>::check(value) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(base));
__generator->write(Fits<VirtualRegister, size>::convert(property));
__generator->write(Fits<VirtualRegister, size>::convert(value));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*put_by_val_direct"[!__isWide]);
                            __dumper->dumpOperand(base, true);

                __dumper->dumpOperand(property, false);

                __dumper->dumpOperand(value, false);

        }


                    OpPutByValDirect(const uint8_t* stream)
            : base(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
property(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
value(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpPutByValDirect(const uint32_t* stream)
            : base(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
property(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
value(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpPutByValDirect decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (isWide())
                setBase<OpcodeSize::Wide>(value, func);
            else
                setBase<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setProperty(VirtualRegister value, Functor func)
        {
            if (isWide())
                setProperty<OpcodeSize::Wide>(value, func);
            else
                setProperty<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setProperty(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (isWide())
                setValue<OpcodeSize::Wide>(value, func);
            else
                setValue<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpPutByValDirect&)
            
            { }

            ArrayProfile arrayProfile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister base;
VirtualRegister property;
VirtualRegister value;
        unsigned metadataID;

        };

        struct OpJneqPtr : public Instruction {
            static constexpr OpcodeID opcodeID = op_jneq_ptr;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister value, Special::Pointer specialPointer, BoundLabel target)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, value, specialPointer, target, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, value, specialPointer, target, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister value, Special::Pointer specialPointer, BoundLabel target)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, value, specialPointer, target, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister value, Special::Pointer specialPointer, BoundLabel target, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, value, specialPointer, target, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister value, Special::Pointer specialPointer, BoundLabel target, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(value) && Fits<Special::Pointer, size>::check(specialPointer) && Fits<BoundLabel, size>::check(target) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(value));
__generator->write(Fits<Special::Pointer, size>::convert(specialPointer));
__generator->write(Fits<BoundLabel, size>::convert(target));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*jneq_ptr"[!__isWide]);
                            __dumper->dumpOperand(value, true);

                __dumper->dumpOperand(specialPointer, false);

                __dumper->dumpOperand(target, false);

        }


                    OpJneqPtr(const uint8_t* stream)
            : value(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
specialPointer(Fits<Special::Pointer, OpcodeSize::Narrow>::convert(stream[2])),
target(Fits<BoundLabel, OpcodeSize::Narrow>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpJneqPtr(const uint32_t* stream)
            : value(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
specialPointer(Fits<Special::Pointer, OpcodeSize::Wide>::convert(stream[2])),
target(Fits<BoundLabel, OpcodeSize::Wide>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpJneqPtr decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (isWide())
                setValue<OpcodeSize::Wide>(value, func);
            else
                setValue<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setSpecialPointer(Special::Pointer value, Functor func)
        {
            if (isWide())
                setSpecialPointer<OpcodeSize::Wide>(value, func);
            else
                setSpecialPointer<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setSpecialPointer(Special::Pointer value, Functor func)
        {
            if (!Fits<Special::Pointer, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<Special::Pointer, size>::convert(value);
        }

        template<typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (isWide())
                setTarget<OpcodeSize::Wide>(value, func);
            else
                setTarget<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (!Fits<BoundLabel, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<BoundLabel, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpJneqPtr&)
            
            { }

            bool hasJumped;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister value;
Special::Pointer specialPointer;
BoundLabel target;
        unsigned metadataID;

        };

        struct OpCall : public Instruction {
            static constexpr OpcodeID opcodeID = op_call;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, unsigned argc, unsigned argv)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, callee, argc, argv, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, callee, argc, argv, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, unsigned argc, unsigned argv)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, callee, argc, argv, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, unsigned argc, unsigned argv, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, callee, argc, argv, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, unsigned argc, unsigned argv, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(callee) && Fits<unsigned, size>::check(argc) && Fits<unsigned, size>::check(argv) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(callee));
__generator->write(Fits<unsigned, size>::convert(argc));
__generator->write(Fits<unsigned, size>::convert(argv));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*call"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(callee, false);

                __dumper->dumpOperand(argc, false);

                __dumper->dumpOperand(argv, false);

        }


                    OpCall(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
callee(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
argc(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3])),
argv(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[4])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[5]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpCall(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
callee(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
argc(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3])),
argv(Fits<unsigned, OpcodeSize::Wide>::convert(stream[4])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[5]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpCall decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setCallee(VirtualRegister value, Functor func)
        {
            if (isWide())
                setCallee<OpcodeSize::Wide>(value, func);
            else
                setCallee<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setCallee(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setArgc(unsigned value, Functor func)
        {
            if (isWide())
                setArgc<OpcodeSize::Wide>(value, func);
            else
                setArgc<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setArgc(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }

        template<typename Functor>
        void setArgv(unsigned value, Functor func)
        {
            if (isWide())
                setArgv<OpcodeSize::Wide>(value, func);
            else
                setArgv<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setArgv(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpCall&)
            
            { }

            LLIntCallLinkInfo callLinkInfo;
ArrayProfile arrayProfile;
ValueProfile profile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister callee;
unsigned argc;
unsigned argv;
        unsigned metadataID;

        };

        struct OpTailCall : public Instruction {
            static constexpr OpcodeID opcodeID = op_tail_call;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, unsigned argc, unsigned argv)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, callee, argc, argv, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, callee, argc, argv, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, unsigned argc, unsigned argv)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, callee, argc, argv, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, unsigned argc, unsigned argv, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, callee, argc, argv, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, unsigned argc, unsigned argv, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(callee) && Fits<unsigned, size>::check(argc) && Fits<unsigned, size>::check(argv) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(callee));
__generator->write(Fits<unsigned, size>::convert(argc));
__generator->write(Fits<unsigned, size>::convert(argv));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*tail_call"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(callee, false);

                __dumper->dumpOperand(argc, false);

                __dumper->dumpOperand(argv, false);

        }


                    OpTailCall(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
callee(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
argc(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3])),
argv(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[4])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[5]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpTailCall(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
callee(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
argc(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3])),
argv(Fits<unsigned, OpcodeSize::Wide>::convert(stream[4])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[5]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpTailCall decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setCallee(VirtualRegister value, Functor func)
        {
            if (isWide())
                setCallee<OpcodeSize::Wide>(value, func);
            else
                setCallee<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setCallee(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setArgc(unsigned value, Functor func)
        {
            if (isWide())
                setArgc<OpcodeSize::Wide>(value, func);
            else
                setArgc<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setArgc(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }

        template<typename Functor>
        void setArgv(unsigned value, Functor func)
        {
            if (isWide())
                setArgv<OpcodeSize::Wide>(value, func);
            else
                setArgv<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setArgv(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpTailCall&)
            
            { }

            LLIntCallLinkInfo callLinkInfo;
ArrayProfile arrayProfile;
ValueProfile profile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister callee;
unsigned argc;
unsigned argv;
        unsigned metadataID;

        };

        struct OpCallEval : public Instruction {
            static constexpr OpcodeID opcodeID = op_call_eval;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, unsigned argc, unsigned argv)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, callee, argc, argv, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, callee, argc, argv, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, unsigned argc, unsigned argv)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, callee, argc, argv, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, unsigned argc, unsigned argv, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, callee, argc, argv, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, unsigned argc, unsigned argv, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(callee) && Fits<unsigned, size>::check(argc) && Fits<unsigned, size>::check(argv) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(callee));
__generator->write(Fits<unsigned, size>::convert(argc));
__generator->write(Fits<unsigned, size>::convert(argv));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*call_eval"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(callee, false);

                __dumper->dumpOperand(argc, false);

                __dumper->dumpOperand(argv, false);

        }


                    OpCallEval(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
callee(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
argc(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3])),
argv(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[4])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[5]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpCallEval(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
callee(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
argc(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3])),
argv(Fits<unsigned, OpcodeSize::Wide>::convert(stream[4])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[5]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpCallEval decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setCallee(VirtualRegister value, Functor func)
        {
            if (isWide())
                setCallee<OpcodeSize::Wide>(value, func);
            else
                setCallee<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setCallee(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setArgc(unsigned value, Functor func)
        {
            if (isWide())
                setArgc<OpcodeSize::Wide>(value, func);
            else
                setArgc<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setArgc(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }

        template<typename Functor>
        void setArgv(unsigned value, Functor func)
        {
            if (isWide())
                setArgv<OpcodeSize::Wide>(value, func);
            else
                setArgv<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setArgv(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpCallEval&)
            
            { }

            LLIntCallLinkInfo callLinkInfo;
ArrayProfile arrayProfile;
ValueProfile profile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister callee;
unsigned argc;
unsigned argv;
        unsigned metadataID;

        };

        struct OpCallVarargs : public Instruction {
            static constexpr OpcodeID opcodeID = op_call_varargs;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, VirtualRegister thisValue, VirtualRegister arguments, VirtualRegister firstFree, int firstVarArg)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, callee, thisValue, arguments, firstFree, firstVarArg, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, callee, thisValue, arguments, firstFree, firstVarArg, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, VirtualRegister thisValue, VirtualRegister arguments, VirtualRegister firstFree, int firstVarArg)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, callee, thisValue, arguments, firstFree, firstVarArg, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, VirtualRegister thisValue, VirtualRegister arguments, VirtualRegister firstFree, int firstVarArg, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, callee, thisValue, arguments, firstFree, firstVarArg, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, VirtualRegister thisValue, VirtualRegister arguments, VirtualRegister firstFree, int firstVarArg, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(callee) && Fits<VirtualRegister, size>::check(thisValue) && Fits<VirtualRegister, size>::check(arguments) && Fits<VirtualRegister, size>::check(firstFree) && Fits<int, size>::check(firstVarArg) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(callee));
__generator->write(Fits<VirtualRegister, size>::convert(thisValue));
__generator->write(Fits<VirtualRegister, size>::convert(arguments));
__generator->write(Fits<VirtualRegister, size>::convert(firstFree));
__generator->write(Fits<int, size>::convert(firstVarArg));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*call_varargs"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(callee, false);

                __dumper->dumpOperand(thisValue, false);

                __dumper->dumpOperand(arguments, false);

                __dumper->dumpOperand(firstFree, false);

                __dumper->dumpOperand(firstVarArg, false);

        }


                    OpCallVarargs(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
callee(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
thisValue(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3])),
arguments(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[4])),
firstFree(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[5])),
firstVarArg(Fits<int, OpcodeSize::Narrow>::convert(stream[6])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[7]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpCallVarargs(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
callee(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
thisValue(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3])),
arguments(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[4])),
firstFree(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[5])),
firstVarArg(Fits<int, OpcodeSize::Wide>::convert(stream[6])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[7]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpCallVarargs decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setCallee(VirtualRegister value, Functor func)
        {
            if (isWide())
                setCallee<OpcodeSize::Wide>(value, func);
            else
                setCallee<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setCallee(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setThisValue(VirtualRegister value, Functor func)
        {
            if (isWide())
                setThisValue<OpcodeSize::Wide>(value, func);
            else
                setThisValue<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setThisValue(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setArguments(VirtualRegister value, Functor func)
        {
            if (isWide())
                setArguments<OpcodeSize::Wide>(value, func);
            else
                setArguments<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setArguments(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setFirstFree(VirtualRegister value, Functor func)
        {
            if (isWide())
                setFirstFree<OpcodeSize::Wide>(value, func);
            else
                setFirstFree<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setFirstFree(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 5 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setFirstVarArg(int value, Functor func)
        {
            if (isWide())
                setFirstVarArg<OpcodeSize::Wide>(value, func);
            else
                setFirstVarArg<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setFirstVarArg(int value, Functor func)
        {
            if (!Fits<int, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 6 * size + PaddingBySize<size>::value);
            *stream = Fits<int, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpCallVarargs&)
            
            { }

            ArrayProfile arrayProfile;
ValueProfile profile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister callee;
VirtualRegister thisValue;
VirtualRegister arguments;
VirtualRegister firstFree;
int firstVarArg;
        unsigned metadataID;

        };

        struct OpTailCallVarargs : public Instruction {
            static constexpr OpcodeID opcodeID = op_tail_call_varargs;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, VirtualRegister thisValue, VirtualRegister arguments, VirtualRegister firstFree, int firstVarArg)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, callee, thisValue, arguments, firstFree, firstVarArg, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, callee, thisValue, arguments, firstFree, firstVarArg, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, VirtualRegister thisValue, VirtualRegister arguments, VirtualRegister firstFree, int firstVarArg)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, callee, thisValue, arguments, firstFree, firstVarArg, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, VirtualRegister thisValue, VirtualRegister arguments, VirtualRegister firstFree, int firstVarArg, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, callee, thisValue, arguments, firstFree, firstVarArg, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, VirtualRegister thisValue, VirtualRegister arguments, VirtualRegister firstFree, int firstVarArg, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(callee) && Fits<VirtualRegister, size>::check(thisValue) && Fits<VirtualRegister, size>::check(arguments) && Fits<VirtualRegister, size>::check(firstFree) && Fits<int, size>::check(firstVarArg) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(callee));
__generator->write(Fits<VirtualRegister, size>::convert(thisValue));
__generator->write(Fits<VirtualRegister, size>::convert(arguments));
__generator->write(Fits<VirtualRegister, size>::convert(firstFree));
__generator->write(Fits<int, size>::convert(firstVarArg));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*tail_call_varargs"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(callee, false);

                __dumper->dumpOperand(thisValue, false);

                __dumper->dumpOperand(arguments, false);

                __dumper->dumpOperand(firstFree, false);

                __dumper->dumpOperand(firstVarArg, false);

        }


                    OpTailCallVarargs(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
callee(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
thisValue(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3])),
arguments(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[4])),
firstFree(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[5])),
firstVarArg(Fits<int, OpcodeSize::Narrow>::convert(stream[6])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[7]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpTailCallVarargs(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
callee(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
thisValue(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3])),
arguments(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[4])),
firstFree(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[5])),
firstVarArg(Fits<int, OpcodeSize::Wide>::convert(stream[6])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[7]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpTailCallVarargs decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setCallee(VirtualRegister value, Functor func)
        {
            if (isWide())
                setCallee<OpcodeSize::Wide>(value, func);
            else
                setCallee<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setCallee(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setThisValue(VirtualRegister value, Functor func)
        {
            if (isWide())
                setThisValue<OpcodeSize::Wide>(value, func);
            else
                setThisValue<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setThisValue(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setArguments(VirtualRegister value, Functor func)
        {
            if (isWide())
                setArguments<OpcodeSize::Wide>(value, func);
            else
                setArguments<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setArguments(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setFirstFree(VirtualRegister value, Functor func)
        {
            if (isWide())
                setFirstFree<OpcodeSize::Wide>(value, func);
            else
                setFirstFree<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setFirstFree(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 5 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setFirstVarArg(int value, Functor func)
        {
            if (isWide())
                setFirstVarArg<OpcodeSize::Wide>(value, func);
            else
                setFirstVarArg<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setFirstVarArg(int value, Functor func)
        {
            if (!Fits<int, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 6 * size + PaddingBySize<size>::value);
            *stream = Fits<int, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpTailCallVarargs&)
            
            { }

            ArrayProfile arrayProfile;
ValueProfile profile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister callee;
VirtualRegister thisValue;
VirtualRegister arguments;
VirtualRegister firstFree;
int firstVarArg;
        unsigned metadataID;

        };

        struct OpTailCallForwardArguments : public Instruction {
            static constexpr OpcodeID opcodeID = op_tail_call_forward_arguments;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, VirtualRegister thisValue, VirtualRegister arguments, VirtualRegister firstFree, int firstVarArg)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, callee, thisValue, arguments, firstFree, firstVarArg, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, callee, thisValue, arguments, firstFree, firstVarArg, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, VirtualRegister thisValue, VirtualRegister arguments, VirtualRegister firstFree, int firstVarArg)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, callee, thisValue, arguments, firstFree, firstVarArg, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, VirtualRegister thisValue, VirtualRegister arguments, VirtualRegister firstFree, int firstVarArg, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, callee, thisValue, arguments, firstFree, firstVarArg, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, VirtualRegister thisValue, VirtualRegister arguments, VirtualRegister firstFree, int firstVarArg, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(callee) && Fits<VirtualRegister, size>::check(thisValue) && Fits<VirtualRegister, size>::check(arguments) && Fits<VirtualRegister, size>::check(firstFree) && Fits<int, size>::check(firstVarArg) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(callee));
__generator->write(Fits<VirtualRegister, size>::convert(thisValue));
__generator->write(Fits<VirtualRegister, size>::convert(arguments));
__generator->write(Fits<VirtualRegister, size>::convert(firstFree));
__generator->write(Fits<int, size>::convert(firstVarArg));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*tail_call_forward_arguments"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(callee, false);

                __dumper->dumpOperand(thisValue, false);

                __dumper->dumpOperand(arguments, false);

                __dumper->dumpOperand(firstFree, false);

                __dumper->dumpOperand(firstVarArg, false);

        }


                    OpTailCallForwardArguments(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
callee(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
thisValue(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3])),
arguments(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[4])),
firstFree(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[5])),
firstVarArg(Fits<int, OpcodeSize::Narrow>::convert(stream[6])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[7]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpTailCallForwardArguments(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
callee(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
thisValue(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3])),
arguments(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[4])),
firstFree(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[5])),
firstVarArg(Fits<int, OpcodeSize::Wide>::convert(stream[6])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[7]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpTailCallForwardArguments decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setCallee(VirtualRegister value, Functor func)
        {
            if (isWide())
                setCallee<OpcodeSize::Wide>(value, func);
            else
                setCallee<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setCallee(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setThisValue(VirtualRegister value, Functor func)
        {
            if (isWide())
                setThisValue<OpcodeSize::Wide>(value, func);
            else
                setThisValue<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setThisValue(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setArguments(VirtualRegister value, Functor func)
        {
            if (isWide())
                setArguments<OpcodeSize::Wide>(value, func);
            else
                setArguments<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setArguments(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setFirstFree(VirtualRegister value, Functor func)
        {
            if (isWide())
                setFirstFree<OpcodeSize::Wide>(value, func);
            else
                setFirstFree<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setFirstFree(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 5 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setFirstVarArg(int value, Functor func)
        {
            if (isWide())
                setFirstVarArg<OpcodeSize::Wide>(value, func);
            else
                setFirstVarArg<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setFirstVarArg(int value, Functor func)
        {
            if (!Fits<int, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 6 * size + PaddingBySize<size>::value);
            *stream = Fits<int, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpTailCallForwardArguments&)
            
            { }

            ArrayProfile arrayProfile;
ValueProfile profile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister callee;
VirtualRegister thisValue;
VirtualRegister arguments;
VirtualRegister firstFree;
int firstVarArg;
        unsigned metadataID;

        };

        struct OpConstruct : public Instruction {
            static constexpr OpcodeID opcodeID = op_construct;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, unsigned argc, unsigned argv)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, callee, argc, argv, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, callee, argc, argv, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, unsigned argc, unsigned argv)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, callee, argc, argv, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, unsigned argc, unsigned argv, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, callee, argc, argv, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, unsigned argc, unsigned argv, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(callee) && Fits<unsigned, size>::check(argc) && Fits<unsigned, size>::check(argv) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(callee));
__generator->write(Fits<unsigned, size>::convert(argc));
__generator->write(Fits<unsigned, size>::convert(argv));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*construct"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(callee, false);

                __dumper->dumpOperand(argc, false);

                __dumper->dumpOperand(argv, false);

        }


                    OpConstruct(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
callee(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
argc(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3])),
argv(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[4])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[5]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpConstruct(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
callee(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
argc(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3])),
argv(Fits<unsigned, OpcodeSize::Wide>::convert(stream[4])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[5]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpConstruct decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setCallee(VirtualRegister value, Functor func)
        {
            if (isWide())
                setCallee<OpcodeSize::Wide>(value, func);
            else
                setCallee<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setCallee(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setArgc(unsigned value, Functor func)
        {
            if (isWide())
                setArgc<OpcodeSize::Wide>(value, func);
            else
                setArgc<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setArgc(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }

        template<typename Functor>
        void setArgv(unsigned value, Functor func)
        {
            if (isWide())
                setArgv<OpcodeSize::Wide>(value, func);
            else
                setArgv<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setArgv(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpConstruct&)
            
            { }

            LLIntCallLinkInfo callLinkInfo;
ArrayProfile arrayProfile;
ValueProfile profile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister callee;
unsigned argc;
unsigned argv;
        unsigned metadataID;

        };

        struct OpConstructVarargs : public Instruction {
            static constexpr OpcodeID opcodeID = op_construct_varargs;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, VirtualRegister thisValue, VirtualRegister arguments, VirtualRegister firstFree, int firstVarArg)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, callee, thisValue, arguments, firstFree, firstVarArg, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, callee, thisValue, arguments, firstFree, firstVarArg, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, VirtualRegister thisValue, VirtualRegister arguments, VirtualRegister firstFree, int firstVarArg)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, callee, thisValue, arguments, firstFree, firstVarArg, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, VirtualRegister thisValue, VirtualRegister arguments, VirtualRegister firstFree, int firstVarArg, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, callee, thisValue, arguments, firstFree, firstVarArg, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister callee, VirtualRegister thisValue, VirtualRegister arguments, VirtualRegister firstFree, int firstVarArg, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(callee) && Fits<VirtualRegister, size>::check(thisValue) && Fits<VirtualRegister, size>::check(arguments) && Fits<VirtualRegister, size>::check(firstFree) && Fits<int, size>::check(firstVarArg) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(callee));
__generator->write(Fits<VirtualRegister, size>::convert(thisValue));
__generator->write(Fits<VirtualRegister, size>::convert(arguments));
__generator->write(Fits<VirtualRegister, size>::convert(firstFree));
__generator->write(Fits<int, size>::convert(firstVarArg));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*construct_varargs"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(callee, false);

                __dumper->dumpOperand(thisValue, false);

                __dumper->dumpOperand(arguments, false);

                __dumper->dumpOperand(firstFree, false);

                __dumper->dumpOperand(firstVarArg, false);

        }


                    OpConstructVarargs(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
callee(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
thisValue(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3])),
arguments(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[4])),
firstFree(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[5])),
firstVarArg(Fits<int, OpcodeSize::Narrow>::convert(stream[6])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[7]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpConstructVarargs(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
callee(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
thisValue(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3])),
arguments(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[4])),
firstFree(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[5])),
firstVarArg(Fits<int, OpcodeSize::Wide>::convert(stream[6])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[7]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpConstructVarargs decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setCallee(VirtualRegister value, Functor func)
        {
            if (isWide())
                setCallee<OpcodeSize::Wide>(value, func);
            else
                setCallee<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setCallee(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setThisValue(VirtualRegister value, Functor func)
        {
            if (isWide())
                setThisValue<OpcodeSize::Wide>(value, func);
            else
                setThisValue<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setThisValue(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setArguments(VirtualRegister value, Functor func)
        {
            if (isWide())
                setArguments<OpcodeSize::Wide>(value, func);
            else
                setArguments<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setArguments(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setFirstFree(VirtualRegister value, Functor func)
        {
            if (isWide())
                setFirstFree<OpcodeSize::Wide>(value, func);
            else
                setFirstFree<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setFirstFree(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 5 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setFirstVarArg(int value, Functor func)
        {
            if (isWide())
                setFirstVarArg<OpcodeSize::Wide>(value, func);
            else
                setFirstVarArg<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setFirstVarArg(int value, Functor func)
        {
            if (!Fits<int, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 6 * size + PaddingBySize<size>::value);
            *stream = Fits<int, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpConstructVarargs&)
            
            { }

            ArrayProfile arrayProfile;
ValueProfile profile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister callee;
VirtualRegister thisValue;
VirtualRegister arguments;
VirtualRegister firstFree;
int firstVarArg;
        unsigned metadataID;

        };

        struct OpResolveScope : public Instruction {
            static constexpr OpcodeID opcodeID = op_resolve_scope;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned var, ResolveType resolveType, unsigned localScopeDepth)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, scope, var, resolveType, localScopeDepth, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, scope, var, resolveType, localScopeDepth, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned var, ResolveType resolveType, unsigned localScopeDepth)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, scope, var, resolveType, localScopeDepth, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned var, ResolveType resolveType, unsigned localScopeDepth, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, scope, var, resolveType, localScopeDepth, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned var, ResolveType resolveType, unsigned localScopeDepth, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(scope) && Fits<unsigned, size>::check(var) && Fits<ResolveType, size>::check(resolveType) && Fits<unsigned, size>::check(localScopeDepth) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(scope));
__generator->write(Fits<unsigned, size>::convert(var));
__generator->write(Fits<ResolveType, size>::convert(resolveType));
__generator->write(Fits<unsigned, size>::convert(localScopeDepth));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*resolve_scope"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(scope, false);

                __dumper->dumpOperand(var, false);

                __dumper->dumpOperand(resolveType, false);

                __dumper->dumpOperand(localScopeDepth, false);

        }


                    OpResolveScope(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
scope(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
var(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3])),
resolveType(Fits<ResolveType, OpcodeSize::Narrow>::convert(stream[4])),
localScopeDepth(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[5])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[6]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpResolveScope(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
scope(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
var(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3])),
resolveType(Fits<ResolveType, OpcodeSize::Wide>::convert(stream[4])),
localScopeDepth(Fits<unsigned, OpcodeSize::Wide>::convert(stream[5])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[6]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpResolveScope decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (isWide())
                setScope<OpcodeSize::Wide>(value, func);
            else
                setScope<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setVar(unsigned value, Functor func)
        {
            if (isWide())
                setVar<OpcodeSize::Wide>(value, func);
            else
                setVar<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setVar(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }

        template<typename Functor>
        void setResolveType(ResolveType value, Functor func)
        {
            if (isWide())
                setResolveType<OpcodeSize::Wide>(value, func);
            else
                setResolveType<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setResolveType(ResolveType value, Functor func)
        {
            if (!Fits<ResolveType, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<ResolveType, size>::convert(value);
        }

        template<typename Functor>
        void setLocalScopeDepth(unsigned value, Functor func)
        {
            if (isWide())
                setLocalScopeDepth<OpcodeSize::Wide>(value, func);
            else
                setLocalScopeDepth<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLocalScopeDepth(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 5 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpResolveScope&)
            
            { }

            ResolveType resolveType;
unsigned localScopeDepth;
union {
WriteBarrierBase<JSCell> lexicalEnvironment;
WriteBarrierBase<SymbolTable> symbolTable;
WriteBarrierBase<JSScope> constantScope;
JSGlobalLexicalEnvironment* globalLexicalEnvironment;
JSGlobalObject* globalObject;
};
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister scope;
unsigned var;
ResolveType resolveType;
unsigned localScopeDepth;
        unsigned metadataID;

        };

        struct OpGetFromScope : public Instruction {
            static constexpr OpcodeID opcodeID = op_get_from_scope;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned var, GetPutInfo getPutInfo, unsigned localScopeDepth, unsigned offset)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, scope, var, getPutInfo, localScopeDepth, offset, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, scope, var, getPutInfo, localScopeDepth, offset, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned var, GetPutInfo getPutInfo, unsigned localScopeDepth, unsigned offset)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, scope, var, getPutInfo, localScopeDepth, offset, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned var, GetPutInfo getPutInfo, unsigned localScopeDepth, unsigned offset, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, scope, var, getPutInfo, localScopeDepth, offset, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned var, GetPutInfo getPutInfo, unsigned localScopeDepth, unsigned offset, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(scope) && Fits<unsigned, size>::check(var) && Fits<GetPutInfo, size>::check(getPutInfo) && Fits<unsigned, size>::check(localScopeDepth) && Fits<unsigned, size>::check(offset) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(scope));
__generator->write(Fits<unsigned, size>::convert(var));
__generator->write(Fits<GetPutInfo, size>::convert(getPutInfo));
__generator->write(Fits<unsigned, size>::convert(localScopeDepth));
__generator->write(Fits<unsigned, size>::convert(offset));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*get_from_scope"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(scope, false);

                __dumper->dumpOperand(var, false);

                __dumper->dumpOperand(getPutInfo, false);

                __dumper->dumpOperand(localScopeDepth, false);

                __dumper->dumpOperand(offset, false);

        }


                    OpGetFromScope(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
scope(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
var(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3])),
getPutInfo(Fits<GetPutInfo, OpcodeSize::Narrow>::convert(stream[4])),
localScopeDepth(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[5])),
offset(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[6])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[7]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpGetFromScope(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
scope(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
var(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3])),
getPutInfo(Fits<GetPutInfo, OpcodeSize::Wide>::convert(stream[4])),
localScopeDepth(Fits<unsigned, OpcodeSize::Wide>::convert(stream[5])),
offset(Fits<unsigned, OpcodeSize::Wide>::convert(stream[6])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[7]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpGetFromScope decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (isWide())
                setScope<OpcodeSize::Wide>(value, func);
            else
                setScope<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setVar(unsigned value, Functor func)
        {
            if (isWide())
                setVar<OpcodeSize::Wide>(value, func);
            else
                setVar<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setVar(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }

        template<typename Functor>
        void setGetPutInfo(GetPutInfo value, Functor func)
        {
            if (isWide())
                setGetPutInfo<OpcodeSize::Wide>(value, func);
            else
                setGetPutInfo<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setGetPutInfo(GetPutInfo value, Functor func)
        {
            if (!Fits<GetPutInfo, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<GetPutInfo, size>::convert(value);
        }

        template<typename Functor>
        void setLocalScopeDepth(unsigned value, Functor func)
        {
            if (isWide())
                setLocalScopeDepth<OpcodeSize::Wide>(value, func);
            else
                setLocalScopeDepth<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLocalScopeDepth(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 5 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }

        template<typename Functor>
        void setOffset(unsigned value, Functor func)
        {
            if (isWide())
                setOffset<OpcodeSize::Wide>(value, func);
            else
                setOffset<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setOffset(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 6 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpGetFromScope& __op)
            : getPutInfo(__op.getPutInfo), operand(__op.offset)
            { }

            GetPutInfo getPutInfo;
union {
WatchpointSet* watchpointSet;
WriteBarrierBase<Structure> structure;
};
uintptr_t operand;
ValueProfile profile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister scope;
unsigned var;
GetPutInfo getPutInfo;
unsigned localScopeDepth;
unsigned offset;
        unsigned metadataID;

        };

        struct OpPutToScope : public Instruction {
            static constexpr OpcodeID opcodeID = op_put_to_scope;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister scope, unsigned var, VirtualRegister value, GetPutInfo getPutInfo, int symbolTableOrScopeDepth, unsigned offset)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, scope, var, value, getPutInfo, symbolTableOrScopeDepth, offset, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, scope, var, value, getPutInfo, symbolTableOrScopeDepth, offset, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister scope, unsigned var, VirtualRegister value, GetPutInfo getPutInfo, int symbolTableOrScopeDepth, unsigned offset)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, scope, var, value, getPutInfo, symbolTableOrScopeDepth, offset, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister scope, unsigned var, VirtualRegister value, GetPutInfo getPutInfo, int symbolTableOrScopeDepth, unsigned offset, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, scope, var, value, getPutInfo, symbolTableOrScopeDepth, offset, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister scope, unsigned var, VirtualRegister value, GetPutInfo getPutInfo, int symbolTableOrScopeDepth, unsigned offset, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(scope) && Fits<unsigned, size>::check(var) && Fits<VirtualRegister, size>::check(value) && Fits<GetPutInfo, size>::check(getPutInfo) && Fits<int, size>::check(symbolTableOrScopeDepth) && Fits<unsigned, size>::check(offset) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(scope));
__generator->write(Fits<unsigned, size>::convert(var));
__generator->write(Fits<VirtualRegister, size>::convert(value));
__generator->write(Fits<GetPutInfo, size>::convert(getPutInfo));
__generator->write(Fits<int, size>::convert(symbolTableOrScopeDepth));
__generator->write(Fits<unsigned, size>::convert(offset));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*put_to_scope"[!__isWide]);
                            __dumper->dumpOperand(scope, true);

                __dumper->dumpOperand(var, false);

                __dumper->dumpOperand(value, false);

                __dumper->dumpOperand(getPutInfo, false);

                __dumper->dumpOperand(symbolTableOrScopeDepth, false);

                __dumper->dumpOperand(offset, false);

        }


                    OpPutToScope(const uint8_t* stream)
            : scope(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
var(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[2])),
value(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3])),
getPutInfo(Fits<GetPutInfo, OpcodeSize::Narrow>::convert(stream[4])),
symbolTableOrScopeDepth(Fits<int, OpcodeSize::Narrow>::convert(stream[5])),
offset(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[6])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[7]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpPutToScope(const uint32_t* stream)
            : scope(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
var(Fits<unsigned, OpcodeSize::Wide>::convert(stream[2])),
value(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3])),
getPutInfo(Fits<GetPutInfo, OpcodeSize::Wide>::convert(stream[4])),
symbolTableOrScopeDepth(Fits<int, OpcodeSize::Wide>::convert(stream[5])),
offset(Fits<unsigned, OpcodeSize::Wide>::convert(stream[6])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[7]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpPutToScope decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (isWide())
                setScope<OpcodeSize::Wide>(value, func);
            else
                setScope<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setVar(unsigned value, Functor func)
        {
            if (isWide())
                setVar<OpcodeSize::Wide>(value, func);
            else
                setVar<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setVar(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }

        template<typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (isWide())
                setValue<OpcodeSize::Wide>(value, func);
            else
                setValue<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setGetPutInfo(GetPutInfo value, Functor func)
        {
            if (isWide())
                setGetPutInfo<OpcodeSize::Wide>(value, func);
            else
                setGetPutInfo<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setGetPutInfo(GetPutInfo value, Functor func)
        {
            if (!Fits<GetPutInfo, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<GetPutInfo, size>::convert(value);
        }

        template<typename Functor>
        void setSymbolTableOrScopeDepth(int value, Functor func)
        {
            if (isWide())
                setSymbolTableOrScopeDepth<OpcodeSize::Wide>(value, func);
            else
                setSymbolTableOrScopeDepth<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setSymbolTableOrScopeDepth(int value, Functor func)
        {
            if (!Fits<int, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 5 * size + PaddingBySize<size>::value);
            *stream = Fits<int, size>::convert(value);
        }

        template<typename Functor>
        void setOffset(unsigned value, Functor func)
        {
            if (isWide())
                setOffset<OpcodeSize::Wide>(value, func);
            else
                setOffset<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setOffset(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 6 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpPutToScope& __op)
            : getPutInfo(__op.getPutInfo), operand(__op.offset)
            { }

            GetPutInfo getPutInfo;
union {
WriteBarrierBase<Structure> structure;
WatchpointSet* watchpointSet;
};
uintptr_t operand;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister scope;
unsigned var;
VirtualRegister value;
GetPutInfo getPutInfo;
int symbolTableOrScopeDepth;
unsigned offset;
        unsigned metadataID;

        };

        struct OpGetFromArguments : public Instruction {
            static constexpr OpcodeID opcodeID = op_get_from_arguments;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister arguments, unsigned index)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, arguments, index, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, arguments, index, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister arguments, unsigned index)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, arguments, index, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister arguments, unsigned index, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, arguments, index, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister arguments, unsigned index, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(arguments) && Fits<unsigned, size>::check(index) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(arguments));
__generator->write(Fits<unsigned, size>::convert(index));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*get_from_arguments"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(arguments, false);

                __dumper->dumpOperand(index, false);

        }


                    OpGetFromArguments(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
arguments(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
index(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpGetFromArguments(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
arguments(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
index(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpGetFromArguments decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setArguments(VirtualRegister value, Functor func)
        {
            if (isWide())
                setArguments<OpcodeSize::Wide>(value, func);
            else
                setArguments<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setArguments(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setIndex(unsigned value, Functor func)
        {
            if (isWide())
                setIndex<OpcodeSize::Wide>(value, func);
            else
                setIndex<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setIndex(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpGetFromArguments&)
            
            { }

            ValueProfile profile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister arguments;
unsigned index;
        unsigned metadataID;

        };

        struct OpCatch : public Instruction {
            static constexpr OpcodeID opcodeID = op_catch;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister exception, VirtualRegister thrownValue)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, exception, thrownValue, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, exception, thrownValue, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister exception, VirtualRegister thrownValue)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, exception, thrownValue, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister exception, VirtualRegister thrownValue, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, exception, thrownValue, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister exception, VirtualRegister thrownValue, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(exception) && Fits<VirtualRegister, size>::check(thrownValue) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(exception));
__generator->write(Fits<VirtualRegister, size>::convert(thrownValue));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*catch"[!__isWide]);
                            __dumper->dumpOperand(exception, true);

                __dumper->dumpOperand(thrownValue, false);

        }


                    OpCatch(const uint8_t* stream)
            : exception(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
thrownValue(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpCatch(const uint32_t* stream)
            : exception(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
thrownValue(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpCatch decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setException(VirtualRegister value, Functor func)
        {
            if (isWide())
                setException<OpcodeSize::Wide>(value, func);
            else
                setException<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setException(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setThrownValue(VirtualRegister value, Functor func)
        {
            if (isWide())
                setThrownValue<OpcodeSize::Wide>(value, func);
            else
                setThrownValue<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setThrownValue(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpCatch&)
            
            { }

            ValueProfileAndOperandBuffer* buffer;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister exception;
VirtualRegister thrownValue;
        unsigned metadataID;

        };

        struct OpProfileType : public Instruction {
            static constexpr OpcodeID opcodeID = op_profile_type;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister target, int symbolTableOrScopeDepth, ProfileTypeBytecodeFlag flag, unsigned identifier, ResolveType resolveType)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, target, symbolTableOrScopeDepth, flag, identifier, resolveType, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, target, symbolTableOrScopeDepth, flag, identifier, resolveType, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister target, int symbolTableOrScopeDepth, ProfileTypeBytecodeFlag flag, unsigned identifier, ResolveType resolveType)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, target, symbolTableOrScopeDepth, flag, identifier, resolveType, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister target, int symbolTableOrScopeDepth, ProfileTypeBytecodeFlag flag, unsigned identifier, ResolveType resolveType, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, target, symbolTableOrScopeDepth, flag, identifier, resolveType, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister target, int symbolTableOrScopeDepth, ProfileTypeBytecodeFlag flag, unsigned identifier, ResolveType resolveType, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(target) && Fits<int, size>::check(symbolTableOrScopeDepth) && Fits<ProfileTypeBytecodeFlag, size>::check(flag) && Fits<unsigned, size>::check(identifier) && Fits<ResolveType, size>::check(resolveType) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(target));
__generator->write(Fits<int, size>::convert(symbolTableOrScopeDepth));
__generator->write(Fits<ProfileTypeBytecodeFlag, size>::convert(flag));
__generator->write(Fits<unsigned, size>::convert(identifier));
__generator->write(Fits<ResolveType, size>::convert(resolveType));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*profile_type"[!__isWide]);
                            __dumper->dumpOperand(target, true);

                __dumper->dumpOperand(symbolTableOrScopeDepth, false);

                __dumper->dumpOperand(flag, false);

                __dumper->dumpOperand(identifier, false);

                __dumper->dumpOperand(resolveType, false);

        }


                    OpProfileType(const uint8_t* stream)
            : target(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
symbolTableOrScopeDepth(Fits<int, OpcodeSize::Narrow>::convert(stream[2])),
flag(Fits<ProfileTypeBytecodeFlag, OpcodeSize::Narrow>::convert(stream[3])),
identifier(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[4])),
resolveType(Fits<ResolveType, OpcodeSize::Narrow>::convert(stream[5])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[6]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpProfileType(const uint32_t* stream)
            : target(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
symbolTableOrScopeDepth(Fits<int, OpcodeSize::Wide>::convert(stream[2])),
flag(Fits<ProfileTypeBytecodeFlag, OpcodeSize::Wide>::convert(stream[3])),
identifier(Fits<unsigned, OpcodeSize::Wide>::convert(stream[4])),
resolveType(Fits<ResolveType, OpcodeSize::Wide>::convert(stream[5])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[6]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpProfileType decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setTarget(VirtualRegister value, Functor func)
        {
            if (isWide())
                setTarget<OpcodeSize::Wide>(value, func);
            else
                setTarget<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setTarget(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setSymbolTableOrScopeDepth(int value, Functor func)
        {
            if (isWide())
                setSymbolTableOrScopeDepth<OpcodeSize::Wide>(value, func);
            else
                setSymbolTableOrScopeDepth<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setSymbolTableOrScopeDepth(int value, Functor func)
        {
            if (!Fits<int, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<int, size>::convert(value);
        }

        template<typename Functor>
        void setFlag(ProfileTypeBytecodeFlag value, Functor func)
        {
            if (isWide())
                setFlag<OpcodeSize::Wide>(value, func);
            else
                setFlag<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setFlag(ProfileTypeBytecodeFlag value, Functor func)
        {
            if (!Fits<ProfileTypeBytecodeFlag, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<ProfileTypeBytecodeFlag, size>::convert(value);
        }

        template<typename Functor>
        void setIdentifier(unsigned value, Functor func)
        {
            if (isWide())
                setIdentifier<OpcodeSize::Wide>(value, func);
            else
                setIdentifier<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setIdentifier(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }

        template<typename Functor>
        void setResolveType(ResolveType value, Functor func)
        {
            if (isWide())
                setResolveType<OpcodeSize::Wide>(value, func);
            else
                setResolveType<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setResolveType(ResolveType value, Functor func)
        {
            if (!Fits<ResolveType, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 5 * size + PaddingBySize<size>::value);
            *stream = Fits<ResolveType, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpProfileType&)
            
            { }

            TypeLocation* typeLocation;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister target;
int symbolTableOrScopeDepth;
ProfileTypeBytecodeFlag flag;
unsigned identifier;
ResolveType resolveType;
        unsigned metadataID;

        };

        struct OpProfileControlFlow : public Instruction {
            static constexpr OpcodeID opcodeID = op_profile_control_flow;

                    static void emit(BytecodeGenerator* __generator, int textOffset)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, textOffset, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, textOffset, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, int textOffset)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, textOffset, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, int textOffset, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, textOffset, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, int textOffset, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<int, size>::check(textOffset) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<int, size>::convert(textOffset));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*profile_control_flow"[!__isWide]);
                            __dumper->dumpOperand(textOffset, true);

        }


                    OpProfileControlFlow(const uint8_t* stream)
            : textOffset(Fits<int, OpcodeSize::Narrow>::convert(stream[1])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpProfileControlFlow(const uint32_t* stream)
            : textOffset(Fits<int, OpcodeSize::Wide>::convert(stream[1])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpProfileControlFlow decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setTextOffset(int value, Functor func)
        {
            if (isWide())
                setTextOffset<OpcodeSize::Wide>(value, func);
            else
                setTextOffset<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setTextOffset(int value, Functor func)
        {
            if (!Fits<int, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<int, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpProfileControlFlow&)
            
            { }

            BasicBlockLocation* basicBlockLocation;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    int textOffset;
        unsigned metadataID;

        };

        struct OpHasIndexedProperty : public Instruction {
            static constexpr OpcodeID opcodeID = op_has_indexed_property;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister property)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, base, property, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, base, property, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister property)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, base, property, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister property, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, base, property, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister property, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(base) && Fits<VirtualRegister, size>::check(property) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(base));
__generator->write(Fits<VirtualRegister, size>::convert(property));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*has_indexed_property"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(base, false);

                __dumper->dumpOperand(property, false);

        }


                    OpHasIndexedProperty(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
property(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpHasIndexedProperty(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
property(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpHasIndexedProperty decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (isWide())
                setBase<OpcodeSize::Wide>(value, func);
            else
                setBase<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setProperty(VirtualRegister value, Functor func)
        {
            if (isWide())
                setProperty<OpcodeSize::Wide>(value, func);
            else
                setProperty<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setProperty(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpHasIndexedProperty&)
            
            { }

            ArrayProfile arrayProfile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister base;
VirtualRegister property;
        unsigned metadataID;

        };

        struct OpGetDirectPname : public Instruction {
            static constexpr OpcodeID opcodeID = op_get_direct_pname;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister property, VirtualRegister index, VirtualRegister enumerator)
        {
            __generator->recordOpcode(opcodeID);
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, base, property, index, enumerator, __metadataID) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, base, property, index, enumerator, __metadataID);
        }

        
        template<OpcodeSize size, FitsAssertion shouldAssert = Assert>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister property, VirtualRegister index, VirtualRegister enumerator)
        {
                    auto __metadataID = __generator->addMetadataFor(opcodeID);

            return emit<size, shouldAssert>(__generator, dst, base, property, index, enumerator, __metadataID);
        }
        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister property, VirtualRegister index, VirtualRegister enumerator, unsigned __metadataID)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, base, property, index, enumerator, __metadataID);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister property, VirtualRegister index, VirtualRegister enumerator, unsigned __metadataID)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(base) && Fits<VirtualRegister, size>::check(property) && Fits<VirtualRegister, size>::check(index) && Fits<VirtualRegister, size>::check(enumerator) && Fits<unsigned, size>::check(__metadataID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(base));
__generator->write(Fits<VirtualRegister, size>::convert(property));
__generator->write(Fits<VirtualRegister, size>::convert(index));
__generator->write(Fits<VirtualRegister, size>::convert(enumerator));
__generator->write(Fits<unsigned, size>::convert(__metadataID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*get_direct_pname"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(base, false);

                __dumper->dumpOperand(property, false);

                __dumper->dumpOperand(index, false);

                __dumper->dumpOperand(enumerator, false);

        }


                    OpGetDirectPname(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
property(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3])),
index(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[4])),
enumerator(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[5])),
metadataID(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[6]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpGetDirectPname(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
property(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3])),
index(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[4])),
enumerator(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[5])),
metadataID(Fits<unsigned, OpcodeSize::Wide>::convert(stream[6]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpGetDirectPname decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (isWide())
                setBase<OpcodeSize::Wide>(value, func);
            else
                setBase<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setProperty(VirtualRegister value, Functor func)
        {
            if (isWide())
                setProperty<OpcodeSize::Wide>(value, func);
            else
                setProperty<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setProperty(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setIndex(VirtualRegister value, Functor func)
        {
            if (isWide())
                setIndex<OpcodeSize::Wide>(value, func);
            else
                setIndex<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setIndex(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setEnumerator(VirtualRegister value, Functor func)
        {
            if (isWide())
                setEnumerator<OpcodeSize::Wide>(value, func);
            else
                setEnumerator<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setEnumerator(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 5 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                            struct Metadata {
            WTF_MAKE_NONCOPYABLE(Metadata);

        public:
            Metadata(const OpGetDirectPname&)
            
            { }

            ValueProfile profile;
        };


                Metadata& metadata(CodeBlock* codeBlock) const
        {
            return codeBlock->metadata<Metadata>(opcodeID, metadataID);
        }

        Metadata& metadata(ExecState* exec) const
        {
            return metadata(exec->codeBlock());
        }



                    VirtualRegister dst;
VirtualRegister base;
VirtualRegister property;
VirtualRegister index;
VirtualRegister enumerator;
        unsigned metadataID;

        };

        struct OpWide : public Instruction {
            static constexpr OpcodeID opcodeID = op_wide;

                    static void emit(BytecodeGenerator* __generator)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator) || emit<OpcodeSize::Wide, Assert, false>(__generator);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*wide"[!__isWide]);
            
        }


                    OpWide(const uint8_t* stream)
            
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpWide(const uint32_t* stream)
            
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpWide decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



            

                    

        


                    
        

        };

        struct OpEnter : public Instruction {
            static constexpr OpcodeID opcodeID = op_enter;

                    static void emit(BytecodeGenerator* __generator)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator) || emit<OpcodeSize::Wide, Assert, false>(__generator);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*enter"[!__isWide]);
            
        }


                    OpEnter(const uint8_t* stream)
            
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpEnter(const uint32_t* stream)
            
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpEnter decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



            

                    

        


                    
        

        };

        struct OpGetScope : public Instruction {
            static constexpr OpcodeID opcodeID = op_get_scope;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*get_scope"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

        }


                    OpGetScope(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpGetScope(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpGetScope decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
        

        };

        struct OpCreateDirectArguments : public Instruction {
            static constexpr OpcodeID opcodeID = op_create_direct_arguments;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*create_direct_arguments"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

        }


                    OpCreateDirectArguments(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpCreateDirectArguments(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpCreateDirectArguments decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
        

        };

        struct OpCreateScopedArguments : public Instruction {
            static constexpr OpcodeID opcodeID = op_create_scoped_arguments;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, scope) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, scope);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, scope);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(scope) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(scope));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*create_scoped_arguments"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(scope, false);

        }


                    OpCreateScopedArguments(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
scope(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpCreateScopedArguments(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
scope(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpCreateScopedArguments decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (isWide())
                setScope<OpcodeSize::Wide>(value, func);
            else
                setScope<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister scope;
        

        };

        struct OpCreateClonedArguments : public Instruction {
            static constexpr OpcodeID opcodeID = op_create_cloned_arguments;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*create_cloned_arguments"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

        }


                    OpCreateClonedArguments(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpCreateClonedArguments(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpCreateClonedArguments decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
        

        };

        struct OpArgumentCount : public Instruction {
            static constexpr OpcodeID opcodeID = op_argument_count;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*argument_count"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

        }


                    OpArgumentCount(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpArgumentCount(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpArgumentCount decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
        

        };

        struct OpCheckTdz : public Instruction {
            static constexpr OpcodeID opcodeID = op_check_tdz;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister target)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, target) || emit<OpcodeSize::Wide, Assert, false>(__generator, target);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister target)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, target);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister target)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(target) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(target));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*check_tdz"[!__isWide]);
                            __dumper->dumpOperand(target, true);

        }


                    OpCheckTdz(const uint8_t* stream)
            : target(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpCheckTdz(const uint32_t* stream)
            : target(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpCheckTdz decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setTarget(VirtualRegister value, Functor func)
        {
            if (isWide())
                setTarget<OpcodeSize::Wide>(value, func);
            else
                setTarget<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setTarget(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister target;
        

        };

        struct OpNewArrayWithSpread : public Instruction {
            static constexpr OpcodeID opcodeID = op_new_array_with_spread;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister argv, unsigned argc, unsigned bitVector)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, argv, argc, bitVector) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, argv, argc, bitVector);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister argv, unsigned argc, unsigned bitVector)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, argv, argc, bitVector);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister argv, unsigned argc, unsigned bitVector)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(argv) && Fits<unsigned, size>::check(argc) && Fits<unsigned, size>::check(bitVector) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(argv));
__generator->write(Fits<unsigned, size>::convert(argc));
__generator->write(Fits<unsigned, size>::convert(bitVector));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*new_array_with_spread"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(argv, false);

                __dumper->dumpOperand(argc, false);

                __dumper->dumpOperand(bitVector, false);

        }


                    OpNewArrayWithSpread(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
argv(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
argc(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3])),
bitVector(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpNewArrayWithSpread(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
argv(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
argc(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3])),
bitVector(Fits<unsigned, OpcodeSize::Wide>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpNewArrayWithSpread decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setArgv(VirtualRegister value, Functor func)
        {
            if (isWide())
                setArgv<OpcodeSize::Wide>(value, func);
            else
                setArgv<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setArgv(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setArgc(unsigned value, Functor func)
        {
            if (isWide())
                setArgc<OpcodeSize::Wide>(value, func);
            else
                setArgc<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setArgc(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }

        template<typename Functor>
        void setBitVector(unsigned value, Functor func)
        {
            if (isWide())
                setBitVector<OpcodeSize::Wide>(value, func);
            else
                setBitVector<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setBitVector(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister argv;
unsigned argc;
unsigned bitVector;
        

        };

        struct OpSpread : public Instruction {
            static constexpr OpcodeID opcodeID = op_spread;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister argument)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, argument) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, argument);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister argument)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, argument);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister argument)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(argument) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(argument));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*spread"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(argument, false);

        }


                    OpSpread(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
argument(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpSpread(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
argument(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpSpread decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setArgument(VirtualRegister value, Functor func)
        {
            if (isWide())
                setArgument<OpcodeSize::Wide>(value, func);
            else
                setArgument<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setArgument(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister argument;
        

        };

        struct OpNewRegexp : public Instruction {
            static constexpr OpcodeID opcodeID = op_new_regexp;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister regexp)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, regexp) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, regexp);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister regexp)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, regexp);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister regexp)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(regexp) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(regexp));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*new_regexp"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(regexp, false);

        }


                    OpNewRegexp(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
regexp(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpNewRegexp(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
regexp(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpNewRegexp decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRegexp(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRegexp<OpcodeSize::Wide>(value, func);
            else
                setRegexp<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRegexp(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister regexp;
        

        };

        struct OpMov : public Instruction {
            static constexpr OpcodeID opcodeID = op_mov;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister src)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, src) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, src);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister src)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, src);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister src)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(src) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(src));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*mov"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(src, false);

        }


                    OpMov(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
src(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpMov(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
src(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpMov decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setSrc(VirtualRegister value, Functor func)
        {
            if (isWide())
                setSrc<OpcodeSize::Wide>(value, func);
            else
                setSrc<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setSrc(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister src;
        

        };

        struct OpEq : public Instruction {
            static constexpr OpcodeID opcodeID = op_eq;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, lhs, rhs) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, lhs, rhs);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, lhs, rhs);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*eq"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(lhs, false);

                __dumper->dumpOperand(rhs, false);

        }


                    OpEq(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpEq(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpEq decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister lhs;
VirtualRegister rhs;
        

        };

        struct OpNeq : public Instruction {
            static constexpr OpcodeID opcodeID = op_neq;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, lhs, rhs) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, lhs, rhs);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, lhs, rhs);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*neq"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(lhs, false);

                __dumper->dumpOperand(rhs, false);

        }


                    OpNeq(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpNeq(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpNeq decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister lhs;
VirtualRegister rhs;
        

        };

        struct OpStricteq : public Instruction {
            static constexpr OpcodeID opcodeID = op_stricteq;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, lhs, rhs) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, lhs, rhs);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, lhs, rhs);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*stricteq"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(lhs, false);

                __dumper->dumpOperand(rhs, false);

        }


                    OpStricteq(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpStricteq(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpStricteq decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister lhs;
VirtualRegister rhs;
        

        };

        struct OpNstricteq : public Instruction {
            static constexpr OpcodeID opcodeID = op_nstricteq;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, lhs, rhs) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, lhs, rhs);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, lhs, rhs);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*nstricteq"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(lhs, false);

                __dumper->dumpOperand(rhs, false);

        }


                    OpNstricteq(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpNstricteq(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpNstricteq decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister lhs;
VirtualRegister rhs;
        

        };

        struct OpLess : public Instruction {
            static constexpr OpcodeID opcodeID = op_less;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, lhs, rhs) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, lhs, rhs);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, lhs, rhs);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*less"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(lhs, false);

                __dumper->dumpOperand(rhs, false);

        }


                    OpLess(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpLess(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpLess decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister lhs;
VirtualRegister rhs;
        

        };

        struct OpLesseq : public Instruction {
            static constexpr OpcodeID opcodeID = op_lesseq;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, lhs, rhs) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, lhs, rhs);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, lhs, rhs);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*lesseq"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(lhs, false);

                __dumper->dumpOperand(rhs, false);

        }


                    OpLesseq(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpLesseq(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpLesseq decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister lhs;
VirtualRegister rhs;
        

        };

        struct OpGreater : public Instruction {
            static constexpr OpcodeID opcodeID = op_greater;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, lhs, rhs) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, lhs, rhs);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, lhs, rhs);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*greater"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(lhs, false);

                __dumper->dumpOperand(rhs, false);

        }


                    OpGreater(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpGreater(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpGreater decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister lhs;
VirtualRegister rhs;
        

        };

        struct OpGreatereq : public Instruction {
            static constexpr OpcodeID opcodeID = op_greatereq;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, lhs, rhs) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, lhs, rhs);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, lhs, rhs);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*greatereq"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(lhs, false);

                __dumper->dumpOperand(rhs, false);

        }


                    OpGreatereq(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpGreatereq(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpGreatereq decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister lhs;
VirtualRegister rhs;
        

        };

        struct OpBelow : public Instruction {
            static constexpr OpcodeID opcodeID = op_below;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, lhs, rhs) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, lhs, rhs);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, lhs, rhs);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*below"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(lhs, false);

                __dumper->dumpOperand(rhs, false);

        }


                    OpBelow(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpBelow(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpBelow decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister lhs;
VirtualRegister rhs;
        

        };

        struct OpBeloweq : public Instruction {
            static constexpr OpcodeID opcodeID = op_beloweq;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, lhs, rhs) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, lhs, rhs);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, lhs, rhs);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*beloweq"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(lhs, false);

                __dumper->dumpOperand(rhs, false);

        }


                    OpBeloweq(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpBeloweq(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpBeloweq decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister lhs;
VirtualRegister rhs;
        

        };

        struct OpMod : public Instruction {
            static constexpr OpcodeID opcodeID = op_mod;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, lhs, rhs) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, lhs, rhs);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, lhs, rhs);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*mod"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(lhs, false);

                __dumper->dumpOperand(rhs, false);

        }


                    OpMod(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpMod(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpMod decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister lhs;
VirtualRegister rhs;
        

        };

        struct OpPow : public Instruction {
            static constexpr OpcodeID opcodeID = op_pow;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, lhs, rhs) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, lhs, rhs);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, lhs, rhs);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*pow"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(lhs, false);

                __dumper->dumpOperand(rhs, false);

        }


                    OpPow(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpPow(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpPow decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister lhs;
VirtualRegister rhs;
        

        };

        struct OpLshift : public Instruction {
            static constexpr OpcodeID opcodeID = op_lshift;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, lhs, rhs) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, lhs, rhs);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, lhs, rhs);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*lshift"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(lhs, false);

                __dumper->dumpOperand(rhs, false);

        }


                    OpLshift(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpLshift(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpLshift decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister lhs;
VirtualRegister rhs;
        

        };

        struct OpRshift : public Instruction {
            static constexpr OpcodeID opcodeID = op_rshift;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, lhs, rhs) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, lhs, rhs);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, lhs, rhs);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*rshift"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(lhs, false);

                __dumper->dumpOperand(rhs, false);

        }


                    OpRshift(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpRshift(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpRshift decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister lhs;
VirtualRegister rhs;
        

        };

        struct OpUrshift : public Instruction {
            static constexpr OpcodeID opcodeID = op_urshift;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, lhs, rhs) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, lhs, rhs);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, lhs, rhs);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister lhs, VirtualRegister rhs)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*urshift"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(lhs, false);

                __dumper->dumpOperand(rhs, false);

        }


                    OpUrshift(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpUrshift(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpUrshift decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister lhs;
VirtualRegister rhs;
        

        };

        struct OpEqNull : public Instruction {
            static constexpr OpcodeID opcodeID = op_eq_null;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, operand) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, operand);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, operand);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(operand) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(operand));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*eq_null"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(operand, false);

        }


                    OpEqNull(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpEqNull(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpEqNull decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (isWide())
                setOperand<OpcodeSize::Wide>(value, func);
            else
                setOperand<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister operand;
        

        };

        struct OpNeqNull : public Instruction {
            static constexpr OpcodeID opcodeID = op_neq_null;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, operand) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, operand);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, operand);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(operand) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(operand));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*neq_null"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(operand, false);

        }


                    OpNeqNull(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpNeqNull(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpNeqNull decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (isWide())
                setOperand<OpcodeSize::Wide>(value, func);
            else
                setOperand<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister operand;
        

        };

        struct OpToString : public Instruction {
            static constexpr OpcodeID opcodeID = op_to_string;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, operand) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, operand);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, operand);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(operand) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(operand));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*to_string"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(operand, false);

        }


                    OpToString(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpToString(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpToString decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (isWide())
                setOperand<OpcodeSize::Wide>(value, func);
            else
                setOperand<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister operand;
        

        };

        struct OpUnsigned : public Instruction {
            static constexpr OpcodeID opcodeID = op_unsigned;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, operand) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, operand);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, operand);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(operand) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(operand));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*unsigned"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(operand, false);

        }


                    OpUnsigned(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpUnsigned(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpUnsigned decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (isWide())
                setOperand<OpcodeSize::Wide>(value, func);
            else
                setOperand<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister operand;
        

        };

        struct OpIsEmpty : public Instruction {
            static constexpr OpcodeID opcodeID = op_is_empty;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, operand) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, operand);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, operand);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(operand) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(operand));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*is_empty"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(operand, false);

        }


                    OpIsEmpty(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpIsEmpty(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpIsEmpty decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (isWide())
                setOperand<OpcodeSize::Wide>(value, func);
            else
                setOperand<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister operand;
        

        };

        struct OpIsUndefined : public Instruction {
            static constexpr OpcodeID opcodeID = op_is_undefined;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, operand) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, operand);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, operand);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(operand) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(operand));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*is_undefined"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(operand, false);

        }


                    OpIsUndefined(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpIsUndefined(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpIsUndefined decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (isWide())
                setOperand<OpcodeSize::Wide>(value, func);
            else
                setOperand<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister operand;
        

        };

        struct OpIsBoolean : public Instruction {
            static constexpr OpcodeID opcodeID = op_is_boolean;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, operand) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, operand);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, operand);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(operand) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(operand));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*is_boolean"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(operand, false);

        }


                    OpIsBoolean(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpIsBoolean(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpIsBoolean decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (isWide())
                setOperand<OpcodeSize::Wide>(value, func);
            else
                setOperand<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister operand;
        

        };

        struct OpIsNumber : public Instruction {
            static constexpr OpcodeID opcodeID = op_is_number;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, operand) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, operand);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, operand);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(operand) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(operand));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*is_number"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(operand, false);

        }


                    OpIsNumber(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpIsNumber(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpIsNumber decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (isWide())
                setOperand<OpcodeSize::Wide>(value, func);
            else
                setOperand<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister operand;
        

        };

        struct OpIsObject : public Instruction {
            static constexpr OpcodeID opcodeID = op_is_object;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, operand) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, operand);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, operand);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(operand) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(operand));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*is_object"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(operand, false);

        }


                    OpIsObject(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpIsObject(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpIsObject decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (isWide())
                setOperand<OpcodeSize::Wide>(value, func);
            else
                setOperand<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister operand;
        

        };

        struct OpIsObjectOrNull : public Instruction {
            static constexpr OpcodeID opcodeID = op_is_object_or_null;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, operand) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, operand);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, operand);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(operand) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(operand));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*is_object_or_null"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(operand, false);

        }


                    OpIsObjectOrNull(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpIsObjectOrNull(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpIsObjectOrNull decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (isWide())
                setOperand<OpcodeSize::Wide>(value, func);
            else
                setOperand<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister operand;
        

        };

        struct OpIsFunction : public Instruction {
            static constexpr OpcodeID opcodeID = op_is_function;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, operand) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, operand);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, operand);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(operand) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(operand));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*is_function"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(operand, false);

        }


                    OpIsFunction(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpIsFunction(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpIsFunction decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (isWide())
                setOperand<OpcodeSize::Wide>(value, func);
            else
                setOperand<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister operand;
        

        };

        struct OpInc : public Instruction {
            static constexpr OpcodeID opcodeID = op_inc;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister srcDst)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, srcDst) || emit<OpcodeSize::Wide, Assert, false>(__generator, srcDst);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister srcDst)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, srcDst);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister srcDst)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(srcDst) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(srcDst));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*inc"[!__isWide]);
                            __dumper->dumpOperand(srcDst, true);

        }


                    OpInc(const uint8_t* stream)
            : srcDst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpInc(const uint32_t* stream)
            : srcDst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpInc decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setSrcDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setSrcDst<OpcodeSize::Wide>(value, func);
            else
                setSrcDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setSrcDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister srcDst;
        

        };

        struct OpDec : public Instruction {
            static constexpr OpcodeID opcodeID = op_dec;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister srcDst)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, srcDst) || emit<OpcodeSize::Wide, Assert, false>(__generator, srcDst);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister srcDst)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, srcDst);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister srcDst)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(srcDst) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(srcDst));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*dec"[!__isWide]);
                            __dumper->dumpOperand(srcDst, true);

        }


                    OpDec(const uint8_t* stream)
            : srcDst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpDec(const uint32_t* stream)
            : srcDst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpDec decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setSrcDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setSrcDst<OpcodeSize::Wide>(value, func);
            else
                setSrcDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setSrcDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister srcDst;
        

        };

        struct OpNot : public Instruction {
            static constexpr OpcodeID opcodeID = op_not;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, operand) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, operand);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, operand);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(operand) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(operand));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*not"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(operand, false);

        }


                    OpNot(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpNot(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpNot decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (isWide())
                setOperand<OpcodeSize::Wide>(value, func);
            else
                setOperand<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister operand;
        

        };

        struct OpIdentityWithProfile : public Instruction {
            static constexpr OpcodeID opcodeID = op_identity_with_profile;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister srcDst, unsigned topProfile, unsigned bottomProfile)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, srcDst, topProfile, bottomProfile) || emit<OpcodeSize::Wide, Assert, false>(__generator, srcDst, topProfile, bottomProfile);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister srcDst, unsigned topProfile, unsigned bottomProfile)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, srcDst, topProfile, bottomProfile);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister srcDst, unsigned topProfile, unsigned bottomProfile)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(srcDst) && Fits<unsigned, size>::check(topProfile) && Fits<unsigned, size>::check(bottomProfile) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(srcDst));
__generator->write(Fits<unsigned, size>::convert(topProfile));
__generator->write(Fits<unsigned, size>::convert(bottomProfile));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*identity_with_profile"[!__isWide]);
                            __dumper->dumpOperand(srcDst, true);

                __dumper->dumpOperand(topProfile, false);

                __dumper->dumpOperand(bottomProfile, false);

        }


                    OpIdentityWithProfile(const uint8_t* stream)
            : srcDst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
topProfile(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[2])),
bottomProfile(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpIdentityWithProfile(const uint32_t* stream)
            : srcDst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
topProfile(Fits<unsigned, OpcodeSize::Wide>::convert(stream[2])),
bottomProfile(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpIdentityWithProfile decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setSrcDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setSrcDst<OpcodeSize::Wide>(value, func);
            else
                setSrcDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setSrcDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setTopProfile(unsigned value, Functor func)
        {
            if (isWide())
                setTopProfile<OpcodeSize::Wide>(value, func);
            else
                setTopProfile<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setTopProfile(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }

        template<typename Functor>
        void setBottomProfile(unsigned value, Functor func)
        {
            if (isWide())
                setBottomProfile<OpcodeSize::Wide>(value, func);
            else
                setBottomProfile<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setBottomProfile(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }


                    

        


                    VirtualRegister srcDst;
unsigned topProfile;
unsigned bottomProfile;
        

        };

        struct OpOverridesHasInstance : public Instruction {
            static constexpr OpcodeID opcodeID = op_overrides_has_instance;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister constructor, VirtualRegister hasInstanceValue)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, constructor, hasInstanceValue) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, constructor, hasInstanceValue);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister constructor, VirtualRegister hasInstanceValue)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, constructor, hasInstanceValue);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister constructor, VirtualRegister hasInstanceValue)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(constructor) && Fits<VirtualRegister, size>::check(hasInstanceValue) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(constructor));
__generator->write(Fits<VirtualRegister, size>::convert(hasInstanceValue));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*overrides_has_instance"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(constructor, false);

                __dumper->dumpOperand(hasInstanceValue, false);

        }


                    OpOverridesHasInstance(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
constructor(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
hasInstanceValue(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpOverridesHasInstance(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
constructor(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
hasInstanceValue(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpOverridesHasInstance decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setConstructor(VirtualRegister value, Functor func)
        {
            if (isWide())
                setConstructor<OpcodeSize::Wide>(value, func);
            else
                setConstructor<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setConstructor(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setHasInstanceValue(VirtualRegister value, Functor func)
        {
            if (isWide())
                setHasInstanceValue<OpcodeSize::Wide>(value, func);
            else
                setHasInstanceValue<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setHasInstanceValue(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister constructor;
VirtualRegister hasInstanceValue;
        

        };

        struct OpInstanceof : public Instruction {
            static constexpr OpcodeID opcodeID = op_instanceof;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister value, VirtualRegister prototype)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, value, prototype) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, value, prototype);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister value, VirtualRegister prototype)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, value, prototype);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister value, VirtualRegister prototype)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(value) && Fits<VirtualRegister, size>::check(prototype) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(value));
__generator->write(Fits<VirtualRegister, size>::convert(prototype));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*instanceof"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(value, false);

                __dumper->dumpOperand(prototype, false);

        }


                    OpInstanceof(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
value(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
prototype(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpInstanceof(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
value(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
prototype(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpInstanceof decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (isWide())
                setValue<OpcodeSize::Wide>(value, func);
            else
                setValue<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setPrototype(VirtualRegister value, Functor func)
        {
            if (isWide())
                setPrototype<OpcodeSize::Wide>(value, func);
            else
                setPrototype<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setPrototype(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister value;
VirtualRegister prototype;
        

        };

        struct OpInstanceofCustom : public Instruction {
            static constexpr OpcodeID opcodeID = op_instanceof_custom;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister value, VirtualRegister constructor, VirtualRegister hasInstanceValue)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, value, constructor, hasInstanceValue) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, value, constructor, hasInstanceValue);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister value, VirtualRegister constructor, VirtualRegister hasInstanceValue)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, value, constructor, hasInstanceValue);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister value, VirtualRegister constructor, VirtualRegister hasInstanceValue)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(value) && Fits<VirtualRegister, size>::check(constructor) && Fits<VirtualRegister, size>::check(hasInstanceValue) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(value));
__generator->write(Fits<VirtualRegister, size>::convert(constructor));
__generator->write(Fits<VirtualRegister, size>::convert(hasInstanceValue));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*instanceof_custom"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(value, false);

                __dumper->dumpOperand(constructor, false);

                __dumper->dumpOperand(hasInstanceValue, false);

        }


                    OpInstanceofCustom(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
value(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
constructor(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3])),
hasInstanceValue(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpInstanceofCustom(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
value(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
constructor(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3])),
hasInstanceValue(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpInstanceofCustom decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (isWide())
                setValue<OpcodeSize::Wide>(value, func);
            else
                setValue<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setConstructor(VirtualRegister value, Functor func)
        {
            if (isWide())
                setConstructor<OpcodeSize::Wide>(value, func);
            else
                setConstructor<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setConstructor(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setHasInstanceValue(VirtualRegister value, Functor func)
        {
            if (isWide())
                setHasInstanceValue<OpcodeSize::Wide>(value, func);
            else
                setHasInstanceValue<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setHasInstanceValue(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister value;
VirtualRegister constructor;
VirtualRegister hasInstanceValue;
        

        };

        struct OpTypeof : public Instruction {
            static constexpr OpcodeID opcodeID = op_typeof;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister value)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, value) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, value);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister value)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, value);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister value)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(value) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(value));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*typeof"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(value, false);

        }


                    OpTypeof(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
value(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpTypeof(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
value(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpTypeof decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (isWide())
                setValue<OpcodeSize::Wide>(value, func);
            else
                setValue<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister value;
        

        };

        struct OpIsCellWithType : public Instruction {
            static constexpr OpcodeID opcodeID = op_is_cell_with_type;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand, JSType type)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, operand, type) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, operand, type);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand, JSType type)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, operand, type);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister operand, JSType type)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(operand) && Fits<JSType, size>::check(type) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(operand));
__generator->write(Fits<JSType, size>::convert(type));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*is_cell_with_type"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(operand, false);

                __dumper->dumpOperand(type, false);

        }


                    OpIsCellWithType(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
type(Fits<JSType, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpIsCellWithType(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
operand(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
type(Fits<JSType, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpIsCellWithType decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (isWide())
                setOperand<OpcodeSize::Wide>(value, func);
            else
                setOperand<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setOperand(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setType(JSType value, Functor func)
        {
            if (isWide())
                setType<OpcodeSize::Wide>(value, func);
            else
                setType<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setType(JSType value, Functor func)
        {
            if (!Fits<JSType, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<JSType, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister operand;
JSType type;
        

        };

        struct OpInById : public Instruction {
            static constexpr OpcodeID opcodeID = op_in_by_id;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, unsigned property)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, base, property) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, base, property);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, unsigned property)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, base, property);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, unsigned property)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(base) && Fits<unsigned, size>::check(property) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(base));
__generator->write(Fits<unsigned, size>::convert(property));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*in_by_id"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(base, false);

                __dumper->dumpOperand(property, false);

        }


                    OpInById(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
property(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpInById(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
property(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpInById decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (isWide())
                setBase<OpcodeSize::Wide>(value, func);
            else
                setBase<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setProperty(unsigned value, Functor func)
        {
            if (isWide())
                setProperty<OpcodeSize::Wide>(value, func);
            else
                setProperty<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setProperty(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister base;
unsigned property;
        

        };

        struct OpPutByIdWithThis : public Instruction {
            static constexpr OpcodeID opcodeID = op_put_by_id_with_this;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister base, VirtualRegister thisValue, unsigned property, VirtualRegister value)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, base, thisValue, property, value) || emit<OpcodeSize::Wide, Assert, false>(__generator, base, thisValue, property, value);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister base, VirtualRegister thisValue, unsigned property, VirtualRegister value)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, base, thisValue, property, value);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister base, VirtualRegister thisValue, unsigned property, VirtualRegister value)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(base) && Fits<VirtualRegister, size>::check(thisValue) && Fits<unsigned, size>::check(property) && Fits<VirtualRegister, size>::check(value) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(base));
__generator->write(Fits<VirtualRegister, size>::convert(thisValue));
__generator->write(Fits<unsigned, size>::convert(property));
__generator->write(Fits<VirtualRegister, size>::convert(value));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*put_by_id_with_this"[!__isWide]);
                            __dumper->dumpOperand(base, true);

                __dumper->dumpOperand(thisValue, false);

                __dumper->dumpOperand(property, false);

                __dumper->dumpOperand(value, false);

        }


                    OpPutByIdWithThis(const uint8_t* stream)
            : base(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
thisValue(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
property(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3])),
value(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpPutByIdWithThis(const uint32_t* stream)
            : base(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
thisValue(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
property(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3])),
value(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpPutByIdWithThis decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (isWide())
                setBase<OpcodeSize::Wide>(value, func);
            else
                setBase<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setThisValue(VirtualRegister value, Functor func)
        {
            if (isWide())
                setThisValue<OpcodeSize::Wide>(value, func);
            else
                setThisValue<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setThisValue(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setProperty(unsigned value, Functor func)
        {
            if (isWide())
                setProperty<OpcodeSize::Wide>(value, func);
            else
                setProperty<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setProperty(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }

        template<typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (isWide())
                setValue<OpcodeSize::Wide>(value, func);
            else
                setValue<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister base;
VirtualRegister thisValue;
unsigned property;
VirtualRegister value;
        

        };

        struct OpDelById : public Instruction {
            static constexpr OpcodeID opcodeID = op_del_by_id;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, unsigned property)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, base, property) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, base, property);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, unsigned property)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, base, property);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, unsigned property)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(base) && Fits<unsigned, size>::check(property) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(base));
__generator->write(Fits<unsigned, size>::convert(property));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*del_by_id"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(base, false);

                __dumper->dumpOperand(property, false);

        }


                    OpDelById(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
property(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpDelById(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
property(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpDelById decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (isWide())
                setBase<OpcodeSize::Wide>(value, func);
            else
                setBase<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setProperty(unsigned value, Functor func)
        {
            if (isWide())
                setProperty<OpcodeSize::Wide>(value, func);
            else
                setProperty<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setProperty(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister base;
unsigned property;
        

        };

        struct OpPutByValWithThis : public Instruction {
            static constexpr OpcodeID opcodeID = op_put_by_val_with_this;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister base, VirtualRegister thisValue, VirtualRegister property, VirtualRegister value)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, base, thisValue, property, value) || emit<OpcodeSize::Wide, Assert, false>(__generator, base, thisValue, property, value);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister base, VirtualRegister thisValue, VirtualRegister property, VirtualRegister value)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, base, thisValue, property, value);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister base, VirtualRegister thisValue, VirtualRegister property, VirtualRegister value)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(base) && Fits<VirtualRegister, size>::check(thisValue) && Fits<VirtualRegister, size>::check(property) && Fits<VirtualRegister, size>::check(value) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(base));
__generator->write(Fits<VirtualRegister, size>::convert(thisValue));
__generator->write(Fits<VirtualRegister, size>::convert(property));
__generator->write(Fits<VirtualRegister, size>::convert(value));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*put_by_val_with_this"[!__isWide]);
                            __dumper->dumpOperand(base, true);

                __dumper->dumpOperand(thisValue, false);

                __dumper->dumpOperand(property, false);

                __dumper->dumpOperand(value, false);

        }


                    OpPutByValWithThis(const uint8_t* stream)
            : base(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
thisValue(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
property(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3])),
value(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpPutByValWithThis(const uint32_t* stream)
            : base(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
thisValue(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
property(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3])),
value(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpPutByValWithThis decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (isWide())
                setBase<OpcodeSize::Wide>(value, func);
            else
                setBase<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setThisValue(VirtualRegister value, Functor func)
        {
            if (isWide())
                setThisValue<OpcodeSize::Wide>(value, func);
            else
                setThisValue<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setThisValue(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setProperty(VirtualRegister value, Functor func)
        {
            if (isWide())
                setProperty<OpcodeSize::Wide>(value, func);
            else
                setProperty<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setProperty(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (isWide())
                setValue<OpcodeSize::Wide>(value, func);
            else
                setValue<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister base;
VirtualRegister thisValue;
VirtualRegister property;
VirtualRegister value;
        

        };

        struct OpDelByVal : public Instruction {
            static constexpr OpcodeID opcodeID = op_del_by_val;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister property)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, base, property) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, base, property);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister property)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, base, property);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister property)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(base) && Fits<VirtualRegister, size>::check(property) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(base));
__generator->write(Fits<VirtualRegister, size>::convert(property));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*del_by_val"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(base, false);

                __dumper->dumpOperand(property, false);

        }


                    OpDelByVal(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
property(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpDelByVal(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
property(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpDelByVal decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (isWide())
                setBase<OpcodeSize::Wide>(value, func);
            else
                setBase<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setProperty(VirtualRegister value, Functor func)
        {
            if (isWide())
                setProperty<OpcodeSize::Wide>(value, func);
            else
                setProperty<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setProperty(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister base;
VirtualRegister property;
        

        };

        struct OpPutGetterById : public Instruction {
            static constexpr OpcodeID opcodeID = op_put_getter_by_id;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister base, unsigned property, unsigned attributes, VirtualRegister accessor)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, base, property, attributes, accessor) || emit<OpcodeSize::Wide, Assert, false>(__generator, base, property, attributes, accessor);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister base, unsigned property, unsigned attributes, VirtualRegister accessor)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, base, property, attributes, accessor);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister base, unsigned property, unsigned attributes, VirtualRegister accessor)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(base) && Fits<unsigned, size>::check(property) && Fits<unsigned, size>::check(attributes) && Fits<VirtualRegister, size>::check(accessor) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(base));
__generator->write(Fits<unsigned, size>::convert(property));
__generator->write(Fits<unsigned, size>::convert(attributes));
__generator->write(Fits<VirtualRegister, size>::convert(accessor));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*put_getter_by_id"[!__isWide]);
                            __dumper->dumpOperand(base, true);

                __dumper->dumpOperand(property, false);

                __dumper->dumpOperand(attributes, false);

                __dumper->dumpOperand(accessor, false);

        }


                    OpPutGetterById(const uint8_t* stream)
            : base(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
property(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[2])),
attributes(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3])),
accessor(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpPutGetterById(const uint32_t* stream)
            : base(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
property(Fits<unsigned, OpcodeSize::Wide>::convert(stream[2])),
attributes(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3])),
accessor(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpPutGetterById decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (isWide())
                setBase<OpcodeSize::Wide>(value, func);
            else
                setBase<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setProperty(unsigned value, Functor func)
        {
            if (isWide())
                setProperty<OpcodeSize::Wide>(value, func);
            else
                setProperty<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setProperty(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }

        template<typename Functor>
        void setAttributes(unsigned value, Functor func)
        {
            if (isWide())
                setAttributes<OpcodeSize::Wide>(value, func);
            else
                setAttributes<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setAttributes(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }

        template<typename Functor>
        void setAccessor(VirtualRegister value, Functor func)
        {
            if (isWide())
                setAccessor<OpcodeSize::Wide>(value, func);
            else
                setAccessor<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setAccessor(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister base;
unsigned property;
unsigned attributes;
VirtualRegister accessor;
        

        };

        struct OpPutSetterById : public Instruction {
            static constexpr OpcodeID opcodeID = op_put_setter_by_id;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister base, unsigned property, unsigned attributes, VirtualRegister accessor)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, base, property, attributes, accessor) || emit<OpcodeSize::Wide, Assert, false>(__generator, base, property, attributes, accessor);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister base, unsigned property, unsigned attributes, VirtualRegister accessor)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, base, property, attributes, accessor);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister base, unsigned property, unsigned attributes, VirtualRegister accessor)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(base) && Fits<unsigned, size>::check(property) && Fits<unsigned, size>::check(attributes) && Fits<VirtualRegister, size>::check(accessor) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(base));
__generator->write(Fits<unsigned, size>::convert(property));
__generator->write(Fits<unsigned, size>::convert(attributes));
__generator->write(Fits<VirtualRegister, size>::convert(accessor));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*put_setter_by_id"[!__isWide]);
                            __dumper->dumpOperand(base, true);

                __dumper->dumpOperand(property, false);

                __dumper->dumpOperand(attributes, false);

                __dumper->dumpOperand(accessor, false);

        }


                    OpPutSetterById(const uint8_t* stream)
            : base(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
property(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[2])),
attributes(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3])),
accessor(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpPutSetterById(const uint32_t* stream)
            : base(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
property(Fits<unsigned, OpcodeSize::Wide>::convert(stream[2])),
attributes(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3])),
accessor(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpPutSetterById decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (isWide())
                setBase<OpcodeSize::Wide>(value, func);
            else
                setBase<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setProperty(unsigned value, Functor func)
        {
            if (isWide())
                setProperty<OpcodeSize::Wide>(value, func);
            else
                setProperty<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setProperty(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }

        template<typename Functor>
        void setAttributes(unsigned value, Functor func)
        {
            if (isWide())
                setAttributes<OpcodeSize::Wide>(value, func);
            else
                setAttributes<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setAttributes(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }

        template<typename Functor>
        void setAccessor(VirtualRegister value, Functor func)
        {
            if (isWide())
                setAccessor<OpcodeSize::Wide>(value, func);
            else
                setAccessor<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setAccessor(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister base;
unsigned property;
unsigned attributes;
VirtualRegister accessor;
        

        };

        struct OpPutGetterSetterById : public Instruction {
            static constexpr OpcodeID opcodeID = op_put_getter_setter_by_id;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister base, unsigned property, unsigned attributes, VirtualRegister getter, VirtualRegister setter)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, base, property, attributes, getter, setter) || emit<OpcodeSize::Wide, Assert, false>(__generator, base, property, attributes, getter, setter);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister base, unsigned property, unsigned attributes, VirtualRegister getter, VirtualRegister setter)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, base, property, attributes, getter, setter);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister base, unsigned property, unsigned attributes, VirtualRegister getter, VirtualRegister setter)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(base) && Fits<unsigned, size>::check(property) && Fits<unsigned, size>::check(attributes) && Fits<VirtualRegister, size>::check(getter) && Fits<VirtualRegister, size>::check(setter) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(base));
__generator->write(Fits<unsigned, size>::convert(property));
__generator->write(Fits<unsigned, size>::convert(attributes));
__generator->write(Fits<VirtualRegister, size>::convert(getter));
__generator->write(Fits<VirtualRegister, size>::convert(setter));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*put_getter_setter_by_id"[!__isWide]);
                            __dumper->dumpOperand(base, true);

                __dumper->dumpOperand(property, false);

                __dumper->dumpOperand(attributes, false);

                __dumper->dumpOperand(getter, false);

                __dumper->dumpOperand(setter, false);

        }


                    OpPutGetterSetterById(const uint8_t* stream)
            : base(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
property(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[2])),
attributes(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3])),
getter(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[4])),
setter(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[5]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpPutGetterSetterById(const uint32_t* stream)
            : base(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
property(Fits<unsigned, OpcodeSize::Wide>::convert(stream[2])),
attributes(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3])),
getter(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[4])),
setter(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[5]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpPutGetterSetterById decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (isWide())
                setBase<OpcodeSize::Wide>(value, func);
            else
                setBase<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setProperty(unsigned value, Functor func)
        {
            if (isWide())
                setProperty<OpcodeSize::Wide>(value, func);
            else
                setProperty<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setProperty(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }

        template<typename Functor>
        void setAttributes(unsigned value, Functor func)
        {
            if (isWide())
                setAttributes<OpcodeSize::Wide>(value, func);
            else
                setAttributes<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setAttributes(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }

        template<typename Functor>
        void setGetter(VirtualRegister value, Functor func)
        {
            if (isWide())
                setGetter<OpcodeSize::Wide>(value, func);
            else
                setGetter<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setGetter(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setSetter(VirtualRegister value, Functor func)
        {
            if (isWide())
                setSetter<OpcodeSize::Wide>(value, func);
            else
                setSetter<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setSetter(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 5 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister base;
unsigned property;
unsigned attributes;
VirtualRegister getter;
VirtualRegister setter;
        

        };

        struct OpPutGetterByVal : public Instruction {
            static constexpr OpcodeID opcodeID = op_put_getter_by_val;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister base, VirtualRegister property, unsigned attributes, VirtualRegister accessor)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, base, property, attributes, accessor) || emit<OpcodeSize::Wide, Assert, false>(__generator, base, property, attributes, accessor);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister base, VirtualRegister property, unsigned attributes, VirtualRegister accessor)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, base, property, attributes, accessor);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister base, VirtualRegister property, unsigned attributes, VirtualRegister accessor)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(base) && Fits<VirtualRegister, size>::check(property) && Fits<unsigned, size>::check(attributes) && Fits<VirtualRegister, size>::check(accessor) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(base));
__generator->write(Fits<VirtualRegister, size>::convert(property));
__generator->write(Fits<unsigned, size>::convert(attributes));
__generator->write(Fits<VirtualRegister, size>::convert(accessor));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*put_getter_by_val"[!__isWide]);
                            __dumper->dumpOperand(base, true);

                __dumper->dumpOperand(property, false);

                __dumper->dumpOperand(attributes, false);

                __dumper->dumpOperand(accessor, false);

        }


                    OpPutGetterByVal(const uint8_t* stream)
            : base(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
property(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
attributes(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3])),
accessor(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpPutGetterByVal(const uint32_t* stream)
            : base(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
property(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
attributes(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3])),
accessor(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpPutGetterByVal decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (isWide())
                setBase<OpcodeSize::Wide>(value, func);
            else
                setBase<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setProperty(VirtualRegister value, Functor func)
        {
            if (isWide())
                setProperty<OpcodeSize::Wide>(value, func);
            else
                setProperty<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setProperty(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setAttributes(unsigned value, Functor func)
        {
            if (isWide())
                setAttributes<OpcodeSize::Wide>(value, func);
            else
                setAttributes<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setAttributes(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }

        template<typename Functor>
        void setAccessor(VirtualRegister value, Functor func)
        {
            if (isWide())
                setAccessor<OpcodeSize::Wide>(value, func);
            else
                setAccessor<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setAccessor(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister base;
VirtualRegister property;
unsigned attributes;
VirtualRegister accessor;
        

        };

        struct OpPutSetterByVal : public Instruction {
            static constexpr OpcodeID opcodeID = op_put_setter_by_val;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister base, VirtualRegister property, unsigned attributes, VirtualRegister accessor)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, base, property, attributes, accessor) || emit<OpcodeSize::Wide, Assert, false>(__generator, base, property, attributes, accessor);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister base, VirtualRegister property, unsigned attributes, VirtualRegister accessor)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, base, property, attributes, accessor);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister base, VirtualRegister property, unsigned attributes, VirtualRegister accessor)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(base) && Fits<VirtualRegister, size>::check(property) && Fits<unsigned, size>::check(attributes) && Fits<VirtualRegister, size>::check(accessor) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(base));
__generator->write(Fits<VirtualRegister, size>::convert(property));
__generator->write(Fits<unsigned, size>::convert(attributes));
__generator->write(Fits<VirtualRegister, size>::convert(accessor));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*put_setter_by_val"[!__isWide]);
                            __dumper->dumpOperand(base, true);

                __dumper->dumpOperand(property, false);

                __dumper->dumpOperand(attributes, false);

                __dumper->dumpOperand(accessor, false);

        }


                    OpPutSetterByVal(const uint8_t* stream)
            : base(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
property(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
attributes(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3])),
accessor(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpPutSetterByVal(const uint32_t* stream)
            : base(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
property(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
attributes(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3])),
accessor(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpPutSetterByVal decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (isWide())
                setBase<OpcodeSize::Wide>(value, func);
            else
                setBase<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setProperty(VirtualRegister value, Functor func)
        {
            if (isWide())
                setProperty<OpcodeSize::Wide>(value, func);
            else
                setProperty<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setProperty(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setAttributes(unsigned value, Functor func)
        {
            if (isWide())
                setAttributes<OpcodeSize::Wide>(value, func);
            else
                setAttributes<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setAttributes(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }

        template<typename Functor>
        void setAccessor(VirtualRegister value, Functor func)
        {
            if (isWide())
                setAccessor<OpcodeSize::Wide>(value, func);
            else
                setAccessor<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setAccessor(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister base;
VirtualRegister property;
unsigned attributes;
VirtualRegister accessor;
        

        };

        struct OpDefineDataProperty : public Instruction {
            static constexpr OpcodeID opcodeID = op_define_data_property;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister base, VirtualRegister property, VirtualRegister value, VirtualRegister attributes)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, base, property, value, attributes) || emit<OpcodeSize::Wide, Assert, false>(__generator, base, property, value, attributes);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister base, VirtualRegister property, VirtualRegister value, VirtualRegister attributes)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, base, property, value, attributes);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister base, VirtualRegister property, VirtualRegister value, VirtualRegister attributes)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(base) && Fits<VirtualRegister, size>::check(property) && Fits<VirtualRegister, size>::check(value) && Fits<VirtualRegister, size>::check(attributes) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(base));
__generator->write(Fits<VirtualRegister, size>::convert(property));
__generator->write(Fits<VirtualRegister, size>::convert(value));
__generator->write(Fits<VirtualRegister, size>::convert(attributes));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*define_data_property"[!__isWide]);
                            __dumper->dumpOperand(base, true);

                __dumper->dumpOperand(property, false);

                __dumper->dumpOperand(value, false);

                __dumper->dumpOperand(attributes, false);

        }


                    OpDefineDataProperty(const uint8_t* stream)
            : base(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
property(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
value(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3])),
attributes(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpDefineDataProperty(const uint32_t* stream)
            : base(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
property(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
value(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3])),
attributes(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpDefineDataProperty decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (isWide())
                setBase<OpcodeSize::Wide>(value, func);
            else
                setBase<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setProperty(VirtualRegister value, Functor func)
        {
            if (isWide())
                setProperty<OpcodeSize::Wide>(value, func);
            else
                setProperty<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setProperty(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (isWide())
                setValue<OpcodeSize::Wide>(value, func);
            else
                setValue<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setAttributes(VirtualRegister value, Functor func)
        {
            if (isWide())
                setAttributes<OpcodeSize::Wide>(value, func);
            else
                setAttributes<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setAttributes(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister base;
VirtualRegister property;
VirtualRegister value;
VirtualRegister attributes;
        

        };

        struct OpDefineAccessorProperty : public Instruction {
            static constexpr OpcodeID opcodeID = op_define_accessor_property;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister base, VirtualRegister property, VirtualRegister getter, VirtualRegister setter, VirtualRegister attributes)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, base, property, getter, setter, attributes) || emit<OpcodeSize::Wide, Assert, false>(__generator, base, property, getter, setter, attributes);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister base, VirtualRegister property, VirtualRegister getter, VirtualRegister setter, VirtualRegister attributes)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, base, property, getter, setter, attributes);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister base, VirtualRegister property, VirtualRegister getter, VirtualRegister setter, VirtualRegister attributes)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(base) && Fits<VirtualRegister, size>::check(property) && Fits<VirtualRegister, size>::check(getter) && Fits<VirtualRegister, size>::check(setter) && Fits<VirtualRegister, size>::check(attributes) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(base));
__generator->write(Fits<VirtualRegister, size>::convert(property));
__generator->write(Fits<VirtualRegister, size>::convert(getter));
__generator->write(Fits<VirtualRegister, size>::convert(setter));
__generator->write(Fits<VirtualRegister, size>::convert(attributes));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*define_accessor_property"[!__isWide]);
                            __dumper->dumpOperand(base, true);

                __dumper->dumpOperand(property, false);

                __dumper->dumpOperand(getter, false);

                __dumper->dumpOperand(setter, false);

                __dumper->dumpOperand(attributes, false);

        }


                    OpDefineAccessorProperty(const uint8_t* stream)
            : base(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
property(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
getter(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3])),
setter(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[4])),
attributes(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[5]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpDefineAccessorProperty(const uint32_t* stream)
            : base(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
property(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
getter(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3])),
setter(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[4])),
attributes(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[5]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpDefineAccessorProperty decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (isWide())
                setBase<OpcodeSize::Wide>(value, func);
            else
                setBase<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setProperty(VirtualRegister value, Functor func)
        {
            if (isWide())
                setProperty<OpcodeSize::Wide>(value, func);
            else
                setProperty<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setProperty(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setGetter(VirtualRegister value, Functor func)
        {
            if (isWide())
                setGetter<OpcodeSize::Wide>(value, func);
            else
                setGetter<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setGetter(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setSetter(VirtualRegister value, Functor func)
        {
            if (isWide())
                setSetter<OpcodeSize::Wide>(value, func);
            else
                setSetter<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setSetter(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setAttributes(VirtualRegister value, Functor func)
        {
            if (isWide())
                setAttributes<OpcodeSize::Wide>(value, func);
            else
                setAttributes<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setAttributes(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 5 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister base;
VirtualRegister property;
VirtualRegister getter;
VirtualRegister setter;
VirtualRegister attributes;
        

        };

        struct OpJmp : public Instruction {
            static constexpr OpcodeID opcodeID = op_jmp;

                    static void emit(BytecodeGenerator* __generator, BoundLabel target)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, target) || emit<OpcodeSize::Wide, Assert, false>(__generator, target);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, BoundLabel target)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, target);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, BoundLabel target)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<BoundLabel, size>::check(target) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<BoundLabel, size>::convert(target));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*jmp"[!__isWide]);
                            __dumper->dumpOperand(target, true);

        }


                    OpJmp(const uint8_t* stream)
            : target(Fits<BoundLabel, OpcodeSize::Narrow>::convert(stream[1]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpJmp(const uint32_t* stream)
            : target(Fits<BoundLabel, OpcodeSize::Wide>::convert(stream[1]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpJmp decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (isWide())
                setTarget<OpcodeSize::Wide>(value, func);
            else
                setTarget<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (!Fits<BoundLabel, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<BoundLabel, size>::convert(value);
        }


                    

        


                    BoundLabel target;
        

        };

        struct OpJtrue : public Instruction {
            static constexpr OpcodeID opcodeID = op_jtrue;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister condition, BoundLabel target)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, condition, target) || emit<OpcodeSize::Wide, Assert, false>(__generator, condition, target);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister condition, BoundLabel target)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, condition, target);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister condition, BoundLabel target)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(condition) && Fits<BoundLabel, size>::check(target) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(condition));
__generator->write(Fits<BoundLabel, size>::convert(target));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*jtrue"[!__isWide]);
                            __dumper->dumpOperand(condition, true);

                __dumper->dumpOperand(target, false);

        }


                    OpJtrue(const uint8_t* stream)
            : condition(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
target(Fits<BoundLabel, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpJtrue(const uint32_t* stream)
            : condition(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
target(Fits<BoundLabel, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpJtrue decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setCondition(VirtualRegister value, Functor func)
        {
            if (isWide())
                setCondition<OpcodeSize::Wide>(value, func);
            else
                setCondition<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setCondition(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (isWide())
                setTarget<OpcodeSize::Wide>(value, func);
            else
                setTarget<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (!Fits<BoundLabel, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<BoundLabel, size>::convert(value);
        }


                    

        


                    VirtualRegister condition;
BoundLabel target;
        

        };

        struct OpJfalse : public Instruction {
            static constexpr OpcodeID opcodeID = op_jfalse;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister condition, BoundLabel target)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, condition, target) || emit<OpcodeSize::Wide, Assert, false>(__generator, condition, target);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister condition, BoundLabel target)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, condition, target);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister condition, BoundLabel target)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(condition) && Fits<BoundLabel, size>::check(target) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(condition));
__generator->write(Fits<BoundLabel, size>::convert(target));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*jfalse"[!__isWide]);
                            __dumper->dumpOperand(condition, true);

                __dumper->dumpOperand(target, false);

        }


                    OpJfalse(const uint8_t* stream)
            : condition(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
target(Fits<BoundLabel, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpJfalse(const uint32_t* stream)
            : condition(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
target(Fits<BoundLabel, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpJfalse decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setCondition(VirtualRegister value, Functor func)
        {
            if (isWide())
                setCondition<OpcodeSize::Wide>(value, func);
            else
                setCondition<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setCondition(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (isWide())
                setTarget<OpcodeSize::Wide>(value, func);
            else
                setTarget<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (!Fits<BoundLabel, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<BoundLabel, size>::convert(value);
        }


                    

        


                    VirtualRegister condition;
BoundLabel target;
        

        };

        struct OpJeqNull : public Instruction {
            static constexpr OpcodeID opcodeID = op_jeq_null;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister value, BoundLabel target)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, value, target) || emit<OpcodeSize::Wide, Assert, false>(__generator, value, target);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister value, BoundLabel target)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, value, target);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister value, BoundLabel target)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(value) && Fits<BoundLabel, size>::check(target) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(value));
__generator->write(Fits<BoundLabel, size>::convert(target));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*jeq_null"[!__isWide]);
                            __dumper->dumpOperand(value, true);

                __dumper->dumpOperand(target, false);

        }


                    OpJeqNull(const uint8_t* stream)
            : value(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
target(Fits<BoundLabel, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpJeqNull(const uint32_t* stream)
            : value(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
target(Fits<BoundLabel, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpJeqNull decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (isWide())
                setValue<OpcodeSize::Wide>(value, func);
            else
                setValue<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (isWide())
                setTarget<OpcodeSize::Wide>(value, func);
            else
                setTarget<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (!Fits<BoundLabel, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<BoundLabel, size>::convert(value);
        }


                    

        


                    VirtualRegister value;
BoundLabel target;
        

        };

        struct OpJneqNull : public Instruction {
            static constexpr OpcodeID opcodeID = op_jneq_null;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister value, BoundLabel target)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, value, target) || emit<OpcodeSize::Wide, Assert, false>(__generator, value, target);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister value, BoundLabel target)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, value, target);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister value, BoundLabel target)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(value) && Fits<BoundLabel, size>::check(target) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(value));
__generator->write(Fits<BoundLabel, size>::convert(target));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*jneq_null"[!__isWide]);
                            __dumper->dumpOperand(value, true);

                __dumper->dumpOperand(target, false);

        }


                    OpJneqNull(const uint8_t* stream)
            : value(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
target(Fits<BoundLabel, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpJneqNull(const uint32_t* stream)
            : value(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
target(Fits<BoundLabel, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpJneqNull decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (isWide())
                setValue<OpcodeSize::Wide>(value, func);
            else
                setValue<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (isWide())
                setTarget<OpcodeSize::Wide>(value, func);
            else
                setTarget<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (!Fits<BoundLabel, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<BoundLabel, size>::convert(value);
        }


                    

        


                    VirtualRegister value;
BoundLabel target;
        

        };

        struct OpJeq : public Instruction {
            static constexpr OpcodeID opcodeID = op_jeq;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, lhs, rhs, target) || emit<OpcodeSize::Wide, Assert, false>(__generator, lhs, rhs, target);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, lhs, rhs, target);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && Fits<BoundLabel, size>::check(target) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
__generator->write(Fits<BoundLabel, size>::convert(target));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*jeq"[!__isWide]);
                            __dumper->dumpOperand(lhs, true);

                __dumper->dumpOperand(rhs, false);

                __dumper->dumpOperand(target, false);

        }


                    OpJeq(const uint8_t* stream)
            : lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
target(Fits<BoundLabel, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpJeq(const uint32_t* stream)
            : lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
target(Fits<BoundLabel, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpJeq decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (isWide())
                setTarget<OpcodeSize::Wide>(value, func);
            else
                setTarget<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (!Fits<BoundLabel, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<BoundLabel, size>::convert(value);
        }


                    

        


                    VirtualRegister lhs;
VirtualRegister rhs;
BoundLabel target;
        

        };

        struct OpJstricteq : public Instruction {
            static constexpr OpcodeID opcodeID = op_jstricteq;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, lhs, rhs, target) || emit<OpcodeSize::Wide, Assert, false>(__generator, lhs, rhs, target);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, lhs, rhs, target);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && Fits<BoundLabel, size>::check(target) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
__generator->write(Fits<BoundLabel, size>::convert(target));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*jstricteq"[!__isWide]);
                            __dumper->dumpOperand(lhs, true);

                __dumper->dumpOperand(rhs, false);

                __dumper->dumpOperand(target, false);

        }


                    OpJstricteq(const uint8_t* stream)
            : lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
target(Fits<BoundLabel, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpJstricteq(const uint32_t* stream)
            : lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
target(Fits<BoundLabel, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpJstricteq decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (isWide())
                setTarget<OpcodeSize::Wide>(value, func);
            else
                setTarget<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (!Fits<BoundLabel, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<BoundLabel, size>::convert(value);
        }


                    

        


                    VirtualRegister lhs;
VirtualRegister rhs;
BoundLabel target;
        

        };

        struct OpJneq : public Instruction {
            static constexpr OpcodeID opcodeID = op_jneq;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, lhs, rhs, target) || emit<OpcodeSize::Wide, Assert, false>(__generator, lhs, rhs, target);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, lhs, rhs, target);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && Fits<BoundLabel, size>::check(target) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
__generator->write(Fits<BoundLabel, size>::convert(target));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*jneq"[!__isWide]);
                            __dumper->dumpOperand(lhs, true);

                __dumper->dumpOperand(rhs, false);

                __dumper->dumpOperand(target, false);

        }


                    OpJneq(const uint8_t* stream)
            : lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
target(Fits<BoundLabel, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpJneq(const uint32_t* stream)
            : lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
target(Fits<BoundLabel, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpJneq decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (isWide())
                setTarget<OpcodeSize::Wide>(value, func);
            else
                setTarget<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (!Fits<BoundLabel, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<BoundLabel, size>::convert(value);
        }


                    

        


                    VirtualRegister lhs;
VirtualRegister rhs;
BoundLabel target;
        

        };

        struct OpJnstricteq : public Instruction {
            static constexpr OpcodeID opcodeID = op_jnstricteq;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, lhs, rhs, target) || emit<OpcodeSize::Wide, Assert, false>(__generator, lhs, rhs, target);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, lhs, rhs, target);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && Fits<BoundLabel, size>::check(target) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
__generator->write(Fits<BoundLabel, size>::convert(target));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*jnstricteq"[!__isWide]);
                            __dumper->dumpOperand(lhs, true);

                __dumper->dumpOperand(rhs, false);

                __dumper->dumpOperand(target, false);

        }


                    OpJnstricteq(const uint8_t* stream)
            : lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
target(Fits<BoundLabel, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpJnstricteq(const uint32_t* stream)
            : lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
target(Fits<BoundLabel, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpJnstricteq decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (isWide())
                setTarget<OpcodeSize::Wide>(value, func);
            else
                setTarget<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (!Fits<BoundLabel, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<BoundLabel, size>::convert(value);
        }


                    

        


                    VirtualRegister lhs;
VirtualRegister rhs;
BoundLabel target;
        

        };

        struct OpJless : public Instruction {
            static constexpr OpcodeID opcodeID = op_jless;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, lhs, rhs, target) || emit<OpcodeSize::Wide, Assert, false>(__generator, lhs, rhs, target);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, lhs, rhs, target);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && Fits<BoundLabel, size>::check(target) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
__generator->write(Fits<BoundLabel, size>::convert(target));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*jless"[!__isWide]);
                            __dumper->dumpOperand(lhs, true);

                __dumper->dumpOperand(rhs, false);

                __dumper->dumpOperand(target, false);

        }


                    OpJless(const uint8_t* stream)
            : lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
target(Fits<BoundLabel, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpJless(const uint32_t* stream)
            : lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
target(Fits<BoundLabel, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpJless decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (isWide())
                setTarget<OpcodeSize::Wide>(value, func);
            else
                setTarget<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (!Fits<BoundLabel, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<BoundLabel, size>::convert(value);
        }


                    

        


                    VirtualRegister lhs;
VirtualRegister rhs;
BoundLabel target;
        

        };

        struct OpJlesseq : public Instruction {
            static constexpr OpcodeID opcodeID = op_jlesseq;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, lhs, rhs, target) || emit<OpcodeSize::Wide, Assert, false>(__generator, lhs, rhs, target);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, lhs, rhs, target);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && Fits<BoundLabel, size>::check(target) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
__generator->write(Fits<BoundLabel, size>::convert(target));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*jlesseq"[!__isWide]);
                            __dumper->dumpOperand(lhs, true);

                __dumper->dumpOperand(rhs, false);

                __dumper->dumpOperand(target, false);

        }


                    OpJlesseq(const uint8_t* stream)
            : lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
target(Fits<BoundLabel, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpJlesseq(const uint32_t* stream)
            : lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
target(Fits<BoundLabel, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpJlesseq decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (isWide())
                setTarget<OpcodeSize::Wide>(value, func);
            else
                setTarget<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (!Fits<BoundLabel, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<BoundLabel, size>::convert(value);
        }


                    

        


                    VirtualRegister lhs;
VirtualRegister rhs;
BoundLabel target;
        

        };

        struct OpJgreater : public Instruction {
            static constexpr OpcodeID opcodeID = op_jgreater;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, lhs, rhs, target) || emit<OpcodeSize::Wide, Assert, false>(__generator, lhs, rhs, target);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, lhs, rhs, target);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && Fits<BoundLabel, size>::check(target) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
__generator->write(Fits<BoundLabel, size>::convert(target));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*jgreater"[!__isWide]);
                            __dumper->dumpOperand(lhs, true);

                __dumper->dumpOperand(rhs, false);

                __dumper->dumpOperand(target, false);

        }


                    OpJgreater(const uint8_t* stream)
            : lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
target(Fits<BoundLabel, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpJgreater(const uint32_t* stream)
            : lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
target(Fits<BoundLabel, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpJgreater decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (isWide())
                setTarget<OpcodeSize::Wide>(value, func);
            else
                setTarget<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (!Fits<BoundLabel, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<BoundLabel, size>::convert(value);
        }


                    

        


                    VirtualRegister lhs;
VirtualRegister rhs;
BoundLabel target;
        

        };

        struct OpJgreatereq : public Instruction {
            static constexpr OpcodeID opcodeID = op_jgreatereq;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, lhs, rhs, target) || emit<OpcodeSize::Wide, Assert, false>(__generator, lhs, rhs, target);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, lhs, rhs, target);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && Fits<BoundLabel, size>::check(target) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
__generator->write(Fits<BoundLabel, size>::convert(target));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*jgreatereq"[!__isWide]);
                            __dumper->dumpOperand(lhs, true);

                __dumper->dumpOperand(rhs, false);

                __dumper->dumpOperand(target, false);

        }


                    OpJgreatereq(const uint8_t* stream)
            : lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
target(Fits<BoundLabel, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpJgreatereq(const uint32_t* stream)
            : lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
target(Fits<BoundLabel, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpJgreatereq decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (isWide())
                setTarget<OpcodeSize::Wide>(value, func);
            else
                setTarget<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (!Fits<BoundLabel, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<BoundLabel, size>::convert(value);
        }


                    

        


                    VirtualRegister lhs;
VirtualRegister rhs;
BoundLabel target;
        

        };

        struct OpJnless : public Instruction {
            static constexpr OpcodeID opcodeID = op_jnless;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, lhs, rhs, target) || emit<OpcodeSize::Wide, Assert, false>(__generator, lhs, rhs, target);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, lhs, rhs, target);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && Fits<BoundLabel, size>::check(target) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
__generator->write(Fits<BoundLabel, size>::convert(target));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*jnless"[!__isWide]);
                            __dumper->dumpOperand(lhs, true);

                __dumper->dumpOperand(rhs, false);

                __dumper->dumpOperand(target, false);

        }


                    OpJnless(const uint8_t* stream)
            : lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
target(Fits<BoundLabel, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpJnless(const uint32_t* stream)
            : lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
target(Fits<BoundLabel, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpJnless decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (isWide())
                setTarget<OpcodeSize::Wide>(value, func);
            else
                setTarget<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (!Fits<BoundLabel, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<BoundLabel, size>::convert(value);
        }


                    

        


                    VirtualRegister lhs;
VirtualRegister rhs;
BoundLabel target;
        

        };

        struct OpJnlesseq : public Instruction {
            static constexpr OpcodeID opcodeID = op_jnlesseq;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, lhs, rhs, target) || emit<OpcodeSize::Wide, Assert, false>(__generator, lhs, rhs, target);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, lhs, rhs, target);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && Fits<BoundLabel, size>::check(target) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
__generator->write(Fits<BoundLabel, size>::convert(target));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*jnlesseq"[!__isWide]);
                            __dumper->dumpOperand(lhs, true);

                __dumper->dumpOperand(rhs, false);

                __dumper->dumpOperand(target, false);

        }


                    OpJnlesseq(const uint8_t* stream)
            : lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
target(Fits<BoundLabel, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpJnlesseq(const uint32_t* stream)
            : lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
target(Fits<BoundLabel, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpJnlesseq decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (isWide())
                setTarget<OpcodeSize::Wide>(value, func);
            else
                setTarget<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (!Fits<BoundLabel, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<BoundLabel, size>::convert(value);
        }


                    

        


                    VirtualRegister lhs;
VirtualRegister rhs;
BoundLabel target;
        

        };

        struct OpJngreater : public Instruction {
            static constexpr OpcodeID opcodeID = op_jngreater;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, lhs, rhs, target) || emit<OpcodeSize::Wide, Assert, false>(__generator, lhs, rhs, target);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, lhs, rhs, target);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && Fits<BoundLabel, size>::check(target) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
__generator->write(Fits<BoundLabel, size>::convert(target));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*jngreater"[!__isWide]);
                            __dumper->dumpOperand(lhs, true);

                __dumper->dumpOperand(rhs, false);

                __dumper->dumpOperand(target, false);

        }


                    OpJngreater(const uint8_t* stream)
            : lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
target(Fits<BoundLabel, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpJngreater(const uint32_t* stream)
            : lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
target(Fits<BoundLabel, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpJngreater decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (isWide())
                setTarget<OpcodeSize::Wide>(value, func);
            else
                setTarget<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (!Fits<BoundLabel, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<BoundLabel, size>::convert(value);
        }


                    

        


                    VirtualRegister lhs;
VirtualRegister rhs;
BoundLabel target;
        

        };

        struct OpJngreatereq : public Instruction {
            static constexpr OpcodeID opcodeID = op_jngreatereq;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, lhs, rhs, target) || emit<OpcodeSize::Wide, Assert, false>(__generator, lhs, rhs, target);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, lhs, rhs, target);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && Fits<BoundLabel, size>::check(target) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
__generator->write(Fits<BoundLabel, size>::convert(target));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*jngreatereq"[!__isWide]);
                            __dumper->dumpOperand(lhs, true);

                __dumper->dumpOperand(rhs, false);

                __dumper->dumpOperand(target, false);

        }


                    OpJngreatereq(const uint8_t* stream)
            : lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
target(Fits<BoundLabel, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpJngreatereq(const uint32_t* stream)
            : lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
target(Fits<BoundLabel, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpJngreatereq decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (isWide())
                setTarget<OpcodeSize::Wide>(value, func);
            else
                setTarget<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (!Fits<BoundLabel, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<BoundLabel, size>::convert(value);
        }


                    

        


                    VirtualRegister lhs;
VirtualRegister rhs;
BoundLabel target;
        

        };

        struct OpJbelow : public Instruction {
            static constexpr OpcodeID opcodeID = op_jbelow;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, lhs, rhs, target) || emit<OpcodeSize::Wide, Assert, false>(__generator, lhs, rhs, target);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, lhs, rhs, target);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && Fits<BoundLabel, size>::check(target) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
__generator->write(Fits<BoundLabel, size>::convert(target));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*jbelow"[!__isWide]);
                            __dumper->dumpOperand(lhs, true);

                __dumper->dumpOperand(rhs, false);

                __dumper->dumpOperand(target, false);

        }


                    OpJbelow(const uint8_t* stream)
            : lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
target(Fits<BoundLabel, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpJbelow(const uint32_t* stream)
            : lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
target(Fits<BoundLabel, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpJbelow decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (isWide())
                setTarget<OpcodeSize::Wide>(value, func);
            else
                setTarget<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (!Fits<BoundLabel, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<BoundLabel, size>::convert(value);
        }


                    

        


                    VirtualRegister lhs;
VirtualRegister rhs;
BoundLabel target;
        

        };

        struct OpJbeloweq : public Instruction {
            static constexpr OpcodeID opcodeID = op_jbeloweq;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, lhs, rhs, target) || emit<OpcodeSize::Wide, Assert, false>(__generator, lhs, rhs, target);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, lhs, rhs, target);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister lhs, VirtualRegister rhs, BoundLabel target)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(lhs) && Fits<VirtualRegister, size>::check(rhs) && Fits<BoundLabel, size>::check(target) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(lhs));
__generator->write(Fits<VirtualRegister, size>::convert(rhs));
__generator->write(Fits<BoundLabel, size>::convert(target));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*jbeloweq"[!__isWide]);
                            __dumper->dumpOperand(lhs, true);

                __dumper->dumpOperand(rhs, false);

                __dumper->dumpOperand(target, false);

        }


                    OpJbeloweq(const uint8_t* stream)
            : lhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
rhs(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
target(Fits<BoundLabel, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpJbeloweq(const uint32_t* stream)
            : lhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
rhs(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
target(Fits<BoundLabel, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpJbeloweq decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setLhs<OpcodeSize::Wide>(value, func);
            else
                setLhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setLhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (isWide())
                setRhs<OpcodeSize::Wide>(value, func);
            else
                setRhs<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setRhs(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (isWide())
                setTarget<OpcodeSize::Wide>(value, func);
            else
                setTarget<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setTarget(BoundLabel value, Functor func)
        {
            if (!Fits<BoundLabel, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<BoundLabel, size>::convert(value);
        }


                    

        


                    VirtualRegister lhs;
VirtualRegister rhs;
BoundLabel target;
        

        };

        struct OpLoopHint : public Instruction {
            static constexpr OpcodeID opcodeID = op_loop_hint;

                    static void emit(BytecodeGenerator* __generator)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator) || emit<OpcodeSize::Wide, Assert, false>(__generator);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*loop_hint"[!__isWide]);
            
        }


                    OpLoopHint(const uint8_t* stream)
            
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpLoopHint(const uint32_t* stream)
            
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpLoopHint decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



            

                    

        


                    
        

        };

        struct OpSwitchImm : public Instruction {
            static constexpr OpcodeID opcodeID = op_switch_imm;

                    static void emit(BytecodeGenerator* __generator, unsigned tableIndex, BoundLabel defaultOffset, VirtualRegister scrutinee)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, tableIndex, defaultOffset, scrutinee) || emit<OpcodeSize::Wide, Assert, false>(__generator, tableIndex, defaultOffset, scrutinee);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, unsigned tableIndex, BoundLabel defaultOffset, VirtualRegister scrutinee)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, tableIndex, defaultOffset, scrutinee);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, unsigned tableIndex, BoundLabel defaultOffset, VirtualRegister scrutinee)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<unsigned, size>::check(tableIndex) && Fits<BoundLabel, size>::check(defaultOffset) && Fits<VirtualRegister, size>::check(scrutinee) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<unsigned, size>::convert(tableIndex));
__generator->write(Fits<BoundLabel, size>::convert(defaultOffset));
__generator->write(Fits<VirtualRegister, size>::convert(scrutinee));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*switch_imm"[!__isWide]);
                            __dumper->dumpOperand(tableIndex, true);

                __dumper->dumpOperand(defaultOffset, false);

                __dumper->dumpOperand(scrutinee, false);

        }


                    OpSwitchImm(const uint8_t* stream)
            : tableIndex(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[1])),
defaultOffset(Fits<BoundLabel, OpcodeSize::Narrow>::convert(stream[2])),
scrutinee(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpSwitchImm(const uint32_t* stream)
            : tableIndex(Fits<unsigned, OpcodeSize::Wide>::convert(stream[1])),
defaultOffset(Fits<BoundLabel, OpcodeSize::Wide>::convert(stream[2])),
scrutinee(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpSwitchImm decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setTableIndex(unsigned value, Functor func)
        {
            if (isWide())
                setTableIndex<OpcodeSize::Wide>(value, func);
            else
                setTableIndex<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setTableIndex(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }

        template<typename Functor>
        void setDefaultOffset(BoundLabel value, Functor func)
        {
            if (isWide())
                setDefaultOffset<OpcodeSize::Wide>(value, func);
            else
                setDefaultOffset<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDefaultOffset(BoundLabel value, Functor func)
        {
            if (!Fits<BoundLabel, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<BoundLabel, size>::convert(value);
        }

        template<typename Functor>
        void setScrutinee(VirtualRegister value, Functor func)
        {
            if (isWide())
                setScrutinee<OpcodeSize::Wide>(value, func);
            else
                setScrutinee<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setScrutinee(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    unsigned tableIndex;
BoundLabel defaultOffset;
VirtualRegister scrutinee;
        

        };

        struct OpSwitchChar : public Instruction {
            static constexpr OpcodeID opcodeID = op_switch_char;

                    static void emit(BytecodeGenerator* __generator, unsigned tableIndex, BoundLabel defaultOffset, VirtualRegister scrutinee)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, tableIndex, defaultOffset, scrutinee) || emit<OpcodeSize::Wide, Assert, false>(__generator, tableIndex, defaultOffset, scrutinee);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, unsigned tableIndex, BoundLabel defaultOffset, VirtualRegister scrutinee)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, tableIndex, defaultOffset, scrutinee);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, unsigned tableIndex, BoundLabel defaultOffset, VirtualRegister scrutinee)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<unsigned, size>::check(tableIndex) && Fits<BoundLabel, size>::check(defaultOffset) && Fits<VirtualRegister, size>::check(scrutinee) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<unsigned, size>::convert(tableIndex));
__generator->write(Fits<BoundLabel, size>::convert(defaultOffset));
__generator->write(Fits<VirtualRegister, size>::convert(scrutinee));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*switch_char"[!__isWide]);
                            __dumper->dumpOperand(tableIndex, true);

                __dumper->dumpOperand(defaultOffset, false);

                __dumper->dumpOperand(scrutinee, false);

        }


                    OpSwitchChar(const uint8_t* stream)
            : tableIndex(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[1])),
defaultOffset(Fits<BoundLabel, OpcodeSize::Narrow>::convert(stream[2])),
scrutinee(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpSwitchChar(const uint32_t* stream)
            : tableIndex(Fits<unsigned, OpcodeSize::Wide>::convert(stream[1])),
defaultOffset(Fits<BoundLabel, OpcodeSize::Wide>::convert(stream[2])),
scrutinee(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpSwitchChar decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setTableIndex(unsigned value, Functor func)
        {
            if (isWide())
                setTableIndex<OpcodeSize::Wide>(value, func);
            else
                setTableIndex<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setTableIndex(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }

        template<typename Functor>
        void setDefaultOffset(BoundLabel value, Functor func)
        {
            if (isWide())
                setDefaultOffset<OpcodeSize::Wide>(value, func);
            else
                setDefaultOffset<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDefaultOffset(BoundLabel value, Functor func)
        {
            if (!Fits<BoundLabel, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<BoundLabel, size>::convert(value);
        }

        template<typename Functor>
        void setScrutinee(VirtualRegister value, Functor func)
        {
            if (isWide())
                setScrutinee<OpcodeSize::Wide>(value, func);
            else
                setScrutinee<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setScrutinee(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    unsigned tableIndex;
BoundLabel defaultOffset;
VirtualRegister scrutinee;
        

        };

        struct OpSwitchString : public Instruction {
            static constexpr OpcodeID opcodeID = op_switch_string;

                    static void emit(BytecodeGenerator* __generator, unsigned tableIndex, BoundLabel defaultOffset, VirtualRegister scrutinee)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, tableIndex, defaultOffset, scrutinee) || emit<OpcodeSize::Wide, Assert, false>(__generator, tableIndex, defaultOffset, scrutinee);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, unsigned tableIndex, BoundLabel defaultOffset, VirtualRegister scrutinee)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, tableIndex, defaultOffset, scrutinee);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, unsigned tableIndex, BoundLabel defaultOffset, VirtualRegister scrutinee)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<unsigned, size>::check(tableIndex) && Fits<BoundLabel, size>::check(defaultOffset) && Fits<VirtualRegister, size>::check(scrutinee) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<unsigned, size>::convert(tableIndex));
__generator->write(Fits<BoundLabel, size>::convert(defaultOffset));
__generator->write(Fits<VirtualRegister, size>::convert(scrutinee));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*switch_string"[!__isWide]);
                            __dumper->dumpOperand(tableIndex, true);

                __dumper->dumpOperand(defaultOffset, false);

                __dumper->dumpOperand(scrutinee, false);

        }


                    OpSwitchString(const uint8_t* stream)
            : tableIndex(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[1])),
defaultOffset(Fits<BoundLabel, OpcodeSize::Narrow>::convert(stream[2])),
scrutinee(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpSwitchString(const uint32_t* stream)
            : tableIndex(Fits<unsigned, OpcodeSize::Wide>::convert(stream[1])),
defaultOffset(Fits<BoundLabel, OpcodeSize::Wide>::convert(stream[2])),
scrutinee(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpSwitchString decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setTableIndex(unsigned value, Functor func)
        {
            if (isWide())
                setTableIndex<OpcodeSize::Wide>(value, func);
            else
                setTableIndex<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setTableIndex(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }

        template<typename Functor>
        void setDefaultOffset(BoundLabel value, Functor func)
        {
            if (isWide())
                setDefaultOffset<OpcodeSize::Wide>(value, func);
            else
                setDefaultOffset<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDefaultOffset(BoundLabel value, Functor func)
        {
            if (!Fits<BoundLabel, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<BoundLabel, size>::convert(value);
        }

        template<typename Functor>
        void setScrutinee(VirtualRegister value, Functor func)
        {
            if (isWide())
                setScrutinee<OpcodeSize::Wide>(value, func);
            else
                setScrutinee<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setScrutinee(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    unsigned tableIndex;
BoundLabel defaultOffset;
VirtualRegister scrutinee;
        

        };

        struct OpNewFunc : public Instruction {
            static constexpr OpcodeID opcodeID = op_new_func;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned functionDecl)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, scope, functionDecl) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, scope, functionDecl);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned functionDecl)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, scope, functionDecl);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned functionDecl)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(scope) && Fits<unsigned, size>::check(functionDecl) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(scope));
__generator->write(Fits<unsigned, size>::convert(functionDecl));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*new_func"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(scope, false);

                __dumper->dumpOperand(functionDecl, false);

        }


                    OpNewFunc(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
scope(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
functionDecl(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpNewFunc(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
scope(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
functionDecl(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpNewFunc decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (isWide())
                setScope<OpcodeSize::Wide>(value, func);
            else
                setScope<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setFunctionDecl(unsigned value, Functor func)
        {
            if (isWide())
                setFunctionDecl<OpcodeSize::Wide>(value, func);
            else
                setFunctionDecl<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setFunctionDecl(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister scope;
unsigned functionDecl;
        

        };

        struct OpNewFuncExp : public Instruction {
            static constexpr OpcodeID opcodeID = op_new_func_exp;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned functionDecl)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, scope, functionDecl) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, scope, functionDecl);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned functionDecl)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, scope, functionDecl);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned functionDecl)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(scope) && Fits<unsigned, size>::check(functionDecl) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(scope));
__generator->write(Fits<unsigned, size>::convert(functionDecl));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*new_func_exp"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(scope, false);

                __dumper->dumpOperand(functionDecl, false);

        }


                    OpNewFuncExp(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
scope(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
functionDecl(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpNewFuncExp(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
scope(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
functionDecl(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpNewFuncExp decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (isWide())
                setScope<OpcodeSize::Wide>(value, func);
            else
                setScope<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setFunctionDecl(unsigned value, Functor func)
        {
            if (isWide())
                setFunctionDecl<OpcodeSize::Wide>(value, func);
            else
                setFunctionDecl<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setFunctionDecl(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister scope;
unsigned functionDecl;
        

        };

        struct OpNewGeneratorFunc : public Instruction {
            static constexpr OpcodeID opcodeID = op_new_generator_func;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned functionDecl)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, scope, functionDecl) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, scope, functionDecl);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned functionDecl)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, scope, functionDecl);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned functionDecl)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(scope) && Fits<unsigned, size>::check(functionDecl) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(scope));
__generator->write(Fits<unsigned, size>::convert(functionDecl));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*new_generator_func"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(scope, false);

                __dumper->dumpOperand(functionDecl, false);

        }


                    OpNewGeneratorFunc(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
scope(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
functionDecl(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpNewGeneratorFunc(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
scope(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
functionDecl(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpNewGeneratorFunc decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (isWide())
                setScope<OpcodeSize::Wide>(value, func);
            else
                setScope<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setFunctionDecl(unsigned value, Functor func)
        {
            if (isWide())
                setFunctionDecl<OpcodeSize::Wide>(value, func);
            else
                setFunctionDecl<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setFunctionDecl(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister scope;
unsigned functionDecl;
        

        };

        struct OpNewGeneratorFuncExp : public Instruction {
            static constexpr OpcodeID opcodeID = op_new_generator_func_exp;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned functionDecl)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, scope, functionDecl) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, scope, functionDecl);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned functionDecl)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, scope, functionDecl);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned functionDecl)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(scope) && Fits<unsigned, size>::check(functionDecl) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(scope));
__generator->write(Fits<unsigned, size>::convert(functionDecl));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*new_generator_func_exp"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(scope, false);

                __dumper->dumpOperand(functionDecl, false);

        }


                    OpNewGeneratorFuncExp(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
scope(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
functionDecl(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpNewGeneratorFuncExp(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
scope(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
functionDecl(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpNewGeneratorFuncExp decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (isWide())
                setScope<OpcodeSize::Wide>(value, func);
            else
                setScope<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setFunctionDecl(unsigned value, Functor func)
        {
            if (isWide())
                setFunctionDecl<OpcodeSize::Wide>(value, func);
            else
                setFunctionDecl<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setFunctionDecl(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister scope;
unsigned functionDecl;
        

        };

        struct OpNewAsyncFunc : public Instruction {
            static constexpr OpcodeID opcodeID = op_new_async_func;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned functionDecl)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, scope, functionDecl) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, scope, functionDecl);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned functionDecl)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, scope, functionDecl);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned functionDecl)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(scope) && Fits<unsigned, size>::check(functionDecl) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(scope));
__generator->write(Fits<unsigned, size>::convert(functionDecl));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*new_async_func"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(scope, false);

                __dumper->dumpOperand(functionDecl, false);

        }


                    OpNewAsyncFunc(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
scope(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
functionDecl(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpNewAsyncFunc(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
scope(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
functionDecl(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpNewAsyncFunc decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (isWide())
                setScope<OpcodeSize::Wide>(value, func);
            else
                setScope<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setFunctionDecl(unsigned value, Functor func)
        {
            if (isWide())
                setFunctionDecl<OpcodeSize::Wide>(value, func);
            else
                setFunctionDecl<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setFunctionDecl(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister scope;
unsigned functionDecl;
        

        };

        struct OpNewAsyncFuncExp : public Instruction {
            static constexpr OpcodeID opcodeID = op_new_async_func_exp;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned functionDecl)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, scope, functionDecl) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, scope, functionDecl);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned functionDecl)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, scope, functionDecl);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned functionDecl)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(scope) && Fits<unsigned, size>::check(functionDecl) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(scope));
__generator->write(Fits<unsigned, size>::convert(functionDecl));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*new_async_func_exp"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(scope, false);

                __dumper->dumpOperand(functionDecl, false);

        }


                    OpNewAsyncFuncExp(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
scope(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
functionDecl(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpNewAsyncFuncExp(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
scope(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
functionDecl(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpNewAsyncFuncExp decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (isWide())
                setScope<OpcodeSize::Wide>(value, func);
            else
                setScope<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setFunctionDecl(unsigned value, Functor func)
        {
            if (isWide())
                setFunctionDecl<OpcodeSize::Wide>(value, func);
            else
                setFunctionDecl<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setFunctionDecl(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister scope;
unsigned functionDecl;
        

        };

        struct OpNewAsyncGeneratorFunc : public Instruction {
            static constexpr OpcodeID opcodeID = op_new_async_generator_func;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned functionDecl)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, scope, functionDecl) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, scope, functionDecl);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned functionDecl)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, scope, functionDecl);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned functionDecl)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(scope) && Fits<unsigned, size>::check(functionDecl) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(scope));
__generator->write(Fits<unsigned, size>::convert(functionDecl));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*new_async_generator_func"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(scope, false);

                __dumper->dumpOperand(functionDecl, false);

        }


                    OpNewAsyncGeneratorFunc(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
scope(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
functionDecl(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpNewAsyncGeneratorFunc(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
scope(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
functionDecl(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpNewAsyncGeneratorFunc decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (isWide())
                setScope<OpcodeSize::Wide>(value, func);
            else
                setScope<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setFunctionDecl(unsigned value, Functor func)
        {
            if (isWide())
                setFunctionDecl<OpcodeSize::Wide>(value, func);
            else
                setFunctionDecl<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setFunctionDecl(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister scope;
unsigned functionDecl;
        

        };

        struct OpNewAsyncGeneratorFuncExp : public Instruction {
            static constexpr OpcodeID opcodeID = op_new_async_generator_func_exp;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned functionDecl)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, scope, functionDecl) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, scope, functionDecl);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned functionDecl)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, scope, functionDecl);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned functionDecl)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(scope) && Fits<unsigned, size>::check(functionDecl) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(scope));
__generator->write(Fits<unsigned, size>::convert(functionDecl));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*new_async_generator_func_exp"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(scope, false);

                __dumper->dumpOperand(functionDecl, false);

        }


                    OpNewAsyncGeneratorFuncExp(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
scope(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
functionDecl(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpNewAsyncGeneratorFuncExp(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
scope(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
functionDecl(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpNewAsyncGeneratorFuncExp decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (isWide())
                setScope<OpcodeSize::Wide>(value, func);
            else
                setScope<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setFunctionDecl(unsigned value, Functor func)
        {
            if (isWide())
                setFunctionDecl<OpcodeSize::Wide>(value, func);
            else
                setFunctionDecl<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setFunctionDecl(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister scope;
unsigned functionDecl;
        

        };

        struct OpSetFunctionName : public Instruction {
            static constexpr OpcodeID opcodeID = op_set_function_name;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister function, VirtualRegister name)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, function, name) || emit<OpcodeSize::Wide, Assert, false>(__generator, function, name);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister function, VirtualRegister name)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, function, name);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister function, VirtualRegister name)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(function) && Fits<VirtualRegister, size>::check(name) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(function));
__generator->write(Fits<VirtualRegister, size>::convert(name));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*set_function_name"[!__isWide]);
                            __dumper->dumpOperand(function, true);

                __dumper->dumpOperand(name, false);

        }


                    OpSetFunctionName(const uint8_t* stream)
            : function(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
name(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpSetFunctionName(const uint32_t* stream)
            : function(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
name(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpSetFunctionName decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setFunction(VirtualRegister value, Functor func)
        {
            if (isWide())
                setFunction<OpcodeSize::Wide>(value, func);
            else
                setFunction<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setFunction(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setName(VirtualRegister value, Functor func)
        {
            if (isWide())
                setName<OpcodeSize::Wide>(value, func);
            else
                setName<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setName(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister function;
VirtualRegister name;
        

        };

        struct OpRet : public Instruction {
            static constexpr OpcodeID opcodeID = op_ret;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister value)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, value) || emit<OpcodeSize::Wide, Assert, false>(__generator, value);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister value)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, value);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister value)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(value) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(value));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*ret"[!__isWide]);
                            __dumper->dumpOperand(value, true);

        }


                    OpRet(const uint8_t* stream)
            : value(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpRet(const uint32_t* stream)
            : value(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpRet decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (isWide())
                setValue<OpcodeSize::Wide>(value, func);
            else
                setValue<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister value;
        

        };

        struct OpStrcat : public Instruction {
            static constexpr OpcodeID opcodeID = op_strcat;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister src, int count)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, src, count) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, src, count);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister src, int count)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, src, count);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister src, int count)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(src) && Fits<int, size>::check(count) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(src));
__generator->write(Fits<int, size>::convert(count));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*strcat"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(src, false);

                __dumper->dumpOperand(count, false);

        }


                    OpStrcat(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
src(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
count(Fits<int, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpStrcat(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
src(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
count(Fits<int, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpStrcat decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setSrc(VirtualRegister value, Functor func)
        {
            if (isWide())
                setSrc<OpcodeSize::Wide>(value, func);
            else
                setSrc<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setSrc(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setCount(int value, Functor func)
        {
            if (isWide())
                setCount<OpcodeSize::Wide>(value, func);
            else
                setCount<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setCount(int value, Functor func)
        {
            if (!Fits<int, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<int, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister src;
int count;
        

        };

        struct OpToPrimitive : public Instruction {
            static constexpr OpcodeID opcodeID = op_to_primitive;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister src)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, src) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, src);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister src)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, src);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister src)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(src) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(src));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*to_primitive"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(src, false);

        }


                    OpToPrimitive(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
src(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpToPrimitive(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
src(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpToPrimitive decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setSrc(VirtualRegister value, Functor func)
        {
            if (isWide())
                setSrc<OpcodeSize::Wide>(value, func);
            else
                setSrc<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setSrc(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister src;
        

        };

        struct OpPutToArguments : public Instruction {
            static constexpr OpcodeID opcodeID = op_put_to_arguments;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister arguments, unsigned index, VirtualRegister value)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, arguments, index, value) || emit<OpcodeSize::Wide, Assert, false>(__generator, arguments, index, value);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister arguments, unsigned index, VirtualRegister value)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, arguments, index, value);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister arguments, unsigned index, VirtualRegister value)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(arguments) && Fits<unsigned, size>::check(index) && Fits<VirtualRegister, size>::check(value) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(arguments));
__generator->write(Fits<unsigned, size>::convert(index));
__generator->write(Fits<VirtualRegister, size>::convert(value));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*put_to_arguments"[!__isWide]);
                            __dumper->dumpOperand(arguments, true);

                __dumper->dumpOperand(index, false);

                __dumper->dumpOperand(value, false);

        }


                    OpPutToArguments(const uint8_t* stream)
            : arguments(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
index(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[2])),
value(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpPutToArguments(const uint32_t* stream)
            : arguments(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
index(Fits<unsigned, OpcodeSize::Wide>::convert(stream[2])),
value(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpPutToArguments decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setArguments(VirtualRegister value, Functor func)
        {
            if (isWide())
                setArguments<OpcodeSize::Wide>(value, func);
            else
                setArguments<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setArguments(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setIndex(unsigned value, Functor func)
        {
            if (isWide())
                setIndex<OpcodeSize::Wide>(value, func);
            else
                setIndex<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setIndex(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }

        template<typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (isWide())
                setValue<OpcodeSize::Wide>(value, func);
            else
                setValue<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister arguments;
unsigned index;
VirtualRegister value;
        

        };

        struct OpPushWithScope : public Instruction {
            static constexpr OpcodeID opcodeID = op_push_with_scope;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister currentScope, VirtualRegister newScope)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, currentScope, newScope) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, currentScope, newScope);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister currentScope, VirtualRegister newScope)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, currentScope, newScope);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister currentScope, VirtualRegister newScope)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(currentScope) && Fits<VirtualRegister, size>::check(newScope) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(currentScope));
__generator->write(Fits<VirtualRegister, size>::convert(newScope));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*push_with_scope"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(currentScope, false);

                __dumper->dumpOperand(newScope, false);

        }


                    OpPushWithScope(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
currentScope(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
newScope(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpPushWithScope(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
currentScope(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
newScope(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpPushWithScope decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setCurrentScope(VirtualRegister value, Functor func)
        {
            if (isWide())
                setCurrentScope<OpcodeSize::Wide>(value, func);
            else
                setCurrentScope<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setCurrentScope(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setNewScope(VirtualRegister value, Functor func)
        {
            if (isWide())
                setNewScope<OpcodeSize::Wide>(value, func);
            else
                setNewScope<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setNewScope(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister currentScope;
VirtualRegister newScope;
        

        };

        struct OpCreateLexicalEnvironment : public Instruction {
            static constexpr OpcodeID opcodeID = op_create_lexical_environment;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, VirtualRegister symbolTable, VirtualRegister initialValue)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, scope, symbolTable, initialValue) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, scope, symbolTable, initialValue);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, VirtualRegister symbolTable, VirtualRegister initialValue)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, scope, symbolTable, initialValue);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, VirtualRegister symbolTable, VirtualRegister initialValue)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(scope) && Fits<VirtualRegister, size>::check(symbolTable) && Fits<VirtualRegister, size>::check(initialValue) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(scope));
__generator->write(Fits<VirtualRegister, size>::convert(symbolTable));
__generator->write(Fits<VirtualRegister, size>::convert(initialValue));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*create_lexical_environment"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(scope, false);

                __dumper->dumpOperand(symbolTable, false);

                __dumper->dumpOperand(initialValue, false);

        }


                    OpCreateLexicalEnvironment(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
scope(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
symbolTable(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3])),
initialValue(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpCreateLexicalEnvironment(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
scope(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
symbolTable(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3])),
initialValue(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpCreateLexicalEnvironment decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (isWide())
                setScope<OpcodeSize::Wide>(value, func);
            else
                setScope<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setSymbolTable(VirtualRegister value, Functor func)
        {
            if (isWide())
                setSymbolTable<OpcodeSize::Wide>(value, func);
            else
                setSymbolTable<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setSymbolTable(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setInitialValue(VirtualRegister value, Functor func)
        {
            if (isWide())
                setInitialValue<OpcodeSize::Wide>(value, func);
            else
                setInitialValue<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setInitialValue(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister scope;
VirtualRegister symbolTable;
VirtualRegister initialValue;
        

        };

        struct OpGetParentScope : public Instruction {
            static constexpr OpcodeID opcodeID = op_get_parent_scope;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, scope) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, scope);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, scope);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(scope) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(scope));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*get_parent_scope"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(scope, false);

        }


                    OpGetParentScope(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
scope(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpGetParentScope(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
scope(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpGetParentScope decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (isWide())
                setScope<OpcodeSize::Wide>(value, func);
            else
                setScope<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister scope;
        

        };

        struct OpThrow : public Instruction {
            static constexpr OpcodeID opcodeID = op_throw;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister value)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, value) || emit<OpcodeSize::Wide, Assert, false>(__generator, value);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister value)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, value);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister value)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(value) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(value));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*throw"[!__isWide]);
                            __dumper->dumpOperand(value, true);

        }


                    OpThrow(const uint8_t* stream)
            : value(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpThrow(const uint32_t* stream)
            : value(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpThrow decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (isWide())
                setValue<OpcodeSize::Wide>(value, func);
            else
                setValue<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister value;
        

        };

        struct OpThrowStaticError : public Instruction {
            static constexpr OpcodeID opcodeID = op_throw_static_error;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister message, ErrorType errorType)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, message, errorType) || emit<OpcodeSize::Wide, Assert, false>(__generator, message, errorType);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister message, ErrorType errorType)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, message, errorType);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister message, ErrorType errorType)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(message) && Fits<ErrorType, size>::check(errorType) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(message));
__generator->write(Fits<ErrorType, size>::convert(errorType));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*throw_static_error"[!__isWide]);
                            __dumper->dumpOperand(message, true);

                __dumper->dumpOperand(errorType, false);

        }


                    OpThrowStaticError(const uint8_t* stream)
            : message(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
errorType(Fits<ErrorType, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpThrowStaticError(const uint32_t* stream)
            : message(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
errorType(Fits<ErrorType, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpThrowStaticError decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setMessage(VirtualRegister value, Functor func)
        {
            if (isWide())
                setMessage<OpcodeSize::Wide>(value, func);
            else
                setMessage<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setMessage(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setErrorType(ErrorType value, Functor func)
        {
            if (isWide())
                setErrorType<OpcodeSize::Wide>(value, func);
            else
                setErrorType<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setErrorType(ErrorType value, Functor func)
        {
            if (!Fits<ErrorType, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<ErrorType, size>::convert(value);
        }


                    

        


                    VirtualRegister message;
ErrorType errorType;
        

        };

        struct OpDebug : public Instruction {
            static constexpr OpcodeID opcodeID = op_debug;

                    static void emit(BytecodeGenerator* __generator, DebugHookType debugHookType, bool hasBreakpoint)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, debugHookType, hasBreakpoint) || emit<OpcodeSize::Wide, Assert, false>(__generator, debugHookType, hasBreakpoint);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, DebugHookType debugHookType, bool hasBreakpoint)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, debugHookType, hasBreakpoint);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, DebugHookType debugHookType, bool hasBreakpoint)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<DebugHookType, size>::check(debugHookType) && Fits<bool, size>::check(hasBreakpoint) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<DebugHookType, size>::convert(debugHookType));
__generator->write(Fits<bool, size>::convert(hasBreakpoint));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*debug"[!__isWide]);
                            __dumper->dumpOperand(debugHookType, true);

                __dumper->dumpOperand(hasBreakpoint, false);

        }


                    OpDebug(const uint8_t* stream)
            : debugHookType(Fits<DebugHookType, OpcodeSize::Narrow>::convert(stream[1])),
hasBreakpoint(Fits<bool, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpDebug(const uint32_t* stream)
            : debugHookType(Fits<DebugHookType, OpcodeSize::Wide>::convert(stream[1])),
hasBreakpoint(Fits<bool, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpDebug decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDebugHookType(DebugHookType value, Functor func)
        {
            if (isWide())
                setDebugHookType<OpcodeSize::Wide>(value, func);
            else
                setDebugHookType<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDebugHookType(DebugHookType value, Functor func)
        {
            if (!Fits<DebugHookType, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<DebugHookType, size>::convert(value);
        }

        template<typename Functor>
        void setHasBreakpoint(bool value, Functor func)
        {
            if (isWide())
                setHasBreakpoint<OpcodeSize::Wide>(value, func);
            else
                setHasBreakpoint<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setHasBreakpoint(bool value, Functor func)
        {
            if (!Fits<bool, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<bool, size>::convert(value);
        }


                    

        


                    DebugHookType debugHookType;
bool hasBreakpoint;
        

        };

        struct OpEnd : public Instruction {
            static constexpr OpcodeID opcodeID = op_end;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister value)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, value) || emit<OpcodeSize::Wide, Assert, false>(__generator, value);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister value)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, value);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister value)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(value) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(value));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*end"[!__isWide]);
                            __dumper->dumpOperand(value, true);

        }


                    OpEnd(const uint8_t* stream)
            : value(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpEnd(const uint32_t* stream)
            : value(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpEnd decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (isWide())
                setValue<OpcodeSize::Wide>(value, func);
            else
                setValue<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setValue(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister value;
        

        };

        struct OpGetEnumerableLength : public Instruction {
            static constexpr OpcodeID opcodeID = op_get_enumerable_length;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, base) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, base);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, base);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(base) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(base));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*get_enumerable_length"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(base, false);

        }


                    OpGetEnumerableLength(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpGetEnumerableLength(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpGetEnumerableLength decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (isWide())
                setBase<OpcodeSize::Wide>(value, func);
            else
                setBase<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister base;
        

        };

        struct OpHasStructureProperty : public Instruction {
            static constexpr OpcodeID opcodeID = op_has_structure_property;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister property, VirtualRegister enumerator)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, base, property, enumerator) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, base, property, enumerator);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister property, VirtualRegister enumerator)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, base, property, enumerator);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister property, VirtualRegister enumerator)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(base) && Fits<VirtualRegister, size>::check(property) && Fits<VirtualRegister, size>::check(enumerator) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(base));
__generator->write(Fits<VirtualRegister, size>::convert(property));
__generator->write(Fits<VirtualRegister, size>::convert(enumerator));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*has_structure_property"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(base, false);

                __dumper->dumpOperand(property, false);

                __dumper->dumpOperand(enumerator, false);

        }


                    OpHasStructureProperty(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
property(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3])),
enumerator(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpHasStructureProperty(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
property(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3])),
enumerator(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[4]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpHasStructureProperty decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (isWide())
                setBase<OpcodeSize::Wide>(value, func);
            else
                setBase<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setProperty(VirtualRegister value, Functor func)
        {
            if (isWide())
                setProperty<OpcodeSize::Wide>(value, func);
            else
                setProperty<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setProperty(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setEnumerator(VirtualRegister value, Functor func)
        {
            if (isWide())
                setEnumerator<OpcodeSize::Wide>(value, func);
            else
                setEnumerator<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setEnumerator(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 4 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister base;
VirtualRegister property;
VirtualRegister enumerator;
        

        };

        struct OpHasGenericProperty : public Instruction {
            static constexpr OpcodeID opcodeID = op_has_generic_property;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister property)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, base, property) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, base, property);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister property)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, base, property);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base, VirtualRegister property)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(base) && Fits<VirtualRegister, size>::check(property) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(base));
__generator->write(Fits<VirtualRegister, size>::convert(property));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*has_generic_property"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(base, false);

                __dumper->dumpOperand(property, false);

        }


                    OpHasGenericProperty(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
property(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpHasGenericProperty(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
property(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpHasGenericProperty decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (isWide())
                setBase<OpcodeSize::Wide>(value, func);
            else
                setBase<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setProperty(VirtualRegister value, Functor func)
        {
            if (isWide())
                setProperty<OpcodeSize::Wide>(value, func);
            else
                setProperty<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setProperty(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister base;
VirtualRegister property;
        

        };

        struct OpGetPropertyEnumerator : public Instruction {
            static constexpr OpcodeID opcodeID = op_get_property_enumerator;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, base) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, base);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, base);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister base)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(base) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(base));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*get_property_enumerator"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(base, false);

        }


                    OpGetPropertyEnumerator(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpGetPropertyEnumerator(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
base(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpGetPropertyEnumerator decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (isWide())
                setBase<OpcodeSize::Wide>(value, func);
            else
                setBase<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setBase(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister base;
        

        };

        struct OpEnumeratorStructurePname : public Instruction {
            static constexpr OpcodeID opcodeID = op_enumerator_structure_pname;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister enumerator, VirtualRegister index)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, enumerator, index) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, enumerator, index);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister enumerator, VirtualRegister index)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, enumerator, index);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister enumerator, VirtualRegister index)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(enumerator) && Fits<VirtualRegister, size>::check(index) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(enumerator));
__generator->write(Fits<VirtualRegister, size>::convert(index));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*enumerator_structure_pname"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(enumerator, false);

                __dumper->dumpOperand(index, false);

        }


                    OpEnumeratorStructurePname(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
enumerator(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
index(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpEnumeratorStructurePname(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
enumerator(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
index(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpEnumeratorStructurePname decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setEnumerator(VirtualRegister value, Functor func)
        {
            if (isWide())
                setEnumerator<OpcodeSize::Wide>(value, func);
            else
                setEnumerator<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setEnumerator(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setIndex(VirtualRegister value, Functor func)
        {
            if (isWide())
                setIndex<OpcodeSize::Wide>(value, func);
            else
                setIndex<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setIndex(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister enumerator;
VirtualRegister index;
        

        };

        struct OpEnumeratorGenericPname : public Instruction {
            static constexpr OpcodeID opcodeID = op_enumerator_generic_pname;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister enumerator, VirtualRegister index)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, enumerator, index) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, enumerator, index);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister enumerator, VirtualRegister index)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, enumerator, index);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister enumerator, VirtualRegister index)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(enumerator) && Fits<VirtualRegister, size>::check(index) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(enumerator));
__generator->write(Fits<VirtualRegister, size>::convert(index));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*enumerator_generic_pname"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(enumerator, false);

                __dumper->dumpOperand(index, false);

        }


                    OpEnumeratorGenericPname(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
enumerator(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
index(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpEnumeratorGenericPname(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
enumerator(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
index(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpEnumeratorGenericPname decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setEnumerator(VirtualRegister value, Functor func)
        {
            if (isWide())
                setEnumerator<OpcodeSize::Wide>(value, func);
            else
                setEnumerator<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setEnumerator(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setIndex(VirtualRegister value, Functor func)
        {
            if (isWide())
                setIndex<OpcodeSize::Wide>(value, func);
            else
                setIndex<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setIndex(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister enumerator;
VirtualRegister index;
        

        };

        struct OpToIndexString : public Instruction {
            static constexpr OpcodeID opcodeID = op_to_index_string;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister index)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, index) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, index);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister index)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, index);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister index)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(index) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(index));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*to_index_string"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(index, false);

        }


                    OpToIndexString(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
index(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpToIndexString(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
index(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpToIndexString decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setIndex(VirtualRegister value, Functor func)
        {
            if (isWide())
                setIndex<OpcodeSize::Wide>(value, func);
            else
                setIndex<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setIndex(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister index;
        

        };

        struct OpUnreachable : public Instruction {
            static constexpr OpcodeID opcodeID = op_unreachable;

                    static void emit(BytecodeGenerator* __generator)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator) || emit<OpcodeSize::Wide, Assert, false>(__generator);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*unreachable"[!__isWide]);
            
        }


                    OpUnreachable(const uint8_t* stream)
            
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpUnreachable(const uint32_t* stream)
            
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpUnreachable decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



            

                    

        


                    
        

        };

        struct OpCreateRest : public Instruction {
            static constexpr OpcodeID opcodeID = op_create_rest;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister arraySize, unsigned numParametersToSkip)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, arraySize, numParametersToSkip) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, arraySize, numParametersToSkip);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister arraySize, unsigned numParametersToSkip)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, arraySize, numParametersToSkip);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister arraySize, unsigned numParametersToSkip)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(arraySize) && Fits<unsigned, size>::check(numParametersToSkip) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(arraySize));
__generator->write(Fits<unsigned, size>::convert(numParametersToSkip));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*create_rest"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(arraySize, false);

                __dumper->dumpOperand(numParametersToSkip, false);

        }


                    OpCreateRest(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
arraySize(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
numParametersToSkip(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpCreateRest(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
arraySize(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
numParametersToSkip(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpCreateRest decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setArraySize(VirtualRegister value, Functor func)
        {
            if (isWide())
                setArraySize<OpcodeSize::Wide>(value, func);
            else
                setArraySize<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setArraySize(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setNumParametersToSkip(unsigned value, Functor func)
        {
            if (isWide())
                setNumParametersToSkip<OpcodeSize::Wide>(value, func);
            else
                setNumParametersToSkip<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setNumParametersToSkip(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister arraySize;
unsigned numParametersToSkip;
        

        };

        struct OpGetRestLength : public Instruction {
            static constexpr OpcodeID opcodeID = op_get_rest_length;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, unsigned numParametersToSkip)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, numParametersToSkip) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, numParametersToSkip);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, unsigned numParametersToSkip)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, numParametersToSkip);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, unsigned numParametersToSkip)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<unsigned, size>::check(numParametersToSkip) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<unsigned, size>::convert(numParametersToSkip));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*get_rest_length"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(numParametersToSkip, false);

        }


                    OpGetRestLength(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
numParametersToSkip(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpGetRestLength(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
numParametersToSkip(Fits<unsigned, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpGetRestLength decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setNumParametersToSkip(unsigned value, Functor func)
        {
            if (isWide())
                setNumParametersToSkip<OpcodeSize::Wide>(value, func);
            else
                setNumParametersToSkip<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setNumParametersToSkip(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
unsigned numParametersToSkip;
        

        };

        struct OpYield : public Instruction {
            static constexpr OpcodeID opcodeID = op_yield;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister generator, unsigned yieldPoint, VirtualRegister argument)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, generator, yieldPoint, argument) || emit<OpcodeSize::Wide, Assert, false>(__generator, generator, yieldPoint, argument);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister generator, unsigned yieldPoint, VirtualRegister argument)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, generator, yieldPoint, argument);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister generator, unsigned yieldPoint, VirtualRegister argument)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(generator) && Fits<unsigned, size>::check(yieldPoint) && Fits<VirtualRegister, size>::check(argument) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(generator));
__generator->write(Fits<unsigned, size>::convert(yieldPoint));
__generator->write(Fits<VirtualRegister, size>::convert(argument));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*yield"[!__isWide]);
                            __dumper->dumpOperand(generator, true);

                __dumper->dumpOperand(yieldPoint, false);

                __dumper->dumpOperand(argument, false);

        }


                    OpYield(const uint8_t* stream)
            : generator(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
yieldPoint(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[2])),
argument(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpYield(const uint32_t* stream)
            : generator(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
yieldPoint(Fits<unsigned, OpcodeSize::Wide>::convert(stream[2])),
argument(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpYield decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setGenerator(VirtualRegister value, Functor func)
        {
            if (isWide())
                setGenerator<OpcodeSize::Wide>(value, func);
            else
                setGenerator<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setGenerator(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setYieldPoint(unsigned value, Functor func)
        {
            if (isWide())
                setYieldPoint<OpcodeSize::Wide>(value, func);
            else
                setYieldPoint<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setYieldPoint(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }

        template<typename Functor>
        void setArgument(VirtualRegister value, Functor func)
        {
            if (isWide())
                setArgument<OpcodeSize::Wide>(value, func);
            else
                setArgument<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setArgument(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister generator;
unsigned yieldPoint;
VirtualRegister argument;
        

        };

        struct OpCheckTraps : public Instruction {
            static constexpr OpcodeID opcodeID = op_check_traps;

                    static void emit(BytecodeGenerator* __generator)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator) || emit<OpcodeSize::Wide, Assert, false>(__generator);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*check_traps"[!__isWide]);
            
        }


                    OpCheckTraps(const uint8_t* stream)
            
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpCheckTraps(const uint32_t* stream)
            
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpCheckTraps decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



            

                    

        


                    
        

        };

        struct OpLogShadowChickenPrologue : public Instruction {
            static constexpr OpcodeID opcodeID = op_log_shadow_chicken_prologue;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister scope)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, scope) || emit<OpcodeSize::Wide, Assert, false>(__generator, scope);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister scope)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, scope);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister scope)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(scope) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(scope));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*log_shadow_chicken_prologue"[!__isWide]);
                            __dumper->dumpOperand(scope, true);

        }


                    OpLogShadowChickenPrologue(const uint8_t* stream)
            : scope(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpLogShadowChickenPrologue(const uint32_t* stream)
            : scope(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpLogShadowChickenPrologue decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (isWide())
                setScope<OpcodeSize::Wide>(value, func);
            else
                setScope<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister scope;
        

        };

        struct OpLogShadowChickenTail : public Instruction {
            static constexpr OpcodeID opcodeID = op_log_shadow_chicken_tail;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister thisValue, VirtualRegister scope)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, thisValue, scope) || emit<OpcodeSize::Wide, Assert, false>(__generator, thisValue, scope);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister thisValue, VirtualRegister scope)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, thisValue, scope);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister thisValue, VirtualRegister scope)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(thisValue) && Fits<VirtualRegister, size>::check(scope) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(thisValue));
__generator->write(Fits<VirtualRegister, size>::convert(scope));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*log_shadow_chicken_tail"[!__isWide]);
                            __dumper->dumpOperand(thisValue, true);

                __dumper->dumpOperand(scope, false);

        }


                    OpLogShadowChickenTail(const uint8_t* stream)
            : thisValue(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
scope(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpLogShadowChickenTail(const uint32_t* stream)
            : thisValue(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
scope(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpLogShadowChickenTail decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setThisValue(VirtualRegister value, Functor func)
        {
            if (isWide())
                setThisValue<OpcodeSize::Wide>(value, func);
            else
                setThisValue<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setThisValue(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (isWide())
                setScope<OpcodeSize::Wide>(value, func);
            else
                setScope<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }


                    

        


                    VirtualRegister thisValue;
VirtualRegister scope;
        

        };

        struct OpResolveScopeForHoistingFuncDeclInEval : public Instruction {
            static constexpr OpcodeID opcodeID = op_resolve_scope_for_hoisting_func_decl_in_eval;

                    static void emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned property)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator, dst, scope, property) || emit<OpcodeSize::Wide, Assert, false>(__generator, dst, scope, property);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned property)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator, dst, scope, property);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator, VirtualRegister dst, VirtualRegister scope, unsigned property)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && Fits<VirtualRegister, size>::check(dst) && Fits<VirtualRegister, size>::check(scope) && Fits<unsigned, size>::check(property) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
__generator->write(Fits<VirtualRegister, size>::convert(dst));
__generator->write(Fits<VirtualRegister, size>::convert(scope));
__generator->write(Fits<unsigned, size>::convert(property));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*resolve_scope_for_hoisting_func_decl_in_eval"[!__isWide]);
                            __dumper->dumpOperand(dst, true);

                __dumper->dumpOperand(scope, false);

                __dumper->dumpOperand(property, false);

        }


                    OpResolveScopeForHoistingFuncDeclInEval(const uint8_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[1])),
scope(Fits<VirtualRegister, OpcodeSize::Narrow>::convert(stream[2])),
property(Fits<unsigned, OpcodeSize::Narrow>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpResolveScopeForHoistingFuncDeclInEval(const uint32_t* stream)
            : dst(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[1])),
scope(Fits<VirtualRegister, OpcodeSize::Wide>::convert(stream[2])),
property(Fits<unsigned, OpcodeSize::Wide>::convert(stream[3]))
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpResolveScopeForHoistingFuncDeclInEval decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



                    template<typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (isWide())
                setDst<OpcodeSize::Wide>(value, func);
            else
                setDst<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setDst(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 1 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (isWide())
                setScope<OpcodeSize::Wide>(value, func);
            else
                setScope<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setScope(VirtualRegister value, Functor func)
        {
            if (!Fits<VirtualRegister, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 2 * size + PaddingBySize<size>::value);
            *stream = Fits<VirtualRegister, size>::convert(value);
        }

        template<typename Functor>
        void setProperty(unsigned value, Functor func)
        {
            if (isWide())
                setProperty<OpcodeSize::Wide>(value, func);
            else
                setProperty<OpcodeSize::Narrow>(value, func);
        }

        template <OpcodeSize size, typename Functor>
        void setProperty(unsigned value, Functor func)
        {
            if (!Fits<unsigned, size>::check(value))
                value = func();
            auto* stream = bitwise_cast<typename TypeBySize<size>::type*>(reinterpret_cast<uint8_t*>(this) + 3 * size + PaddingBySize<size>::value);
            *stream = Fits<unsigned, size>::convert(value);
        }


                    

        


                    VirtualRegister dst;
VirtualRegister scope;
unsigned property;
        

        };

        struct OpNop : public Instruction {
            static constexpr OpcodeID opcodeID = op_nop;

                    static void emit(BytecodeGenerator* __generator)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator) || emit<OpcodeSize::Wide, Assert, false>(__generator);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*nop"[!__isWide]);
            
        }


                    OpNop(const uint8_t* stream)
            
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpNop(const uint32_t* stream)
            
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpNop decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



            

                    

        


                    
        

        };

        struct OpSuperSamplerBegin : public Instruction {
            static constexpr OpcodeID opcodeID = op_super_sampler_begin;

                    static void emit(BytecodeGenerator* __generator)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator) || emit<OpcodeSize::Wide, Assert, false>(__generator);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*super_sampler_begin"[!__isWide]);
            
        }


                    OpSuperSamplerBegin(const uint8_t* stream)
            
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpSuperSamplerBegin(const uint32_t* stream)
            
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpSuperSamplerBegin decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



            

                    

        


                    
        

        };

        struct OpSuperSamplerEnd : public Instruction {
            static constexpr OpcodeID opcodeID = op_super_sampler_end;

                    static void emit(BytecodeGenerator* __generator)
        {
            __generator->recordOpcode(opcodeID);
            
            emit<OpcodeSize::Narrow, NoAssert, false>(__generator) || emit<OpcodeSize::Wide, Assert, false>(__generator);
        }

        

        template<OpcodeSize size, FitsAssertion shouldAssert = Assert, bool recordOpcode = true>
        static bool emit(BytecodeGenerator* __generator)
        {
            if (recordOpcode)
                __generator->recordOpcode(opcodeID);
            bool didEmit = emitImpl<size>(__generator);
            if (shouldAssert == Assert)
                ASSERT(didEmit);
            return didEmit;
        }

        private:
        template<OpcodeSize size>
        static bool emitImpl(BytecodeGenerator* __generator)
        {
            if (size == OpcodeSize::Wide)
                __generator->alignWideOpcode();
            if (Fits<unsigned, size>::check(opcodeID) && (size == OpcodeSize::Wide ? Fits<unsigned, OpcodeSize::Narrow>::check(op_wide) : true)) {
                if (size == OpcodeSize::Wide)
                    __generator->write(Fits<unsigned, OpcodeSize::Narrow>::convert(op_wide));
                __generator->write(Fits<unsigned, size>::convert(opcodeID));
                return true;
            }
            return false;
        }
        public:


                    template<typename Block>
        void dump(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, bool __isWide)
        {
            __dumper->printLocationAndOp(__location, &"*super_sampler_end"[!__isWide]);
            
        }


                    OpSuperSamplerEnd(const uint8_t* stream)
            
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        OpSuperSamplerEnd(const uint32_t* stream)
            
        { ASSERT_UNUSED(stream, stream[0] == opcodeID); }

        static OpSuperSamplerEnd decode(const uint8_t* stream)
        {
            if (*stream != op_wide)
                return { stream };

            auto wideStream = bitwise_cast<const uint32_t*>(stream + 1);
            return { wideStream };
        }



            

                    

        


                    
        

        };


                    template<typename Block>
        static void dumpBytecode(BytecodeDumper<Block>* __dumper, InstructionStream::Offset __location, const Instruction* __instruction)
        {
            switch (__instruction->opcodeID()) {
                            case op_create_this:
                    __instruction->as<OpCreateThis>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_get_argument:
                    __instruction->as<OpGetArgument>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_to_this:
                    __instruction->as<OpToThis>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_new_object:
                    __instruction->as<OpNewObject>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_new_array:
                    __instruction->as<OpNewArray>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_new_array_with_size:
                    __instruction->as<OpNewArrayWithSize>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_new_array_buffer:
                    __instruction->as<OpNewArrayBuffer>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_add:
                    __instruction->as<OpAdd>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_mul:
                    __instruction->as<OpMul>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_div:
                    __instruction->as<OpDiv>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_sub:
                    __instruction->as<OpSub>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_bitxor:
                    __instruction->as<OpBitxor>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_bitand:
                    __instruction->as<OpBitand>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_bitor:
                    __instruction->as<OpBitor>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_to_object:
                    __instruction->as<OpToObject>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_to_number:
                    __instruction->as<OpToNumber>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_negate:
                    __instruction->as<OpNegate>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_in_by_val:
                    __instruction->as<OpInByVal>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_get_by_id:
                    __instruction->as<OpGetById>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_get_by_id_with_this:
                    __instruction->as<OpGetByIdWithThis>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_get_by_val_with_this:
                    __instruction->as<OpGetByValWithThis>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_get_by_id_direct:
                    __instruction->as<OpGetByIdDirect>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_try_get_by_id:
                    __instruction->as<OpTryGetById>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_put_by_id:
                    __instruction->as<OpPutById>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_get_by_val:
                    __instruction->as<OpGetByVal>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_put_by_val:
                    __instruction->as<OpPutByVal>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_put_by_val_direct:
                    __instruction->as<OpPutByValDirect>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_jneq_ptr:
                    __instruction->as<OpJneqPtr>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_call:
                    __instruction->as<OpCall>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_tail_call:
                    __instruction->as<OpTailCall>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_call_eval:
                    __instruction->as<OpCallEval>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_call_varargs:
                    __instruction->as<OpCallVarargs>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_tail_call_varargs:
                    __instruction->as<OpTailCallVarargs>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_tail_call_forward_arguments:
                    __instruction->as<OpTailCallForwardArguments>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_construct:
                    __instruction->as<OpConstruct>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_construct_varargs:
                    __instruction->as<OpConstructVarargs>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_resolve_scope:
                    __instruction->as<OpResolveScope>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_get_from_scope:
                    __instruction->as<OpGetFromScope>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_put_to_scope:
                    __instruction->as<OpPutToScope>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_get_from_arguments:
                    __instruction->as<OpGetFromArguments>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_catch:
                    __instruction->as<OpCatch>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_profile_type:
                    __instruction->as<OpProfileType>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_profile_control_flow:
                    __instruction->as<OpProfileControlFlow>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_has_indexed_property:
                    __instruction->as<OpHasIndexedProperty>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_get_direct_pname:
                    __instruction->as<OpGetDirectPname>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_wide:
                    __instruction->as<OpWide>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_enter:
                    __instruction->as<OpEnter>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_get_scope:
                    __instruction->as<OpGetScope>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_create_direct_arguments:
                    __instruction->as<OpCreateDirectArguments>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_create_scoped_arguments:
                    __instruction->as<OpCreateScopedArguments>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_create_cloned_arguments:
                    __instruction->as<OpCreateClonedArguments>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_argument_count:
                    __instruction->as<OpArgumentCount>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_check_tdz:
                    __instruction->as<OpCheckTdz>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_new_array_with_spread:
                    __instruction->as<OpNewArrayWithSpread>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_spread:
                    __instruction->as<OpSpread>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_new_regexp:
                    __instruction->as<OpNewRegexp>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_mov:
                    __instruction->as<OpMov>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_eq:
                    __instruction->as<OpEq>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_neq:
                    __instruction->as<OpNeq>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_stricteq:
                    __instruction->as<OpStricteq>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_nstricteq:
                    __instruction->as<OpNstricteq>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_less:
                    __instruction->as<OpLess>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_lesseq:
                    __instruction->as<OpLesseq>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_greater:
                    __instruction->as<OpGreater>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_greatereq:
                    __instruction->as<OpGreatereq>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_below:
                    __instruction->as<OpBelow>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_beloweq:
                    __instruction->as<OpBeloweq>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_mod:
                    __instruction->as<OpMod>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_pow:
                    __instruction->as<OpPow>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_lshift:
                    __instruction->as<OpLshift>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_rshift:
                    __instruction->as<OpRshift>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_urshift:
                    __instruction->as<OpUrshift>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_eq_null:
                    __instruction->as<OpEqNull>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_neq_null:
                    __instruction->as<OpNeqNull>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_to_string:
                    __instruction->as<OpToString>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_unsigned:
                    __instruction->as<OpUnsigned>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_is_empty:
                    __instruction->as<OpIsEmpty>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_is_undefined:
                    __instruction->as<OpIsUndefined>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_is_boolean:
                    __instruction->as<OpIsBoolean>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_is_number:
                    __instruction->as<OpIsNumber>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_is_object:
                    __instruction->as<OpIsObject>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_is_object_or_null:
                    __instruction->as<OpIsObjectOrNull>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_is_function:
                    __instruction->as<OpIsFunction>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_inc:
                    __instruction->as<OpInc>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_dec:
                    __instruction->as<OpDec>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_not:
                    __instruction->as<OpNot>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_identity_with_profile:
                    __instruction->as<OpIdentityWithProfile>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_overrides_has_instance:
                    __instruction->as<OpOverridesHasInstance>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_instanceof:
                    __instruction->as<OpInstanceof>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_instanceof_custom:
                    __instruction->as<OpInstanceofCustom>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_typeof:
                    __instruction->as<OpTypeof>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_is_cell_with_type:
                    __instruction->as<OpIsCellWithType>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_in_by_id:
                    __instruction->as<OpInById>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_put_by_id_with_this:
                    __instruction->as<OpPutByIdWithThis>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_del_by_id:
                    __instruction->as<OpDelById>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_put_by_val_with_this:
                    __instruction->as<OpPutByValWithThis>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_del_by_val:
                    __instruction->as<OpDelByVal>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_put_getter_by_id:
                    __instruction->as<OpPutGetterById>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_put_setter_by_id:
                    __instruction->as<OpPutSetterById>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_put_getter_setter_by_id:
                    __instruction->as<OpPutGetterSetterById>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_put_getter_by_val:
                    __instruction->as<OpPutGetterByVal>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_put_setter_by_val:
                    __instruction->as<OpPutSetterByVal>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_define_data_property:
                    __instruction->as<OpDefineDataProperty>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_define_accessor_property:
                    __instruction->as<OpDefineAccessorProperty>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_jmp:
                    __instruction->as<OpJmp>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_jtrue:
                    __instruction->as<OpJtrue>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_jfalse:
                    __instruction->as<OpJfalse>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_jeq_null:
                    __instruction->as<OpJeqNull>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_jneq_null:
                    __instruction->as<OpJneqNull>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_jeq:
                    __instruction->as<OpJeq>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_jstricteq:
                    __instruction->as<OpJstricteq>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_jneq:
                    __instruction->as<OpJneq>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_jnstricteq:
                    __instruction->as<OpJnstricteq>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_jless:
                    __instruction->as<OpJless>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_jlesseq:
                    __instruction->as<OpJlesseq>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_jgreater:
                    __instruction->as<OpJgreater>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_jgreatereq:
                    __instruction->as<OpJgreatereq>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_jnless:
                    __instruction->as<OpJnless>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_jnlesseq:
                    __instruction->as<OpJnlesseq>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_jngreater:
                    __instruction->as<OpJngreater>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_jngreatereq:
                    __instruction->as<OpJngreatereq>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_jbelow:
                    __instruction->as<OpJbelow>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_jbeloweq:
                    __instruction->as<OpJbeloweq>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_loop_hint:
                    __instruction->as<OpLoopHint>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_switch_imm:
                    __instruction->as<OpSwitchImm>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_switch_char:
                    __instruction->as<OpSwitchChar>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_switch_string:
                    __instruction->as<OpSwitchString>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_new_func:
                    __instruction->as<OpNewFunc>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_new_func_exp:
                    __instruction->as<OpNewFuncExp>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_new_generator_func:
                    __instruction->as<OpNewGeneratorFunc>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_new_generator_func_exp:
                    __instruction->as<OpNewGeneratorFuncExp>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_new_async_func:
                    __instruction->as<OpNewAsyncFunc>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_new_async_func_exp:
                    __instruction->as<OpNewAsyncFuncExp>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_new_async_generator_func:
                    __instruction->as<OpNewAsyncGeneratorFunc>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_new_async_generator_func_exp:
                    __instruction->as<OpNewAsyncGeneratorFuncExp>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_set_function_name:
                    __instruction->as<OpSetFunctionName>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_ret:
                    __instruction->as<OpRet>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_strcat:
                    __instruction->as<OpStrcat>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_to_primitive:
                    __instruction->as<OpToPrimitive>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_put_to_arguments:
                    __instruction->as<OpPutToArguments>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_push_with_scope:
                    __instruction->as<OpPushWithScope>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_create_lexical_environment:
                    __instruction->as<OpCreateLexicalEnvironment>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_get_parent_scope:
                    __instruction->as<OpGetParentScope>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_throw:
                    __instruction->as<OpThrow>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_throw_static_error:
                    __instruction->as<OpThrowStaticError>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_debug:
                    __instruction->as<OpDebug>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_end:
                    __instruction->as<OpEnd>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_get_enumerable_length:
                    __instruction->as<OpGetEnumerableLength>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_has_structure_property:
                    __instruction->as<OpHasStructureProperty>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_has_generic_property:
                    __instruction->as<OpHasGenericProperty>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_get_property_enumerator:
                    __instruction->as<OpGetPropertyEnumerator>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_enumerator_structure_pname:
                    __instruction->as<OpEnumeratorStructurePname>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_enumerator_generic_pname:
                    __instruction->as<OpEnumeratorGenericPname>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_to_index_string:
                    __instruction->as<OpToIndexString>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_unreachable:
                    __instruction->as<OpUnreachable>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_create_rest:
                    __instruction->as<OpCreateRest>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_get_rest_length:
                    __instruction->as<OpGetRestLength>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_yield:
                    __instruction->as<OpYield>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_check_traps:
                    __instruction->as<OpCheckTraps>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_log_shadow_chicken_prologue:
                    __instruction->as<OpLogShadowChickenPrologue>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_log_shadow_chicken_tail:
                    __instruction->as<OpLogShadowChickenTail>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_resolve_scope_for_hoisting_func_decl_in_eval:
                    __instruction->as<OpResolveScopeForHoistingFuncDeclInEval>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_nop:
                    __instruction->as<OpNop>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_super_sampler_begin:
                    __instruction->as<OpSuperSamplerBegin>().dump(__dumper, __location, __instruction->isWide());
                    break;

                case op_super_sampler_end:
                    __instruction->as<OpSuperSamplerEnd>().dump(__dumper, __location, __instruction->isWide());
                    break;

            default:
                ASSERT_NOT_REACHED();
            }
        }


} // namespace JSC
